/**
 * @fileoverview gRPC-Web generated client stub for cache_client
 * @enhanceable
 * @public
 */
import * as grpcWeb from 'grpc-web';
import * as cacheclient_pb from './cacheclient_pb';
export declare class ScsClient {
    client_: grpcWeb.AbstractClientBase;
    hostname_: string;
    credentials_: null | {
        [index: string]: string;
    };
    options_: null | {
        [index: string]: any;
    };
    constructor(hostname: string, credentials?: null | {
        [index: string]: string;
    }, options?: null | {
        [index: string]: any;
    });
    methodDescriptorGet: grpcWeb.MethodDescriptor<cacheclient_pb._GetRequest, cacheclient_pb._GetResponse>;
    get(request: cacheclient_pb._GetRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._GetResponse>;
    get(request: cacheclient_pb._GetRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._GetResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._GetResponse>;
    methodDescriptorGetWithHash: grpcWeb.MethodDescriptor<cacheclient_pb._GetWithHashRequest, cacheclient_pb._GetWithHashResponse>;
    getWithHash(request: cacheclient_pb._GetWithHashRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._GetWithHashResponse>;
    getWithHash(request: cacheclient_pb._GetWithHashRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._GetWithHashResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._GetWithHashResponse>;
    methodDescriptorGetBatch: grpcWeb.MethodDescriptor<cacheclient_pb._GetBatchRequest, cacheclient_pb._GetResponse>;
    getBatch(request: cacheclient_pb._GetBatchRequest, metadata?: grpcWeb.Metadata): grpcWeb.ClientReadableStream<cacheclient_pb._GetResponse>;
    methodDescriptorSet: grpcWeb.MethodDescriptor<cacheclient_pb._SetRequest, cacheclient_pb._SetResponse>;
    set(request: cacheclient_pb._SetRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetResponse>;
    set(request: cacheclient_pb._SetRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetResponse>;
    methodDescriptorSetBatch: grpcWeb.MethodDescriptor<cacheclient_pb._SetBatchRequest, cacheclient_pb._SetResponse>;
    setBatch(request: cacheclient_pb._SetBatchRequest, metadata?: grpcWeb.Metadata): grpcWeb.ClientReadableStream<cacheclient_pb._SetResponse>;
    methodDescriptorSetIf: grpcWeb.MethodDescriptor<cacheclient_pb._SetIfRequest, cacheclient_pb._SetIfResponse>;
    setIf(request: cacheclient_pb._SetIfRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetIfResponse>;
    setIf(request: cacheclient_pb._SetIfRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetIfResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetIfResponse>;
    methodDescriptorSetIfHash: grpcWeb.MethodDescriptor<cacheclient_pb._SetIfHashRequest, cacheclient_pb._SetIfHashResponse>;
    setIfHash(request: cacheclient_pb._SetIfHashRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetIfHashResponse>;
    setIfHash(request: cacheclient_pb._SetIfHashRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetIfHashResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetIfHashResponse>;
    methodDescriptorSetIfNotExists: grpcWeb.MethodDescriptor<cacheclient_pb._SetIfNotExistsRequest, cacheclient_pb._SetIfNotExistsResponse>;
    setIfNotExists(request: cacheclient_pb._SetIfNotExistsRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetIfNotExistsResponse>;
    setIfNotExists(request: cacheclient_pb._SetIfNotExistsRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetIfNotExistsResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetIfNotExistsResponse>;
    methodDescriptorDelete: grpcWeb.MethodDescriptor<cacheclient_pb._DeleteRequest, cacheclient_pb._DeleteResponse>;
    delete(request: cacheclient_pb._DeleteRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DeleteResponse>;
    delete(request: cacheclient_pb._DeleteRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DeleteResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DeleteResponse>;
    methodDescriptorKeysExist: grpcWeb.MethodDescriptor<cacheclient_pb._KeysExistRequest, cacheclient_pb._KeysExistResponse>;
    keysExist(request: cacheclient_pb._KeysExistRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._KeysExistResponse>;
    keysExist(request: cacheclient_pb._KeysExistRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._KeysExistResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._KeysExistResponse>;
    methodDescriptorIncrement: grpcWeb.MethodDescriptor<cacheclient_pb._IncrementRequest, cacheclient_pb._IncrementResponse>;
    increment(request: cacheclient_pb._IncrementRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._IncrementResponse>;
    increment(request: cacheclient_pb._IncrementRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._IncrementResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._IncrementResponse>;
    methodDescriptorUpdateTtl: grpcWeb.MethodDescriptor<cacheclient_pb._UpdateTtlRequest, cacheclient_pb._UpdateTtlResponse>;
    updateTtl(request: cacheclient_pb._UpdateTtlRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._UpdateTtlResponse>;
    updateTtl(request: cacheclient_pb._UpdateTtlRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._UpdateTtlResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._UpdateTtlResponse>;
    methodDescriptorItemGetTtl: grpcWeb.MethodDescriptor<cacheclient_pb._ItemGetTtlRequest, cacheclient_pb._ItemGetTtlResponse>;
    itemGetTtl(request: cacheclient_pb._ItemGetTtlRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ItemGetTtlResponse>;
    itemGetTtl(request: cacheclient_pb._ItemGetTtlRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ItemGetTtlResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ItemGetTtlResponse>;
    methodDescriptorItemGetType: grpcWeb.MethodDescriptor<cacheclient_pb._ItemGetTypeRequest, cacheclient_pb._ItemGetTypeResponse>;
    itemGetType(request: cacheclient_pb._ItemGetTypeRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ItemGetTypeResponse>;
    itemGetType(request: cacheclient_pb._ItemGetTypeRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ItemGetTypeResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ItemGetTypeResponse>;
    methodDescriptorDictionaryGet: grpcWeb.MethodDescriptor<cacheclient_pb._DictionaryGetRequest, cacheclient_pb._DictionaryGetResponse>;
    dictionaryGet(request: cacheclient_pb._DictionaryGetRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DictionaryGetResponse>;
    dictionaryGet(request: cacheclient_pb._DictionaryGetRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DictionaryGetResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DictionaryGetResponse>;
    methodDescriptorDictionaryFetch: grpcWeb.MethodDescriptor<cacheclient_pb._DictionaryFetchRequest, cacheclient_pb._DictionaryFetchResponse>;
    dictionaryFetch(request: cacheclient_pb._DictionaryFetchRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DictionaryFetchResponse>;
    dictionaryFetch(request: cacheclient_pb._DictionaryFetchRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DictionaryFetchResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DictionaryFetchResponse>;
    methodDescriptorDictionarySet: grpcWeb.MethodDescriptor<cacheclient_pb._DictionarySetRequest, cacheclient_pb._DictionarySetResponse>;
    dictionarySet(request: cacheclient_pb._DictionarySetRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DictionarySetResponse>;
    dictionarySet(request: cacheclient_pb._DictionarySetRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DictionarySetResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DictionarySetResponse>;
    methodDescriptorDictionaryIncrement: grpcWeb.MethodDescriptor<cacheclient_pb._DictionaryIncrementRequest, cacheclient_pb._DictionaryIncrementResponse>;
    dictionaryIncrement(request: cacheclient_pb._DictionaryIncrementRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DictionaryIncrementResponse>;
    dictionaryIncrement(request: cacheclient_pb._DictionaryIncrementRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DictionaryIncrementResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DictionaryIncrementResponse>;
    methodDescriptorDictionaryDelete: grpcWeb.MethodDescriptor<cacheclient_pb._DictionaryDeleteRequest, cacheclient_pb._DictionaryDeleteResponse>;
    dictionaryDelete(request: cacheclient_pb._DictionaryDeleteRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DictionaryDeleteResponse>;
    dictionaryDelete(request: cacheclient_pb._DictionaryDeleteRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DictionaryDeleteResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DictionaryDeleteResponse>;
    methodDescriptorDictionaryLength: grpcWeb.MethodDescriptor<cacheclient_pb._DictionaryLengthRequest, cacheclient_pb._DictionaryLengthResponse>;
    dictionaryLength(request: cacheclient_pb._DictionaryLengthRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._DictionaryLengthResponse>;
    dictionaryLength(request: cacheclient_pb._DictionaryLengthRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._DictionaryLengthResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._DictionaryLengthResponse>;
    methodDescriptorSetFetch: grpcWeb.MethodDescriptor<cacheclient_pb._SetFetchRequest, cacheclient_pb._SetFetchResponse>;
    setFetch(request: cacheclient_pb._SetFetchRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetFetchResponse>;
    setFetch(request: cacheclient_pb._SetFetchRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetFetchResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetFetchResponse>;
    methodDescriptorSetSample: grpcWeb.MethodDescriptor<cacheclient_pb._SetSampleRequest, cacheclient_pb._SetSampleResponse>;
    setSample(request: cacheclient_pb._SetSampleRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetSampleResponse>;
    setSample(request: cacheclient_pb._SetSampleRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetSampleResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetSampleResponse>;
    methodDescriptorSetUnion: grpcWeb.MethodDescriptor<cacheclient_pb._SetUnionRequest, cacheclient_pb._SetUnionResponse>;
    setUnion(request: cacheclient_pb._SetUnionRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetUnionResponse>;
    setUnion(request: cacheclient_pb._SetUnionRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetUnionResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetUnionResponse>;
    methodDescriptorSetDifference: grpcWeb.MethodDescriptor<cacheclient_pb._SetDifferenceRequest, cacheclient_pb._SetDifferenceResponse>;
    setDifference(request: cacheclient_pb._SetDifferenceRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetDifferenceResponse>;
    setDifference(request: cacheclient_pb._SetDifferenceRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetDifferenceResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetDifferenceResponse>;
    methodDescriptorSetContains: grpcWeb.MethodDescriptor<cacheclient_pb._SetContainsRequest, cacheclient_pb._SetContainsResponse>;
    setContains(request: cacheclient_pb._SetContainsRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetContainsResponse>;
    setContains(request: cacheclient_pb._SetContainsRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetContainsResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetContainsResponse>;
    methodDescriptorSetLength: grpcWeb.MethodDescriptor<cacheclient_pb._SetLengthRequest, cacheclient_pb._SetLengthResponse>;
    setLength(request: cacheclient_pb._SetLengthRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetLengthResponse>;
    setLength(request: cacheclient_pb._SetLengthRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetLengthResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetLengthResponse>;
    methodDescriptorSetPop: grpcWeb.MethodDescriptor<cacheclient_pb._SetPopRequest, cacheclient_pb._SetPopResponse>;
    setPop(request: cacheclient_pb._SetPopRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SetPopResponse>;
    setPop(request: cacheclient_pb._SetPopRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SetPopResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SetPopResponse>;
    methodDescriptorListPushFront: grpcWeb.MethodDescriptor<cacheclient_pb._ListPushFrontRequest, cacheclient_pb._ListPushFrontResponse>;
    listPushFront(request: cacheclient_pb._ListPushFrontRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListPushFrontResponse>;
    listPushFront(request: cacheclient_pb._ListPushFrontRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListPushFrontResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListPushFrontResponse>;
    methodDescriptorListPushBack: grpcWeb.MethodDescriptor<cacheclient_pb._ListPushBackRequest, cacheclient_pb._ListPushBackResponse>;
    listPushBack(request: cacheclient_pb._ListPushBackRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListPushBackResponse>;
    listPushBack(request: cacheclient_pb._ListPushBackRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListPushBackResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListPushBackResponse>;
    methodDescriptorListPopFront: grpcWeb.MethodDescriptor<cacheclient_pb._ListPopFrontRequest, cacheclient_pb._ListPopFrontResponse>;
    listPopFront(request: cacheclient_pb._ListPopFrontRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListPopFrontResponse>;
    listPopFront(request: cacheclient_pb._ListPopFrontRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListPopFrontResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListPopFrontResponse>;
    methodDescriptorListPopBack: grpcWeb.MethodDescriptor<cacheclient_pb._ListPopBackRequest, cacheclient_pb._ListPopBackResponse>;
    listPopBack(request: cacheclient_pb._ListPopBackRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListPopBackResponse>;
    listPopBack(request: cacheclient_pb._ListPopBackRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListPopBackResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListPopBackResponse>;
    methodDescriptorListErase: grpcWeb.MethodDescriptor<cacheclient_pb._ListEraseRequest, cacheclient_pb._ListEraseResponse>;
    listErase(request: cacheclient_pb._ListEraseRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListEraseResponse>;
    listErase(request: cacheclient_pb._ListEraseRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListEraseResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListEraseResponse>;
    methodDescriptorListRemove: grpcWeb.MethodDescriptor<cacheclient_pb._ListRemoveRequest, cacheclient_pb._ListRemoveResponse>;
    listRemove(request: cacheclient_pb._ListRemoveRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListRemoveResponse>;
    listRemove(request: cacheclient_pb._ListRemoveRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListRemoveResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListRemoveResponse>;
    methodDescriptorListFetch: grpcWeb.MethodDescriptor<cacheclient_pb._ListFetchRequest, cacheclient_pb._ListFetchResponse>;
    listFetch(request: cacheclient_pb._ListFetchRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListFetchResponse>;
    listFetch(request: cacheclient_pb._ListFetchRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListFetchResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListFetchResponse>;
    methodDescriptorListLength: grpcWeb.MethodDescriptor<cacheclient_pb._ListLengthRequest, cacheclient_pb._ListLengthResponse>;
    listLength(request: cacheclient_pb._ListLengthRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListLengthResponse>;
    listLength(request: cacheclient_pb._ListLengthRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListLengthResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListLengthResponse>;
    methodDescriptorListConcatenateFront: grpcWeb.MethodDescriptor<cacheclient_pb._ListConcatenateFrontRequest, cacheclient_pb._ListConcatenateFrontResponse>;
    listConcatenateFront(request: cacheclient_pb._ListConcatenateFrontRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListConcatenateFrontResponse>;
    listConcatenateFront(request: cacheclient_pb._ListConcatenateFrontRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListConcatenateFrontResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListConcatenateFrontResponse>;
    methodDescriptorListConcatenateBack: grpcWeb.MethodDescriptor<cacheclient_pb._ListConcatenateBackRequest, cacheclient_pb._ListConcatenateBackResponse>;
    listConcatenateBack(request: cacheclient_pb._ListConcatenateBackRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListConcatenateBackResponse>;
    listConcatenateBack(request: cacheclient_pb._ListConcatenateBackRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListConcatenateBackResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListConcatenateBackResponse>;
    methodDescriptorListRetain: grpcWeb.MethodDescriptor<cacheclient_pb._ListRetainRequest, cacheclient_pb._ListRetainResponse>;
    listRetain(request: cacheclient_pb._ListRetainRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._ListRetainResponse>;
    listRetain(request: cacheclient_pb._ListRetainRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._ListRetainResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._ListRetainResponse>;
    methodDescriptorSortedSetPut: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetPutRequest, cacheclient_pb._SortedSetPutResponse>;
    sortedSetPut(request: cacheclient_pb._SortedSetPutRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetPutResponse>;
    sortedSetPut(request: cacheclient_pb._SortedSetPutRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetPutResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetPutResponse>;
    methodDescriptorSortedSetFetch: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetFetchRequest, cacheclient_pb._SortedSetFetchResponse>;
    sortedSetFetch(request: cacheclient_pb._SortedSetFetchRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetFetchResponse>;
    sortedSetFetch(request: cacheclient_pb._SortedSetFetchRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetFetchResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetFetchResponse>;
    methodDescriptorSortedSetGetScore: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetGetScoreRequest, cacheclient_pb._SortedSetGetScoreResponse>;
    sortedSetGetScore(request: cacheclient_pb._SortedSetGetScoreRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetGetScoreResponse>;
    sortedSetGetScore(request: cacheclient_pb._SortedSetGetScoreRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetGetScoreResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetGetScoreResponse>;
    methodDescriptorSortedSetRemove: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetRemoveRequest, cacheclient_pb._SortedSetRemoveResponse>;
    sortedSetRemove(request: cacheclient_pb._SortedSetRemoveRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetRemoveResponse>;
    sortedSetRemove(request: cacheclient_pb._SortedSetRemoveRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetRemoveResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetRemoveResponse>;
    methodDescriptorSortedSetIncrement: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetIncrementRequest, cacheclient_pb._SortedSetIncrementResponse>;
    sortedSetIncrement(request: cacheclient_pb._SortedSetIncrementRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetIncrementResponse>;
    sortedSetIncrement(request: cacheclient_pb._SortedSetIncrementRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetIncrementResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetIncrementResponse>;
    methodDescriptorSortedSetGetRank: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetGetRankRequest, cacheclient_pb._SortedSetGetRankResponse>;
    sortedSetGetRank(request: cacheclient_pb._SortedSetGetRankRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetGetRankResponse>;
    sortedSetGetRank(request: cacheclient_pb._SortedSetGetRankRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetGetRankResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetGetRankResponse>;
    methodDescriptorSortedSetLength: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetLengthRequest, cacheclient_pb._SortedSetLengthResponse>;
    sortedSetLength(request: cacheclient_pb._SortedSetLengthRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetLengthResponse>;
    sortedSetLength(request: cacheclient_pb._SortedSetLengthRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetLengthResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetLengthResponse>;
    methodDescriptorSortedSetLengthByScore: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetLengthByScoreRequest, cacheclient_pb._SortedSetLengthByScoreResponse>;
    sortedSetLengthByScore(request: cacheclient_pb._SortedSetLengthByScoreRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetLengthByScoreResponse>;
    sortedSetLengthByScore(request: cacheclient_pb._SortedSetLengthByScoreRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetLengthByScoreResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetLengthByScoreResponse>;
    methodDescriptorSortedSetUnionStore: grpcWeb.MethodDescriptor<cacheclient_pb._SortedSetUnionStoreRequest, cacheclient_pb._SortedSetUnionStoreResponse>;
    sortedSetUnionStore(request: cacheclient_pb._SortedSetUnionStoreRequest, metadata: grpcWeb.Metadata | null): Promise<cacheclient_pb._SortedSetUnionStoreResponse>;
    sortedSetUnionStore(request: cacheclient_pb._SortedSetUnionStoreRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: cacheclient_pb._SortedSetUnionStoreResponse) => void): grpcWeb.ClientReadableStream<cacheclient_pb._SortedSetUnionStoreResponse>;
}
