/**
 * @fileoverview gRPC-Web generated client stub for control_client
 * @enhanceable
 * @public
 */
import * as grpcWeb from 'grpc-web';
import * as controlclient_pb from './controlclient_pb';
export declare class ScsControlClient {
    client_: grpcWeb.AbstractClientBase;
    hostname_: string;
    credentials_: null | {
        [index: string]: string;
    };
    options_: null | {
        [index: string]: any;
    };
    constructor(hostname: string, credentials?: null | {
        [index: string]: string;
    }, options?: null | {
        [index: string]: any;
    });
    methodDescriptorCreateCache: grpcWeb.MethodDescriptor<controlclient_pb._CreateCacheRequest, controlclient_pb._CreateCacheResponse>;
    createCache(request: controlclient_pb._CreateCacheRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._CreateCacheResponse>;
    createCache(request: controlclient_pb._CreateCacheRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._CreateCacheResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._CreateCacheResponse>;
    methodDescriptorDeleteCache: grpcWeb.MethodDescriptor<controlclient_pb._DeleteCacheRequest, controlclient_pb._DeleteCacheResponse>;
    deleteCache(request: controlclient_pb._DeleteCacheRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._DeleteCacheResponse>;
    deleteCache(request: controlclient_pb._DeleteCacheRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._DeleteCacheResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._DeleteCacheResponse>;
    methodDescriptorListCaches: grpcWeb.MethodDescriptor<controlclient_pb._ListCachesRequest, controlclient_pb._ListCachesResponse>;
    listCaches(request: controlclient_pb._ListCachesRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._ListCachesResponse>;
    listCaches(request: controlclient_pb._ListCachesRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._ListCachesResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._ListCachesResponse>;
    methodDescriptorFlushCache: grpcWeb.MethodDescriptor<controlclient_pb._FlushCacheRequest, controlclient_pb._FlushCacheResponse>;
    flushCache(request: controlclient_pb._FlushCacheRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._FlushCacheResponse>;
    flushCache(request: controlclient_pb._FlushCacheRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._FlushCacheResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._FlushCacheResponse>;
    methodDescriptorCreateSigningKey: grpcWeb.MethodDescriptor<controlclient_pb._CreateSigningKeyRequest, controlclient_pb._CreateSigningKeyResponse>;
    createSigningKey(request: controlclient_pb._CreateSigningKeyRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._CreateSigningKeyResponse>;
    createSigningKey(request: controlclient_pb._CreateSigningKeyRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._CreateSigningKeyResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._CreateSigningKeyResponse>;
    methodDescriptorRevokeSigningKey: grpcWeb.MethodDescriptor<controlclient_pb._RevokeSigningKeyRequest, controlclient_pb._RevokeSigningKeyResponse>;
    revokeSigningKey(request: controlclient_pb._RevokeSigningKeyRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._RevokeSigningKeyResponse>;
    revokeSigningKey(request: controlclient_pb._RevokeSigningKeyRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._RevokeSigningKeyResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._RevokeSigningKeyResponse>;
    methodDescriptorListSigningKeys: grpcWeb.MethodDescriptor<controlclient_pb._ListSigningKeysRequest, controlclient_pb._ListSigningKeysResponse>;
    listSigningKeys(request: controlclient_pb._ListSigningKeysRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._ListSigningKeysResponse>;
    listSigningKeys(request: controlclient_pb._ListSigningKeysRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._ListSigningKeysResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._ListSigningKeysResponse>;
    methodDescriptorCreateIndex: grpcWeb.MethodDescriptor<controlclient_pb._CreateIndexRequest, controlclient_pb._CreateIndexResponse>;
    createIndex(request: controlclient_pb._CreateIndexRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._CreateIndexResponse>;
    createIndex(request: controlclient_pb._CreateIndexRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._CreateIndexResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._CreateIndexResponse>;
    methodDescriptorDeleteIndex: grpcWeb.MethodDescriptor<controlclient_pb._DeleteIndexRequest, controlclient_pb._DeleteIndexResponse>;
    deleteIndex(request: controlclient_pb._DeleteIndexRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._DeleteIndexResponse>;
    deleteIndex(request: controlclient_pb._DeleteIndexRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._DeleteIndexResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._DeleteIndexResponse>;
    methodDescriptorListIndexes: grpcWeb.MethodDescriptor<controlclient_pb._ListIndexesRequest, controlclient_pb._ListIndexesResponse>;
    listIndexes(request: controlclient_pb._ListIndexesRequest, metadata: grpcWeb.Metadata | null): Promise<controlclient_pb._ListIndexesResponse>;
    listIndexes(request: controlclient_pb._ListIndexesRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: controlclient_pb._ListIndexesResponse) => void): grpcWeb.ClientReadableStream<controlclient_pb._ListIndexesResponse>;
}
