/**
 * @fileoverview gRPC-Web generated client stub for global_admin
 * @enhanceable
 * @public
 */
import * as grpcWeb from 'grpc-web';
import * as global_admin_pb from './global_admin_pb';
export declare class GlobalAdminClient {
    client_: grpcWeb.AbstractClientBase;
    hostname_: string;
    credentials_: null | {
        [index: string]: string;
    };
    options_: null | {
        [index: string]: any;
    };
    constructor(hostname: string, credentials?: null | {
        [index: string]: string;
    }, options?: null | {
        [index: string]: any;
    });
    methodDescriptorGetAccounts: grpcWeb.MethodDescriptor<global_admin_pb._GetAccountsRequest, global_admin_pb._GetAccountsResponse>;
    getAccounts(request: global_admin_pb._GetAccountsRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._GetAccountsResponse>;
    getAccounts(request: global_admin_pb._GetAccountsRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._GetAccountsResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._GetAccountsResponse>;
    methodDescriptorGetInvitationsForUser: grpcWeb.MethodDescriptor<global_admin_pb._GetInvitationsForUserRequest, global_admin_pb._GetInvitationsForUserResponse>;
    getInvitationsForUser(request: global_admin_pb._GetInvitationsForUserRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._GetInvitationsForUserResponse>;
    getInvitationsForUser(request: global_admin_pb._GetInvitationsForUserRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._GetInvitationsForUserResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._GetInvitationsForUserResponse>;
    methodDescriptorGetAccountSessionToken: grpcWeb.MethodDescriptor<global_admin_pb._GetAccountSessionTokenRequest, global_admin_pb._GetAccountSessionTokenResponse>;
    getAccountSessionToken(request: global_admin_pb._GetAccountSessionTokenRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._GetAccountSessionTokenResponse>;
    getAccountSessionToken(request: global_admin_pb._GetAccountSessionTokenRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._GetAccountSessionTokenResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._GetAccountSessionTokenResponse>;
    methodDescriptorRemoveMember: grpcWeb.MethodDescriptor<global_admin_pb._RemoveMemberRequest, global_admin_pb._RemoveMemberResponse>;
    removeMember(request: global_admin_pb._RemoveMemberRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._RemoveMemberResponse>;
    removeMember(request: global_admin_pb._RemoveMemberRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._RemoveMemberResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._RemoveMemberResponse>;
    methodDescriptorListMembers: grpcWeb.MethodDescriptor<global_admin_pb._ListMembersRequest, global_admin_pb._ListMembersResponse>;
    listMembers(request: global_admin_pb._ListMembersRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._ListMembersResponse>;
    listMembers(request: global_admin_pb._ListMembersRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._ListMembersResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._ListMembersResponse>;
    methodDescriptorGetEndpointsForAccount: grpcWeb.MethodDescriptor<global_admin_pb._GetEndpointsForAccountRequest, global_admin_pb._GetEndpointsForAccountResponse>;
    getEndpointsForAccount(request: global_admin_pb._GetEndpointsForAccountRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._GetEndpointsForAccountResponse>;
    getEndpointsForAccount(request: global_admin_pb._GetEndpointsForAccountRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._GetEndpointsForAccountResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._GetEndpointsForAccountResponse>;
    methodDescriptorSetAccountName: grpcWeb.MethodDescriptor<global_admin_pb._SetAccountNameRequest, global_admin_pb._SetAccountNameResponse>;
    setAccountName(request: global_admin_pb._SetAccountNameRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._SetAccountNameResponse>;
    setAccountName(request: global_admin_pb._SetAccountNameRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._SetAccountNameResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._SetAccountNameResponse>;
    methodDescriptorInviteMember: grpcWeb.MethodDescriptor<global_admin_pb._InviteMemberRequest, global_admin_pb._InviteMemberResponse>;
    inviteMember(request: global_admin_pb._InviteMemberRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._InviteMemberResponse>;
    inviteMember(request: global_admin_pb._InviteMemberRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._InviteMemberResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._InviteMemberResponse>;
    methodDescriptorAcceptInvitation: grpcWeb.MethodDescriptor<global_admin_pb._AcceptInvitationRequest, global_admin_pb._AcceptInvitationResponse>;
    acceptInvitation(request: global_admin_pb._AcceptInvitationRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._AcceptInvitationResponse>;
    acceptInvitation(request: global_admin_pb._AcceptInvitationRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._AcceptInvitationResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._AcceptInvitationResponse>;
    methodDescriptorRejectInvitation: grpcWeb.MethodDescriptor<global_admin_pb._RejectInvitationRequest, global_admin_pb._RejectInvitationResponse>;
    rejectInvitation(request: global_admin_pb._RejectInvitationRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._RejectInvitationResponse>;
    rejectInvitation(request: global_admin_pb._RejectInvitationRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._RejectInvitationResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._RejectInvitationResponse>;
    methodDescriptorListInvitationsForAccount: grpcWeb.MethodDescriptor<global_admin_pb._ListInvitationsForAccountRequest, global_admin_pb._ListInvitationsForAccountResponse>;
    listInvitationsForAccount(request: global_admin_pb._ListInvitationsForAccountRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._ListInvitationsForAccountResponse>;
    listInvitationsForAccount(request: global_admin_pb._ListInvitationsForAccountRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._ListInvitationsForAccountResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._ListInvitationsForAccountResponse>;
    methodDescriptorRevokeInvitation: grpcWeb.MethodDescriptor<global_admin_pb._RevokeInvitationRequest, global_admin_pb._RevokeInvitationResponse>;
    revokeInvitation(request: global_admin_pb._RevokeInvitationRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._RevokeInvitationResponse>;
    revokeInvitation(request: global_admin_pb._RevokeInvitationRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._RevokeInvitationResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._RevokeInvitationResponse>;
    methodDescriptorListRolesForAccount: grpcWeb.MethodDescriptor<global_admin_pb._ListRolesForAccountRequest, global_admin_pb._ListRolesForAccountResponse>;
    listRolesForAccount(request: global_admin_pb._ListRolesForAccountRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._ListRolesForAccountResponse>;
    listRolesForAccount(request: global_admin_pb._ListRolesForAccountRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._ListRolesForAccountResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._ListRolesForAccountResponse>;
    methodDescriptorSetMemberRole: grpcWeb.MethodDescriptor<global_admin_pb._SetMemberRoleRequest, global_admin_pb._SetMemberRoleResponse>;
    setMemberRole(request: global_admin_pb._SetMemberRoleRequest, metadata: grpcWeb.Metadata | null): Promise<global_admin_pb._SetMemberRoleResponse>;
    setMemberRole(request: global_admin_pb._SetMemberRoleRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: global_admin_pb._SetMemberRoleResponse) => void): grpcWeb.ClientReadableStream<global_admin_pb._SetMemberRoleResponse>;
}
