/**
 * @fileoverview gRPC-Web generated client stub for leaderboard
 * @enhanceable
 * @public
 */
import * as grpcWeb from 'grpc-web';
import * as common_pb from './common_pb';
import * as leaderboard_pb from './leaderboard_pb';
export declare class LeaderboardClient {
    client_: grpcWeb.AbstractClientBase;
    hostname_: string;
    credentials_: null | {
        [index: string]: string;
    };
    options_: null | {
        [index: string]: any;
    };
    constructor(hostname: string, credentials?: null | {
        [index: string]: string;
    }, options?: null | {
        [index: string]: any;
    });
    methodDescriptorDeleteLeaderboard: grpcWeb.MethodDescriptor<leaderboard_pb._DeleteLeaderboardRequest, common_pb._Empty>;
    deleteLeaderboard(request: leaderboard_pb._DeleteLeaderboardRequest, metadata: grpcWeb.Metadata | null): Promise<common_pb._Empty>;
    deleteLeaderboard(request: leaderboard_pb._DeleteLeaderboardRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: common_pb._Empty) => void): grpcWeb.ClientReadableStream<common_pb._Empty>;
    methodDescriptorUpsertElements: grpcWeb.MethodDescriptor<leaderboard_pb._UpsertElementsRequest, common_pb._Empty>;
    upsertElements(request: leaderboard_pb._UpsertElementsRequest, metadata: grpcWeb.Metadata | null): Promise<common_pb._Empty>;
    upsertElements(request: leaderboard_pb._UpsertElementsRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: common_pb._Empty) => void): grpcWeb.ClientReadableStream<common_pb._Empty>;
    methodDescriptorRemoveElements: grpcWeb.MethodDescriptor<leaderboard_pb._RemoveElementsRequest, common_pb._Empty>;
    removeElements(request: leaderboard_pb._RemoveElementsRequest, metadata: grpcWeb.Metadata | null): Promise<common_pb._Empty>;
    removeElements(request: leaderboard_pb._RemoveElementsRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: common_pb._Empty) => void): grpcWeb.ClientReadableStream<common_pb._Empty>;
    methodDescriptorGetLeaderboardLength: grpcWeb.MethodDescriptor<leaderboard_pb._GetLeaderboardLengthRequest, leaderboard_pb._GetLeaderboardLengthResponse>;
    getLeaderboardLength(request: leaderboard_pb._GetLeaderboardLengthRequest, metadata: grpcWeb.Metadata | null): Promise<leaderboard_pb._GetLeaderboardLengthResponse>;
    getLeaderboardLength(request: leaderboard_pb._GetLeaderboardLengthRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: leaderboard_pb._GetLeaderboardLengthResponse) => void): grpcWeb.ClientReadableStream<leaderboard_pb._GetLeaderboardLengthResponse>;
    methodDescriptorGetByRank: grpcWeb.MethodDescriptor<leaderboard_pb._GetByRankRequest, leaderboard_pb._GetByRankResponse>;
    getByRank(request: leaderboard_pb._GetByRankRequest, metadata: grpcWeb.Metadata | null): Promise<leaderboard_pb._GetByRankResponse>;
    getByRank(request: leaderboard_pb._GetByRankRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: leaderboard_pb._GetByRankResponse) => void): grpcWeb.ClientReadableStream<leaderboard_pb._GetByRankResponse>;
    methodDescriptorGetRank: grpcWeb.MethodDescriptor<leaderboard_pb._GetRankRequest, leaderboard_pb._GetRankResponse>;
    getRank(request: leaderboard_pb._GetRankRequest, metadata: grpcWeb.Metadata | null): Promise<leaderboard_pb._GetRankResponse>;
    getRank(request: leaderboard_pb._GetRankRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: leaderboard_pb._GetRankResponse) => void): grpcWeb.ClientReadableStream<leaderboard_pb._GetRankResponse>;
    methodDescriptorGetByScore: grpcWeb.MethodDescriptor<leaderboard_pb._GetByScoreRequest, leaderboard_pb._GetByScoreResponse>;
    getByScore(request: leaderboard_pb._GetByScoreRequest, metadata: grpcWeb.Metadata | null): Promise<leaderboard_pb._GetByScoreResponse>;
    getByScore(request: leaderboard_pb._GetByScoreRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: leaderboard_pb._GetByScoreResponse) => void): grpcWeb.ClientReadableStream<leaderboard_pb._GetByScoreResponse>;
    methodDescriptorGetCompetitionRank: grpcWeb.MethodDescriptor<leaderboard_pb._GetCompetitionRankRequest, leaderboard_pb._GetCompetitionRankResponse>;
    getCompetitionRank(request: leaderboard_pb._GetCompetitionRankRequest, metadata: grpcWeb.Metadata | null): Promise<leaderboard_pb._GetCompetitionRankResponse>;
    getCompetitionRank(request: leaderboard_pb._GetCompetitionRankRequest, metadata: grpcWeb.Metadata | null, callback: (err: grpcWeb.RpcError, response: leaderboard_pb._GetCompetitionRankResponse) => void): grpcWeb.ClientReadableStream<leaderboard_pb._GetCompetitionRankResponse>;
}
