import * as jspb from 'google-protobuf'

import * as permissionmessages_pb from './permissionmessages_pb';


export class _LoginRequest extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _LoginRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _LoginRequest): _LoginRequest.AsObject;
  static serializeBinaryToWriter(message: _LoginRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _LoginRequest;
  static deserializeBinaryFromReader(message: _LoginRequest, reader: jspb.BinaryReader): _LoginRequest;
}

export namespace _LoginRequest {
  export type AsObject = {
  }
}

export class _LoginResponse extends jspb.Message {
  getDirectBrowser(): _LoginResponse.DirectBrowser | undefined;
  setDirectBrowser(value?: _LoginResponse.DirectBrowser): _LoginResponse;
  hasDirectBrowser(): boolean;
  clearDirectBrowser(): _LoginResponse;

  getLoggedIn(): _LoginResponse.LoggedIn | undefined;
  setLoggedIn(value?: _LoginResponse.LoggedIn): _LoginResponse;
  hasLoggedIn(): boolean;
  clearLoggedIn(): _LoginResponse;

  getMessage(): _LoginResponse.Message | undefined;
  setMessage(value?: _LoginResponse.Message): _LoginResponse;
  hasMessage(): boolean;
  clearMessage(): _LoginResponse;

  getError(): _LoginResponse.Error | undefined;
  setError(value?: _LoginResponse.Error): _LoginResponse;
  hasError(): boolean;
  clearError(): _LoginResponse;

  getStateCase(): _LoginResponse.StateCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _LoginResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _LoginResponse): _LoginResponse.AsObject;
  static serializeBinaryToWriter(message: _LoginResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _LoginResponse;
  static deserializeBinaryFromReader(message: _LoginResponse, reader: jspb.BinaryReader): _LoginResponse;
}

export namespace _LoginResponse {
  export type AsObject = {
    directBrowser?: _LoginResponse.DirectBrowser.AsObject,
    loggedIn?: _LoginResponse.LoggedIn.AsObject,
    message?: _LoginResponse.Message.AsObject,
    error?: _LoginResponse.Error.AsObject,
  }

  export class LoggedIn extends jspb.Message {
    getSessionToken(): string;
    setSessionToken(value: string): LoggedIn;

    getValidForSeconds(): number;
    setValidForSeconds(value: number): LoggedIn;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): LoggedIn.AsObject;
    static toObject(includeInstance: boolean, msg: LoggedIn): LoggedIn.AsObject;
    static serializeBinaryToWriter(message: LoggedIn, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): LoggedIn;
    static deserializeBinaryFromReader(message: LoggedIn, reader: jspb.BinaryReader): LoggedIn;
  }

  export namespace LoggedIn {
    export type AsObject = {
      sessionToken: string,
      validForSeconds: number,
    }
  }


  export class Error extends jspb.Message {
    getDescription(): string;
    setDescription(value: string): Error;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): Error.AsObject;
    static toObject(includeInstance: boolean, msg: Error): Error.AsObject;
    static serializeBinaryToWriter(message: Error, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): Error;
    static deserializeBinaryFromReader(message: Error, reader: jspb.BinaryReader): Error;
  }

  export namespace Error {
    export type AsObject = {
      description: string,
    }
  }


  export class DirectBrowser extends jspb.Message {
    getUrl(): string;
    setUrl(value: string): DirectBrowser;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): DirectBrowser.AsObject;
    static toObject(includeInstance: boolean, msg: DirectBrowser): DirectBrowser.AsObject;
    static serializeBinaryToWriter(message: DirectBrowser, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): DirectBrowser;
    static deserializeBinaryFromReader(message: DirectBrowser, reader: jspb.BinaryReader): DirectBrowser;
  }

  export namespace DirectBrowser {
    export type AsObject = {
      url: string,
    }
  }


  export class Message extends jspb.Message {
    getText(): string;
    setText(value: string): Message;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): Message.AsObject;
    static toObject(includeInstance: boolean, msg: Message): Message.AsObject;
    static serializeBinaryToWriter(message: Message, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): Message;
    static deserializeBinaryFromReader(message: Message, reader: jspb.BinaryReader): Message;
  }

  export namespace Message {
    export type AsObject = {
      text: string,
    }
  }


  export enum StateCase { 
    STATE_NOT_SET = 0,
    DIRECT_BROWSER = 1,
    LOGGED_IN = 2,
    MESSAGE = 3,
    ERROR = 4,
  }
}

export class _GenerateApiTokenRequest extends jspb.Message {
  getNever(): _GenerateApiTokenRequest.Never | undefined;
  setNever(value?: _GenerateApiTokenRequest.Never): _GenerateApiTokenRequest;
  hasNever(): boolean;
  clearNever(): _GenerateApiTokenRequest;

  getExpires(): _GenerateApiTokenRequest.Expires | undefined;
  setExpires(value?: _GenerateApiTokenRequest.Expires): _GenerateApiTokenRequest;
  hasExpires(): boolean;
  clearExpires(): _GenerateApiTokenRequest;

  getAuthToken(): string;
  setAuthToken(value: string): _GenerateApiTokenRequest;

  getPermissions(): permissionmessages_pb.Permissions | undefined;
  setPermissions(value?: permissionmessages_pb.Permissions): _GenerateApiTokenRequest;
  hasPermissions(): boolean;
  clearPermissions(): _GenerateApiTokenRequest;

  getTokenId(): string;
  setTokenId(value: string): _GenerateApiTokenRequest;

  getDescription(): string;
  setDescription(value: string): _GenerateApiTokenRequest;

  getExpiryCase(): _GenerateApiTokenRequest.ExpiryCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GenerateApiTokenRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GenerateApiTokenRequest): _GenerateApiTokenRequest.AsObject;
  static serializeBinaryToWriter(message: _GenerateApiTokenRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GenerateApiTokenRequest;
  static deserializeBinaryFromReader(message: _GenerateApiTokenRequest, reader: jspb.BinaryReader): _GenerateApiTokenRequest;
}

export namespace _GenerateApiTokenRequest {
  export type AsObject = {
    never?: _GenerateApiTokenRequest.Never.AsObject,
    expires?: _GenerateApiTokenRequest.Expires.AsObject,
    authToken: string,
    permissions?: permissionmessages_pb.Permissions.AsObject,
    tokenId: string,
    description: string,
  }

  export class Never extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): Never.AsObject;
    static toObject(includeInstance: boolean, msg: Never): Never.AsObject;
    static serializeBinaryToWriter(message: Never, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): Never;
    static deserializeBinaryFromReader(message: Never, reader: jspb.BinaryReader): Never;
  }

  export namespace Never {
    export type AsObject = {
    }
  }


  export class Expires extends jspb.Message {
    getValidForSeconds(): number;
    setValidForSeconds(value: number): Expires;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): Expires.AsObject;
    static toObject(includeInstance: boolean, msg: Expires): Expires.AsObject;
    static serializeBinaryToWriter(message: Expires, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): Expires;
    static deserializeBinaryFromReader(message: Expires, reader: jspb.BinaryReader): Expires;
  }

  export namespace Expires {
    export type AsObject = {
      validForSeconds: number,
    }
  }


  export enum ExpiryCase { 
    EXPIRY_NOT_SET = 0,
    NEVER = 1,
    EXPIRES = 2,
  }
}

export class _GenerateApiTokenResponse extends jspb.Message {
  getApiKey(): string;
  setApiKey(value: string): _GenerateApiTokenResponse;

  getRefreshToken(): string;
  setRefreshToken(value: string): _GenerateApiTokenResponse;

  getEndpoint(): string;
  setEndpoint(value: string): _GenerateApiTokenResponse;

  getValidUntil(): number;
  setValidUntil(value: number): _GenerateApiTokenResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GenerateApiTokenResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GenerateApiTokenResponse): _GenerateApiTokenResponse.AsObject;
  static serializeBinaryToWriter(message: _GenerateApiTokenResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GenerateApiTokenResponse;
  static deserializeBinaryFromReader(message: _GenerateApiTokenResponse, reader: jspb.BinaryReader): _GenerateApiTokenResponse;
}

export namespace _GenerateApiTokenResponse {
  export type AsObject = {
    apiKey: string,
    refreshToken: string,
    endpoint: string,
    validUntil: number,
  }
}

export class _RefreshApiTokenRequest extends jspb.Message {
  getApiKey(): string;
  setApiKey(value: string): _RefreshApiTokenRequest;

  getRefreshToken(): string;
  setRefreshToken(value: string): _RefreshApiTokenRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RefreshApiTokenRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _RefreshApiTokenRequest): _RefreshApiTokenRequest.AsObject;
  static serializeBinaryToWriter(message: _RefreshApiTokenRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RefreshApiTokenRequest;
  static deserializeBinaryFromReader(message: _RefreshApiTokenRequest, reader: jspb.BinaryReader): _RefreshApiTokenRequest;
}

export namespace _RefreshApiTokenRequest {
  export type AsObject = {
    apiKey: string,
    refreshToken: string,
  }
}

export class _RefreshApiTokenResponse extends jspb.Message {
  getApiKey(): string;
  setApiKey(value: string): _RefreshApiTokenResponse;

  getRefreshToken(): string;
  setRefreshToken(value: string): _RefreshApiTokenResponse;

  getEndpoint(): string;
  setEndpoint(value: string): _RefreshApiTokenResponse;

  getValidUntil(): number;
  setValidUntil(value: number): _RefreshApiTokenResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RefreshApiTokenResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _RefreshApiTokenResponse): _RefreshApiTokenResponse.AsObject;
  static serializeBinaryToWriter(message: _RefreshApiTokenResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RefreshApiTokenResponse;
  static deserializeBinaryFromReader(message: _RefreshApiTokenResponse, reader: jspb.BinaryReader): _RefreshApiTokenResponse;
}

export namespace _RefreshApiTokenResponse {
  export type AsObject = {
    apiKey: string,
    refreshToken: string,
    endpoint: string,
    validUntil: number,
  }
}

