import * as jspb from 'google-protobuf'

import * as common_pb from './common_pb';


export class _GetRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _GetRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetRequest): _GetRequest.AsObject;
  static serializeBinaryToWriter(message: _GetRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetRequest;
  static deserializeBinaryFromReader(message: _GetRequest, reader: jspb.BinaryReader): _GetRequest;
}

export namespace _GetRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
  }
}

export class _GetResponse extends jspb.Message {
  getResult(): ECacheResult;
  setResult(value: ECacheResult): _GetResponse;

  getCacheBody(): Uint8Array | string;
  getCacheBody_asU8(): Uint8Array;
  getCacheBody_asB64(): string;
  setCacheBody(value: Uint8Array | string): _GetResponse;

  getMessage(): string;
  setMessage(value: string): _GetResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetResponse): _GetResponse.AsObject;
  static serializeBinaryToWriter(message: _GetResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetResponse;
  static deserializeBinaryFromReader(message: _GetResponse, reader: jspb.BinaryReader): _GetResponse;
}

export namespace _GetResponse {
  export type AsObject = {
    result: ECacheResult,
    cacheBody: Uint8Array | string,
    message: string,
  }
}

export class _GetWithHashRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _GetWithHashRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetWithHashRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetWithHashRequest): _GetWithHashRequest.AsObject;
  static serializeBinaryToWriter(message: _GetWithHashRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetWithHashRequest;
  static deserializeBinaryFromReader(message: _GetWithHashRequest, reader: jspb.BinaryReader): _GetWithHashRequest;
}

export namespace _GetWithHashRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
  }
}

export class _GetWithHashResponse extends jspb.Message {
  getFound(): _GetWithHashResponse._Found | undefined;
  setFound(value?: _GetWithHashResponse._Found): _GetWithHashResponse;
  hasFound(): boolean;
  clearFound(): _GetWithHashResponse;

  getMissing(): _GetWithHashResponse._Missing | undefined;
  setMissing(value?: _GetWithHashResponse._Missing): _GetWithHashResponse;
  hasMissing(): boolean;
  clearMissing(): _GetWithHashResponse;

  getResultCase(): _GetWithHashResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetWithHashResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetWithHashResponse): _GetWithHashResponse.AsObject;
  static serializeBinaryToWriter(message: _GetWithHashResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetWithHashResponse;
  static deserializeBinaryFromReader(message: _GetWithHashResponse, reader: jspb.BinaryReader): _GetWithHashResponse;
}

export namespace _GetWithHashResponse {
  export type AsObject = {
    found?: _GetWithHashResponse._Found.AsObject,
    missing?: _GetWithHashResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getValue(): Uint8Array | string;
    getValue_asU8(): Uint8Array;
    getValue_asB64(): string;
    setValue(value: Uint8Array | string): _Found;

    getHash(): Uint8Array | string;
    getHash_asU8(): Uint8Array;
    getHash_asB64(): string;
    setHash(value: Uint8Array | string): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      value: Uint8Array | string,
      hash: Uint8Array | string,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _GetBatchRequest extends jspb.Message {
  getItemsList(): Array<_GetRequest>;
  setItemsList(value: Array<_GetRequest>): _GetBatchRequest;
  clearItemsList(): _GetBatchRequest;
  addItems(value?: _GetRequest, index?: number): _GetRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetBatchRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetBatchRequest): _GetBatchRequest.AsObject;
  static serializeBinaryToWriter(message: _GetBatchRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetBatchRequest;
  static deserializeBinaryFromReader(message: _GetBatchRequest, reader: jspb.BinaryReader): _GetBatchRequest;
}

export namespace _GetBatchRequest {
  export type AsObject = {
    itemsList: Array<_GetRequest.AsObject>,
  }
}

export class _DeleteRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _DeleteRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DeleteRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DeleteRequest): _DeleteRequest.AsObject;
  static serializeBinaryToWriter(message: _DeleteRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DeleteRequest;
  static deserializeBinaryFromReader(message: _DeleteRequest, reader: jspb.BinaryReader): _DeleteRequest;
}

export namespace _DeleteRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
  }
}

export class _DeleteResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DeleteResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DeleteResponse): _DeleteResponse.AsObject;
  static serializeBinaryToWriter(message: _DeleteResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DeleteResponse;
  static deserializeBinaryFromReader(message: _DeleteResponse, reader: jspb.BinaryReader): _DeleteResponse;
}

export namespace _DeleteResponse {
  export type AsObject = {
  }
}

export class _SetRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _SetRequest;

  getCacheBody(): Uint8Array | string;
  getCacheBody_asU8(): Uint8Array;
  getCacheBody_asB64(): string;
  setCacheBody(value: Uint8Array | string): _SetRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SetRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetRequest): _SetRequest.AsObject;
  static serializeBinaryToWriter(message: _SetRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetRequest;
  static deserializeBinaryFromReader(message: _SetRequest, reader: jspb.BinaryReader): _SetRequest;
}

export namespace _SetRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
    cacheBody: Uint8Array | string,
    ttlMilliseconds: number,
  }
}

export class _SetResponse extends jspb.Message {
  getResult(): ECacheResult;
  setResult(value: ECacheResult): _SetResponse;

  getMessage(): string;
  setMessage(value: string): _SetResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetResponse): _SetResponse.AsObject;
  static serializeBinaryToWriter(message: _SetResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetResponse;
  static deserializeBinaryFromReader(message: _SetResponse, reader: jspb.BinaryReader): _SetResponse;
}

export namespace _SetResponse {
  export type AsObject = {
    result: ECacheResult,
    message: string,
  }
}

export class _SetBatchRequest extends jspb.Message {
  getItemsList(): Array<_SetRequest>;
  setItemsList(value: Array<_SetRequest>): _SetBatchRequest;
  clearItemsList(): _SetBatchRequest;
  addItems(value?: _SetRequest, index?: number): _SetRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetBatchRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetBatchRequest): _SetBatchRequest.AsObject;
  static serializeBinaryToWriter(message: _SetBatchRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetBatchRequest;
  static deserializeBinaryFromReader(message: _SetBatchRequest, reader: jspb.BinaryReader): _SetBatchRequest;
}

export namespace _SetBatchRequest {
  export type AsObject = {
    itemsList: Array<_SetRequest.AsObject>,
  }
}

export class _SetIfRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _SetIfRequest;

  getCacheBody(): Uint8Array | string;
  getCacheBody_asU8(): Uint8Array;
  getCacheBody_asB64(): string;
  setCacheBody(value: Uint8Array | string): _SetIfRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SetIfRequest;

  getPresent(): common_pb.Present | undefined;
  setPresent(value?: common_pb.Present): _SetIfRequest;
  hasPresent(): boolean;
  clearPresent(): _SetIfRequest;

  getPresentAndNotEqual(): common_pb.PresentAndNotEqual | undefined;
  setPresentAndNotEqual(value?: common_pb.PresentAndNotEqual): _SetIfRequest;
  hasPresentAndNotEqual(): boolean;
  clearPresentAndNotEqual(): _SetIfRequest;

  getAbsent(): common_pb.Absent | undefined;
  setAbsent(value?: common_pb.Absent): _SetIfRequest;
  hasAbsent(): boolean;
  clearAbsent(): _SetIfRequest;

  getEqual(): common_pb.Equal | undefined;
  setEqual(value?: common_pb.Equal): _SetIfRequest;
  hasEqual(): boolean;
  clearEqual(): _SetIfRequest;

  getAbsentOrEqual(): common_pb.AbsentOrEqual | undefined;
  setAbsentOrEqual(value?: common_pb.AbsentOrEqual): _SetIfRequest;
  hasAbsentOrEqual(): boolean;
  clearAbsentOrEqual(): _SetIfRequest;

  getNotEqual(): common_pb.NotEqual | undefined;
  setNotEqual(value?: common_pb.NotEqual): _SetIfRequest;
  hasNotEqual(): boolean;
  clearNotEqual(): _SetIfRequest;

  getConditionCase(): _SetIfRequest.ConditionCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetIfRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetIfRequest): _SetIfRequest.AsObject;
  static serializeBinaryToWriter(message: _SetIfRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetIfRequest;
  static deserializeBinaryFromReader(message: _SetIfRequest, reader: jspb.BinaryReader): _SetIfRequest;
}

export namespace _SetIfRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
    cacheBody: Uint8Array | string,
    ttlMilliseconds: number,
    present?: common_pb.Present.AsObject,
    presentAndNotEqual?: common_pb.PresentAndNotEqual.AsObject,
    absent?: common_pb.Absent.AsObject,
    equal?: common_pb.Equal.AsObject,
    absentOrEqual?: common_pb.AbsentOrEqual.AsObject,
    notEqual?: common_pb.NotEqual.AsObject,
  }

  export enum ConditionCase { 
    CONDITION_NOT_SET = 0,
    PRESENT = 4,
    PRESENT_AND_NOT_EQUAL = 5,
    ABSENT = 6,
    EQUAL = 7,
    ABSENT_OR_EQUAL = 8,
    NOT_EQUAL = 9,
  }
}

export class _SetIfResponse extends jspb.Message {
  getStored(): _SetIfResponse._Stored | undefined;
  setStored(value?: _SetIfResponse._Stored): _SetIfResponse;
  hasStored(): boolean;
  clearStored(): _SetIfResponse;

  getNotStored(): _SetIfResponse._NotStored | undefined;
  setNotStored(value?: _SetIfResponse._NotStored): _SetIfResponse;
  hasNotStored(): boolean;
  clearNotStored(): _SetIfResponse;

  getResultCase(): _SetIfResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetIfResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetIfResponse): _SetIfResponse.AsObject;
  static serializeBinaryToWriter(message: _SetIfResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetIfResponse;
  static deserializeBinaryFromReader(message: _SetIfResponse, reader: jspb.BinaryReader): _SetIfResponse;
}

export namespace _SetIfResponse {
  export type AsObject = {
    stored?: _SetIfResponse._Stored.AsObject,
    notStored?: _SetIfResponse._NotStored.AsObject,
  }

  export class _Stored extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Stored.AsObject;
    static toObject(includeInstance: boolean, msg: _Stored): _Stored.AsObject;
    static serializeBinaryToWriter(message: _Stored, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Stored;
    static deserializeBinaryFromReader(message: _Stored, reader: jspb.BinaryReader): _Stored;
  }

  export namespace _Stored {
    export type AsObject = {
    }
  }


  export class _NotStored extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _NotStored.AsObject;
    static toObject(includeInstance: boolean, msg: _NotStored): _NotStored.AsObject;
    static serializeBinaryToWriter(message: _NotStored, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _NotStored;
    static deserializeBinaryFromReader(message: _NotStored, reader: jspb.BinaryReader): _NotStored;
  }

  export namespace _NotStored {
    export type AsObject = {
    }
  }


  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    STORED = 1,
    NOT_STORED = 2,
  }
}

export class _SetIfHashRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _SetIfHashRequest;

  getCacheBody(): Uint8Array | string;
  getCacheBody_asU8(): Uint8Array;
  getCacheBody_asB64(): string;
  setCacheBody(value: Uint8Array | string): _SetIfHashRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SetIfHashRequest;

  getPresentAndNotHashEqual(): common_pb.PresentAndNotHashEqual | undefined;
  setPresentAndNotHashEqual(value?: common_pb.PresentAndNotHashEqual): _SetIfHashRequest;
  hasPresentAndNotHashEqual(): boolean;
  clearPresentAndNotHashEqual(): _SetIfHashRequest;

  getPresentAndHashEqual(): common_pb.PresentAndHashEqual | undefined;
  setPresentAndHashEqual(value?: common_pb.PresentAndHashEqual): _SetIfHashRequest;
  hasPresentAndHashEqual(): boolean;
  clearPresentAndHashEqual(): _SetIfHashRequest;

  getAbsentOrHashEqual(): common_pb.AbsentOrHashEqual | undefined;
  setAbsentOrHashEqual(value?: common_pb.AbsentOrHashEqual): _SetIfHashRequest;
  hasAbsentOrHashEqual(): boolean;
  clearAbsentOrHashEqual(): _SetIfHashRequest;

  getAbsentOrNotHashEqual(): common_pb.AbsentOrNotHashEqual | undefined;
  setAbsentOrNotHashEqual(value?: common_pb.AbsentOrNotHashEqual): _SetIfHashRequest;
  hasAbsentOrNotHashEqual(): boolean;
  clearAbsentOrNotHashEqual(): _SetIfHashRequest;

  getUnconditional(): common_pb.Unconditional | undefined;
  setUnconditional(value?: common_pb.Unconditional): _SetIfHashRequest;
  hasUnconditional(): boolean;
  clearUnconditional(): _SetIfHashRequest;

  getConditionCase(): _SetIfHashRequest.ConditionCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetIfHashRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetIfHashRequest): _SetIfHashRequest.AsObject;
  static serializeBinaryToWriter(message: _SetIfHashRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetIfHashRequest;
  static deserializeBinaryFromReader(message: _SetIfHashRequest, reader: jspb.BinaryReader): _SetIfHashRequest;
}

export namespace _SetIfHashRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
    cacheBody: Uint8Array | string,
    ttlMilliseconds: number,
    presentAndNotHashEqual?: common_pb.PresentAndNotHashEqual.AsObject,
    presentAndHashEqual?: common_pb.PresentAndHashEqual.AsObject,
    absentOrHashEqual?: common_pb.AbsentOrHashEqual.AsObject,
    absentOrNotHashEqual?: common_pb.AbsentOrNotHashEqual.AsObject,
    unconditional?: common_pb.Unconditional.AsObject,
  }

  export enum ConditionCase { 
    CONDITION_NOT_SET = 0,
    PRESENT_AND_NOT_HASH_EQUAL = 4,
    PRESENT_AND_HASH_EQUAL = 5,
    ABSENT_OR_HASH_EQUAL = 6,
    ABSENT_OR_NOT_HASH_EQUAL = 7,
    UNCONDITIONAL = 8,
  }
}

export class _SetIfHashResponse extends jspb.Message {
  getStored(): _SetIfHashResponse._Stored | undefined;
  setStored(value?: _SetIfHashResponse._Stored): _SetIfHashResponse;
  hasStored(): boolean;
  clearStored(): _SetIfHashResponse;

  getNotStored(): _SetIfHashResponse._NotStored | undefined;
  setNotStored(value?: _SetIfHashResponse._NotStored): _SetIfHashResponse;
  hasNotStored(): boolean;
  clearNotStored(): _SetIfHashResponse;

  getResultCase(): _SetIfHashResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetIfHashResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetIfHashResponse): _SetIfHashResponse.AsObject;
  static serializeBinaryToWriter(message: _SetIfHashResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetIfHashResponse;
  static deserializeBinaryFromReader(message: _SetIfHashResponse, reader: jspb.BinaryReader): _SetIfHashResponse;
}

export namespace _SetIfHashResponse {
  export type AsObject = {
    stored?: _SetIfHashResponse._Stored.AsObject,
    notStored?: _SetIfHashResponse._NotStored.AsObject,
  }

  export class _Stored extends jspb.Message {
    getNewHash(): Uint8Array | string;
    getNewHash_asU8(): Uint8Array;
    getNewHash_asB64(): string;
    setNewHash(value: Uint8Array | string): _Stored;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Stored.AsObject;
    static toObject(includeInstance: boolean, msg: _Stored): _Stored.AsObject;
    static serializeBinaryToWriter(message: _Stored, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Stored;
    static deserializeBinaryFromReader(message: _Stored, reader: jspb.BinaryReader): _Stored;
  }

  export namespace _Stored {
    export type AsObject = {
      newHash: Uint8Array | string,
    }
  }


  export class _NotStored extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _NotStored.AsObject;
    static toObject(includeInstance: boolean, msg: _NotStored): _NotStored.AsObject;
    static serializeBinaryToWriter(message: _NotStored, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _NotStored;
    static deserializeBinaryFromReader(message: _NotStored, reader: jspb.BinaryReader): _NotStored;
  }

  export namespace _NotStored {
    export type AsObject = {
    }
  }


  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    STORED = 1,
    NOT_STORED = 2,
  }
}

export class _SetIfNotExistsRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _SetIfNotExistsRequest;

  getCacheBody(): Uint8Array | string;
  getCacheBody_asU8(): Uint8Array;
  getCacheBody_asB64(): string;
  setCacheBody(value: Uint8Array | string): _SetIfNotExistsRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SetIfNotExistsRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetIfNotExistsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetIfNotExistsRequest): _SetIfNotExistsRequest.AsObject;
  static serializeBinaryToWriter(message: _SetIfNotExistsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetIfNotExistsRequest;
  static deserializeBinaryFromReader(message: _SetIfNotExistsRequest, reader: jspb.BinaryReader): _SetIfNotExistsRequest;
}

export namespace _SetIfNotExistsRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
    cacheBody: Uint8Array | string,
    ttlMilliseconds: number,
  }
}

export class _SetIfNotExistsResponse extends jspb.Message {
  getStored(): _SetIfNotExistsResponse._Stored | undefined;
  setStored(value?: _SetIfNotExistsResponse._Stored): _SetIfNotExistsResponse;
  hasStored(): boolean;
  clearStored(): _SetIfNotExistsResponse;

  getNotStored(): _SetIfNotExistsResponse._NotStored | undefined;
  setNotStored(value?: _SetIfNotExistsResponse._NotStored): _SetIfNotExistsResponse;
  hasNotStored(): boolean;
  clearNotStored(): _SetIfNotExistsResponse;

  getResultCase(): _SetIfNotExistsResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetIfNotExistsResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetIfNotExistsResponse): _SetIfNotExistsResponse.AsObject;
  static serializeBinaryToWriter(message: _SetIfNotExistsResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetIfNotExistsResponse;
  static deserializeBinaryFromReader(message: _SetIfNotExistsResponse, reader: jspb.BinaryReader): _SetIfNotExistsResponse;
}

export namespace _SetIfNotExistsResponse {
  export type AsObject = {
    stored?: _SetIfNotExistsResponse._Stored.AsObject,
    notStored?: _SetIfNotExistsResponse._NotStored.AsObject,
  }

  export class _Stored extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Stored.AsObject;
    static toObject(includeInstance: boolean, msg: _Stored): _Stored.AsObject;
    static serializeBinaryToWriter(message: _Stored, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Stored;
    static deserializeBinaryFromReader(message: _Stored, reader: jspb.BinaryReader): _Stored;
  }

  export namespace _Stored {
    export type AsObject = {
    }
  }


  export class _NotStored extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _NotStored.AsObject;
    static toObject(includeInstance: boolean, msg: _NotStored): _NotStored.AsObject;
    static serializeBinaryToWriter(message: _NotStored, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _NotStored;
    static deserializeBinaryFromReader(message: _NotStored, reader: jspb.BinaryReader): _NotStored;
  }

  export namespace _NotStored {
    export type AsObject = {
    }
  }


  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    STORED = 1,
    NOT_STORED = 2,
  }
}

export class _KeysExistRequest extends jspb.Message {
  getCacheKeysList(): Array<Uint8Array | string>;
  setCacheKeysList(value: Array<Uint8Array | string>): _KeysExistRequest;
  clearCacheKeysList(): _KeysExistRequest;
  addCacheKeys(value: Uint8Array | string, index?: number): _KeysExistRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _KeysExistRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _KeysExistRequest): _KeysExistRequest.AsObject;
  static serializeBinaryToWriter(message: _KeysExistRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _KeysExistRequest;
  static deserializeBinaryFromReader(message: _KeysExistRequest, reader: jspb.BinaryReader): _KeysExistRequest;
}

export namespace _KeysExistRequest {
  export type AsObject = {
    cacheKeysList: Array<Uint8Array | string>,
  }
}

export class _KeysExistResponse extends jspb.Message {
  getExistsList(): Array<boolean>;
  setExistsList(value: Array<boolean>): _KeysExistResponse;
  clearExistsList(): _KeysExistResponse;
  addExists(value: boolean, index?: number): _KeysExistResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _KeysExistResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _KeysExistResponse): _KeysExistResponse.AsObject;
  static serializeBinaryToWriter(message: _KeysExistResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _KeysExistResponse;
  static deserializeBinaryFromReader(message: _KeysExistResponse, reader: jspb.BinaryReader): _KeysExistResponse;
}

export namespace _KeysExistResponse {
  export type AsObject = {
    existsList: Array<boolean>,
  }
}

export class _IncrementRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _IncrementRequest;

  getAmount(): number;
  setAmount(value: number): _IncrementRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _IncrementRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _IncrementRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _IncrementRequest): _IncrementRequest.AsObject;
  static serializeBinaryToWriter(message: _IncrementRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _IncrementRequest;
  static deserializeBinaryFromReader(message: _IncrementRequest, reader: jspb.BinaryReader): _IncrementRequest;
}

export namespace _IncrementRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
    amount: number,
    ttlMilliseconds: number,
  }
}

export class _IncrementResponse extends jspb.Message {
  getValue(): number;
  setValue(value: number): _IncrementResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _IncrementResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _IncrementResponse): _IncrementResponse.AsObject;
  static serializeBinaryToWriter(message: _IncrementResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _IncrementResponse;
  static deserializeBinaryFromReader(message: _IncrementResponse, reader: jspb.BinaryReader): _IncrementResponse;
}

export namespace _IncrementResponse {
  export type AsObject = {
    value: number,
  }
}

export class _UpdateTtlRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _UpdateTtlRequest;

  getIncreaseToMilliseconds(): number;
  setIncreaseToMilliseconds(value: number): _UpdateTtlRequest;

  getDecreaseToMilliseconds(): number;
  setDecreaseToMilliseconds(value: number): _UpdateTtlRequest;

  getOverwriteToMilliseconds(): number;
  setOverwriteToMilliseconds(value: number): _UpdateTtlRequest;

  getUpdateTtlCase(): _UpdateTtlRequest.UpdateTtlCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _UpdateTtlRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _UpdateTtlRequest): _UpdateTtlRequest.AsObject;
  static serializeBinaryToWriter(message: _UpdateTtlRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _UpdateTtlRequest;
  static deserializeBinaryFromReader(message: _UpdateTtlRequest, reader: jspb.BinaryReader): _UpdateTtlRequest;
}

export namespace _UpdateTtlRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
    increaseToMilliseconds: number,
    decreaseToMilliseconds: number,
    overwriteToMilliseconds: number,
  }

  export enum UpdateTtlCase { 
    UPDATE_TTL_NOT_SET = 0,
    INCREASE_TO_MILLISECONDS = 2,
    DECREASE_TO_MILLISECONDS = 3,
    OVERWRITE_TO_MILLISECONDS = 4,
  }
}

export class _UpdateTtlResponse extends jspb.Message {
  getSet(): _UpdateTtlResponse._Set | undefined;
  setSet(value?: _UpdateTtlResponse._Set): _UpdateTtlResponse;
  hasSet(): boolean;
  clearSet(): _UpdateTtlResponse;

  getNotSet(): _UpdateTtlResponse._NotSet | undefined;
  setNotSet(value?: _UpdateTtlResponse._NotSet): _UpdateTtlResponse;
  hasNotSet(): boolean;
  clearNotSet(): _UpdateTtlResponse;

  getMissing(): _UpdateTtlResponse._Missing | undefined;
  setMissing(value?: _UpdateTtlResponse._Missing): _UpdateTtlResponse;
  hasMissing(): boolean;
  clearMissing(): _UpdateTtlResponse;

  getResultCase(): _UpdateTtlResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _UpdateTtlResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _UpdateTtlResponse): _UpdateTtlResponse.AsObject;
  static serializeBinaryToWriter(message: _UpdateTtlResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _UpdateTtlResponse;
  static deserializeBinaryFromReader(message: _UpdateTtlResponse, reader: jspb.BinaryReader): _UpdateTtlResponse;
}

export namespace _UpdateTtlResponse {
  export type AsObject = {
    set?: _UpdateTtlResponse._Set.AsObject,
    notSet?: _UpdateTtlResponse._NotSet.AsObject,
    missing?: _UpdateTtlResponse._Missing.AsObject,
  }

  export class _Set extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Set.AsObject;
    static toObject(includeInstance: boolean, msg: _Set): _Set.AsObject;
    static serializeBinaryToWriter(message: _Set, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Set;
    static deserializeBinaryFromReader(message: _Set, reader: jspb.BinaryReader): _Set;
  }

  export namespace _Set {
    export type AsObject = {
    }
  }


  export class _NotSet extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _NotSet.AsObject;
    static toObject(includeInstance: boolean, msg: _NotSet): _NotSet.AsObject;
    static serializeBinaryToWriter(message: _NotSet, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _NotSet;
    static deserializeBinaryFromReader(message: _NotSet, reader: jspb.BinaryReader): _NotSet;
  }

  export namespace _NotSet {
    export type AsObject = {
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    SET = 1,
    NOT_SET = 2,
    MISSING = 3,
  }
}

export class _ItemGetTtlRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _ItemGetTtlRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ItemGetTtlRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ItemGetTtlRequest): _ItemGetTtlRequest.AsObject;
  static serializeBinaryToWriter(message: _ItemGetTtlRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ItemGetTtlRequest;
  static deserializeBinaryFromReader(message: _ItemGetTtlRequest, reader: jspb.BinaryReader): _ItemGetTtlRequest;
}

export namespace _ItemGetTtlRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
  }
}

export class _ItemGetTtlResponse extends jspb.Message {
  getFound(): _ItemGetTtlResponse._Found | undefined;
  setFound(value?: _ItemGetTtlResponse._Found): _ItemGetTtlResponse;
  hasFound(): boolean;
  clearFound(): _ItemGetTtlResponse;

  getMissing(): _ItemGetTtlResponse._Missing | undefined;
  setMissing(value?: _ItemGetTtlResponse._Missing): _ItemGetTtlResponse;
  hasMissing(): boolean;
  clearMissing(): _ItemGetTtlResponse;

  getResultCase(): _ItemGetTtlResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ItemGetTtlResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ItemGetTtlResponse): _ItemGetTtlResponse.AsObject;
  static serializeBinaryToWriter(message: _ItemGetTtlResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ItemGetTtlResponse;
  static deserializeBinaryFromReader(message: _ItemGetTtlResponse, reader: jspb.BinaryReader): _ItemGetTtlResponse;
}

export namespace _ItemGetTtlResponse {
  export type AsObject = {
    found?: _ItemGetTtlResponse._Found.AsObject,
    missing?: _ItemGetTtlResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getRemainingTtlMillis(): number;
    setRemainingTtlMillis(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      remainingTtlMillis: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ItemGetTypeRequest extends jspb.Message {
  getCacheKey(): Uint8Array | string;
  getCacheKey_asU8(): Uint8Array;
  getCacheKey_asB64(): string;
  setCacheKey(value: Uint8Array | string): _ItemGetTypeRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ItemGetTypeRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ItemGetTypeRequest): _ItemGetTypeRequest.AsObject;
  static serializeBinaryToWriter(message: _ItemGetTypeRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ItemGetTypeRequest;
  static deserializeBinaryFromReader(message: _ItemGetTypeRequest, reader: jspb.BinaryReader): _ItemGetTypeRequest;
}

export namespace _ItemGetTypeRequest {
  export type AsObject = {
    cacheKey: Uint8Array | string,
  }
}

export class _ItemGetTypeResponse extends jspb.Message {
  getFound(): _ItemGetTypeResponse._Found | undefined;
  setFound(value?: _ItemGetTypeResponse._Found): _ItemGetTypeResponse;
  hasFound(): boolean;
  clearFound(): _ItemGetTypeResponse;

  getMissing(): _ItemGetTypeResponse._Missing | undefined;
  setMissing(value?: _ItemGetTypeResponse._Missing): _ItemGetTypeResponse;
  hasMissing(): boolean;
  clearMissing(): _ItemGetTypeResponse;

  getResultCase(): _ItemGetTypeResponse.ResultCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ItemGetTypeResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ItemGetTypeResponse): _ItemGetTypeResponse.AsObject;
  static serializeBinaryToWriter(message: _ItemGetTypeResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ItemGetTypeResponse;
  static deserializeBinaryFromReader(message: _ItemGetTypeResponse, reader: jspb.BinaryReader): _ItemGetTypeResponse;
}

export namespace _ItemGetTypeResponse {
  export type AsObject = {
    found?: _ItemGetTypeResponse._Found.AsObject,
    missing?: _ItemGetTypeResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getItemType(): _ItemGetTypeResponse.ItemType;
    setItemType(value: _ItemGetTypeResponse.ItemType): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      itemType: _ItemGetTypeResponse.ItemType,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ItemType { 
    SCALAR = 0,
    DICTIONARY = 1,
    SET = 2,
    LIST = 3,
    SORTED_SET = 4,
  }

  export enum ResultCase { 
    RESULT_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _DictionaryGetRequest extends jspb.Message {
  getDictionaryName(): Uint8Array | string;
  getDictionaryName_asU8(): Uint8Array;
  getDictionaryName_asB64(): string;
  setDictionaryName(value: Uint8Array | string): _DictionaryGetRequest;

  getFieldsList(): Array<Uint8Array | string>;
  setFieldsList(value: Array<Uint8Array | string>): _DictionaryGetRequest;
  clearFieldsList(): _DictionaryGetRequest;
  addFields(value: Uint8Array | string, index?: number): _DictionaryGetRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryGetRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryGetRequest): _DictionaryGetRequest.AsObject;
  static serializeBinaryToWriter(message: _DictionaryGetRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryGetRequest;
  static deserializeBinaryFromReader(message: _DictionaryGetRequest, reader: jspb.BinaryReader): _DictionaryGetRequest;
}

export namespace _DictionaryGetRequest {
  export type AsObject = {
    dictionaryName: Uint8Array | string,
    fieldsList: Array<Uint8Array | string>,
  }
}

export class _DictionaryGetResponse extends jspb.Message {
  getFound(): _DictionaryGetResponse._Found | undefined;
  setFound(value?: _DictionaryGetResponse._Found): _DictionaryGetResponse;
  hasFound(): boolean;
  clearFound(): _DictionaryGetResponse;

  getMissing(): _DictionaryGetResponse._Missing | undefined;
  setMissing(value?: _DictionaryGetResponse._Missing): _DictionaryGetResponse;
  hasMissing(): boolean;
  clearMissing(): _DictionaryGetResponse;

  getDictionaryCase(): _DictionaryGetResponse.DictionaryCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryGetResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryGetResponse): _DictionaryGetResponse.AsObject;
  static serializeBinaryToWriter(message: _DictionaryGetResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryGetResponse;
  static deserializeBinaryFromReader(message: _DictionaryGetResponse, reader: jspb.BinaryReader): _DictionaryGetResponse;
}

export namespace _DictionaryGetResponse {
  export type AsObject = {
    found?: _DictionaryGetResponse._Found.AsObject,
    missing?: _DictionaryGetResponse._Missing.AsObject,
  }

  export class _DictionaryGetResponsePart extends jspb.Message {
    getResult(): ECacheResult;
    setResult(value: ECacheResult): _DictionaryGetResponsePart;

    getCacheBody(): Uint8Array | string;
    getCacheBody_asU8(): Uint8Array;
    getCacheBody_asB64(): string;
    setCacheBody(value: Uint8Array | string): _DictionaryGetResponsePart;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _DictionaryGetResponsePart.AsObject;
    static toObject(includeInstance: boolean, msg: _DictionaryGetResponsePart): _DictionaryGetResponsePart.AsObject;
    static serializeBinaryToWriter(message: _DictionaryGetResponsePart, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _DictionaryGetResponsePart;
    static deserializeBinaryFromReader(message: _DictionaryGetResponsePart, reader: jspb.BinaryReader): _DictionaryGetResponsePart;
  }

  export namespace _DictionaryGetResponsePart {
    export type AsObject = {
      result: ECacheResult,
      cacheBody: Uint8Array | string,
    }
  }


  export class _Found extends jspb.Message {
    getItemsList(): Array<_DictionaryGetResponse._DictionaryGetResponsePart>;
    setItemsList(value: Array<_DictionaryGetResponse._DictionaryGetResponsePart>): _Found;
    clearItemsList(): _Found;
    addItems(value?: _DictionaryGetResponse._DictionaryGetResponsePart, index?: number): _DictionaryGetResponse._DictionaryGetResponsePart;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      itemsList: Array<_DictionaryGetResponse._DictionaryGetResponsePart.AsObject>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum DictionaryCase { 
    DICTIONARY_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _DictionaryFetchRequest extends jspb.Message {
  getDictionaryName(): Uint8Array | string;
  getDictionaryName_asU8(): Uint8Array;
  getDictionaryName_asB64(): string;
  setDictionaryName(value: Uint8Array | string): _DictionaryFetchRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryFetchRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryFetchRequest): _DictionaryFetchRequest.AsObject;
  static serializeBinaryToWriter(message: _DictionaryFetchRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryFetchRequest;
  static deserializeBinaryFromReader(message: _DictionaryFetchRequest, reader: jspb.BinaryReader): _DictionaryFetchRequest;
}

export namespace _DictionaryFetchRequest {
  export type AsObject = {
    dictionaryName: Uint8Array | string,
  }
}

export class _DictionaryFieldValuePair extends jspb.Message {
  getField(): Uint8Array | string;
  getField_asU8(): Uint8Array;
  getField_asB64(): string;
  setField(value: Uint8Array | string): _DictionaryFieldValuePair;

  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): _DictionaryFieldValuePair;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryFieldValuePair.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryFieldValuePair): _DictionaryFieldValuePair.AsObject;
  static serializeBinaryToWriter(message: _DictionaryFieldValuePair, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryFieldValuePair;
  static deserializeBinaryFromReader(message: _DictionaryFieldValuePair, reader: jspb.BinaryReader): _DictionaryFieldValuePair;
}

export namespace _DictionaryFieldValuePair {
  export type AsObject = {
    field: Uint8Array | string,
    value: Uint8Array | string,
  }
}

export class _DictionaryFetchResponse extends jspb.Message {
  getFound(): _DictionaryFetchResponse._Found | undefined;
  setFound(value?: _DictionaryFetchResponse._Found): _DictionaryFetchResponse;
  hasFound(): boolean;
  clearFound(): _DictionaryFetchResponse;

  getMissing(): _DictionaryFetchResponse._Missing | undefined;
  setMissing(value?: _DictionaryFetchResponse._Missing): _DictionaryFetchResponse;
  hasMissing(): boolean;
  clearMissing(): _DictionaryFetchResponse;

  getDictionaryCase(): _DictionaryFetchResponse.DictionaryCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryFetchResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryFetchResponse): _DictionaryFetchResponse.AsObject;
  static serializeBinaryToWriter(message: _DictionaryFetchResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryFetchResponse;
  static deserializeBinaryFromReader(message: _DictionaryFetchResponse, reader: jspb.BinaryReader): _DictionaryFetchResponse;
}

export namespace _DictionaryFetchResponse {
  export type AsObject = {
    found?: _DictionaryFetchResponse._Found.AsObject,
    missing?: _DictionaryFetchResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getItemsList(): Array<_DictionaryFieldValuePair>;
    setItemsList(value: Array<_DictionaryFieldValuePair>): _Found;
    clearItemsList(): _Found;
    addItems(value?: _DictionaryFieldValuePair, index?: number): _DictionaryFieldValuePair;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      itemsList: Array<_DictionaryFieldValuePair.AsObject>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum DictionaryCase { 
    DICTIONARY_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _DictionarySetRequest extends jspb.Message {
  getDictionaryName(): Uint8Array | string;
  getDictionaryName_asU8(): Uint8Array;
  getDictionaryName_asB64(): string;
  setDictionaryName(value: Uint8Array | string): _DictionarySetRequest;

  getItemsList(): Array<_DictionaryFieldValuePair>;
  setItemsList(value: Array<_DictionaryFieldValuePair>): _DictionarySetRequest;
  clearItemsList(): _DictionarySetRequest;
  addItems(value?: _DictionaryFieldValuePair, index?: number): _DictionaryFieldValuePair;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _DictionarySetRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _DictionarySetRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionarySetRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionarySetRequest): _DictionarySetRequest.AsObject;
  static serializeBinaryToWriter(message: _DictionarySetRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionarySetRequest;
  static deserializeBinaryFromReader(message: _DictionarySetRequest, reader: jspb.BinaryReader): _DictionarySetRequest;
}

export namespace _DictionarySetRequest {
  export type AsObject = {
    dictionaryName: Uint8Array | string,
    itemsList: Array<_DictionaryFieldValuePair.AsObject>,
    ttlMilliseconds: number,
    refreshTtl: boolean,
  }
}

export class _DictionarySetResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionarySetResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionarySetResponse): _DictionarySetResponse.AsObject;
  static serializeBinaryToWriter(message: _DictionarySetResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionarySetResponse;
  static deserializeBinaryFromReader(message: _DictionarySetResponse, reader: jspb.BinaryReader): _DictionarySetResponse;
}

export namespace _DictionarySetResponse {
  export type AsObject = {
  }
}

export class _DictionaryIncrementRequest extends jspb.Message {
  getDictionaryName(): Uint8Array | string;
  getDictionaryName_asU8(): Uint8Array;
  getDictionaryName_asB64(): string;
  setDictionaryName(value: Uint8Array | string): _DictionaryIncrementRequest;

  getField(): Uint8Array | string;
  getField_asU8(): Uint8Array;
  getField_asB64(): string;
  setField(value: Uint8Array | string): _DictionaryIncrementRequest;

  getAmount(): number;
  setAmount(value: number): _DictionaryIncrementRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _DictionaryIncrementRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _DictionaryIncrementRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryIncrementRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryIncrementRequest): _DictionaryIncrementRequest.AsObject;
  static serializeBinaryToWriter(message: _DictionaryIncrementRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryIncrementRequest;
  static deserializeBinaryFromReader(message: _DictionaryIncrementRequest, reader: jspb.BinaryReader): _DictionaryIncrementRequest;
}

export namespace _DictionaryIncrementRequest {
  export type AsObject = {
    dictionaryName: Uint8Array | string,
    field: Uint8Array | string,
    amount: number,
    ttlMilliseconds: number,
    refreshTtl: boolean,
  }
}

export class _DictionaryIncrementResponse extends jspb.Message {
  getValue(): number;
  setValue(value: number): _DictionaryIncrementResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryIncrementResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryIncrementResponse): _DictionaryIncrementResponse.AsObject;
  static serializeBinaryToWriter(message: _DictionaryIncrementResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryIncrementResponse;
  static deserializeBinaryFromReader(message: _DictionaryIncrementResponse, reader: jspb.BinaryReader): _DictionaryIncrementResponse;
}

export namespace _DictionaryIncrementResponse {
  export type AsObject = {
    value: number,
  }
}

export class _DictionaryDeleteRequest extends jspb.Message {
  getDictionaryName(): Uint8Array | string;
  getDictionaryName_asU8(): Uint8Array;
  getDictionaryName_asB64(): string;
  setDictionaryName(value: Uint8Array | string): _DictionaryDeleteRequest;

  getSome(): _DictionaryDeleteRequest.Some | undefined;
  setSome(value?: _DictionaryDeleteRequest.Some): _DictionaryDeleteRequest;
  hasSome(): boolean;
  clearSome(): _DictionaryDeleteRequest;

  getAll(): _DictionaryDeleteRequest.All | undefined;
  setAll(value?: _DictionaryDeleteRequest.All): _DictionaryDeleteRequest;
  hasAll(): boolean;
  clearAll(): _DictionaryDeleteRequest;

  getDeleteCase(): _DictionaryDeleteRequest.DeleteCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryDeleteRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryDeleteRequest): _DictionaryDeleteRequest.AsObject;
  static serializeBinaryToWriter(message: _DictionaryDeleteRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryDeleteRequest;
  static deserializeBinaryFromReader(message: _DictionaryDeleteRequest, reader: jspb.BinaryReader): _DictionaryDeleteRequest;
}

export namespace _DictionaryDeleteRequest {
  export type AsObject = {
    dictionaryName: Uint8Array | string,
    some?: _DictionaryDeleteRequest.Some.AsObject,
    all?: _DictionaryDeleteRequest.All.AsObject,
  }

  export class Some extends jspb.Message {
    getFieldsList(): Array<Uint8Array | string>;
    setFieldsList(value: Array<Uint8Array | string>): Some;
    clearFieldsList(): Some;
    addFields(value: Uint8Array | string, index?: number): Some;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): Some.AsObject;
    static toObject(includeInstance: boolean, msg: Some): Some.AsObject;
    static serializeBinaryToWriter(message: Some, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): Some;
    static deserializeBinaryFromReader(message: Some, reader: jspb.BinaryReader): Some;
  }

  export namespace Some {
    export type AsObject = {
      fieldsList: Array<Uint8Array | string>,
    }
  }


  export class All extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): All.AsObject;
    static toObject(includeInstance: boolean, msg: All): All.AsObject;
    static serializeBinaryToWriter(message: All, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): All;
    static deserializeBinaryFromReader(message: All, reader: jspb.BinaryReader): All;
  }

  export namespace All {
    export type AsObject = {
    }
  }


  export enum DeleteCase { 
    DELETE_NOT_SET = 0,
    SOME = 2,
    ALL = 3,
  }
}

export class _DictionaryDeleteResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryDeleteResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryDeleteResponse): _DictionaryDeleteResponse.AsObject;
  static serializeBinaryToWriter(message: _DictionaryDeleteResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryDeleteResponse;
  static deserializeBinaryFromReader(message: _DictionaryDeleteResponse, reader: jspb.BinaryReader): _DictionaryDeleteResponse;
}

export namespace _DictionaryDeleteResponse {
  export type AsObject = {
  }
}

export class _DictionaryLengthRequest extends jspb.Message {
  getDictionaryName(): Uint8Array | string;
  getDictionaryName_asU8(): Uint8Array;
  getDictionaryName_asB64(): string;
  setDictionaryName(value: Uint8Array | string): _DictionaryLengthRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryLengthRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryLengthRequest): _DictionaryLengthRequest.AsObject;
  static serializeBinaryToWriter(message: _DictionaryLengthRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryLengthRequest;
  static deserializeBinaryFromReader(message: _DictionaryLengthRequest, reader: jspb.BinaryReader): _DictionaryLengthRequest;
}

export namespace _DictionaryLengthRequest {
  export type AsObject = {
    dictionaryName: Uint8Array | string,
  }
}

export class _DictionaryLengthResponse extends jspb.Message {
  getFound(): _DictionaryLengthResponse._Found | undefined;
  setFound(value?: _DictionaryLengthResponse._Found): _DictionaryLengthResponse;
  hasFound(): boolean;
  clearFound(): _DictionaryLengthResponse;

  getMissing(): _DictionaryLengthResponse._Missing | undefined;
  setMissing(value?: _DictionaryLengthResponse._Missing): _DictionaryLengthResponse;
  hasMissing(): boolean;
  clearMissing(): _DictionaryLengthResponse;

  getDictionaryCase(): _DictionaryLengthResponse.DictionaryCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DictionaryLengthResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DictionaryLengthResponse): _DictionaryLengthResponse.AsObject;
  static serializeBinaryToWriter(message: _DictionaryLengthResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DictionaryLengthResponse;
  static deserializeBinaryFromReader(message: _DictionaryLengthResponse, reader: jspb.BinaryReader): _DictionaryLengthResponse;
}

export namespace _DictionaryLengthResponse {
  export type AsObject = {
    found?: _DictionaryLengthResponse._Found.AsObject,
    missing?: _DictionaryLengthResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getLength(): number;
    setLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      length: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum DictionaryCase { 
    DICTIONARY_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SetFetchRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetFetchRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetFetchRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetFetchRequest): _SetFetchRequest.AsObject;
  static serializeBinaryToWriter(message: _SetFetchRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetFetchRequest;
  static deserializeBinaryFromReader(message: _SetFetchRequest, reader: jspb.BinaryReader): _SetFetchRequest;
}

export namespace _SetFetchRequest {
  export type AsObject = {
    setName: Uint8Array | string,
  }
}

export class _SetFetchResponse extends jspb.Message {
  getFound(): _SetFetchResponse._Found | undefined;
  setFound(value?: _SetFetchResponse._Found): _SetFetchResponse;
  hasFound(): boolean;
  clearFound(): _SetFetchResponse;

  getMissing(): _SetFetchResponse._Missing | undefined;
  setMissing(value?: _SetFetchResponse._Missing): _SetFetchResponse;
  hasMissing(): boolean;
  clearMissing(): _SetFetchResponse;

  getSetCase(): _SetFetchResponse.SetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetFetchResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetFetchResponse): _SetFetchResponse.AsObject;
  static serializeBinaryToWriter(message: _SetFetchResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetFetchResponse;
  static deserializeBinaryFromReader(message: _SetFetchResponse, reader: jspb.BinaryReader): _SetFetchResponse;
}

export namespace _SetFetchResponse {
  export type AsObject = {
    found?: _SetFetchResponse._Found.AsObject,
    missing?: _SetFetchResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getElementsList(): Array<Uint8Array | string>;
    setElementsList(value: Array<Uint8Array | string>): _Found;
    clearElementsList(): _Found;
    addElements(value: Uint8Array | string, index?: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      elementsList: Array<Uint8Array | string>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SetCase { 
    SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SetSampleRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetSampleRequest;

  getLimit(): number;
  setLimit(value: number): _SetSampleRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetSampleRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetSampleRequest): _SetSampleRequest.AsObject;
  static serializeBinaryToWriter(message: _SetSampleRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetSampleRequest;
  static deserializeBinaryFromReader(message: _SetSampleRequest, reader: jspb.BinaryReader): _SetSampleRequest;
}

export namespace _SetSampleRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    limit: number,
  }
}

export class _SetSampleResponse extends jspb.Message {
  getFound(): _SetSampleResponse._Found | undefined;
  setFound(value?: _SetSampleResponse._Found): _SetSampleResponse;
  hasFound(): boolean;
  clearFound(): _SetSampleResponse;

  getMissing(): _SetSampleResponse._Missing | undefined;
  setMissing(value?: _SetSampleResponse._Missing): _SetSampleResponse;
  hasMissing(): boolean;
  clearMissing(): _SetSampleResponse;

  getSetCase(): _SetSampleResponse.SetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetSampleResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetSampleResponse): _SetSampleResponse.AsObject;
  static serializeBinaryToWriter(message: _SetSampleResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetSampleResponse;
  static deserializeBinaryFromReader(message: _SetSampleResponse, reader: jspb.BinaryReader): _SetSampleResponse;
}

export namespace _SetSampleResponse {
  export type AsObject = {
    found?: _SetSampleResponse._Found.AsObject,
    missing?: _SetSampleResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getElementsList(): Array<Uint8Array | string>;
    setElementsList(value: Array<Uint8Array | string>): _Found;
    clearElementsList(): _Found;
    addElements(value: Uint8Array | string, index?: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      elementsList: Array<Uint8Array | string>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SetCase { 
    SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SetUnionRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetUnionRequest;

  getElementsList(): Array<Uint8Array | string>;
  setElementsList(value: Array<Uint8Array | string>): _SetUnionRequest;
  clearElementsList(): _SetUnionRequest;
  addElements(value: Uint8Array | string, index?: number): _SetUnionRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SetUnionRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _SetUnionRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetUnionRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetUnionRequest): _SetUnionRequest.AsObject;
  static serializeBinaryToWriter(message: _SetUnionRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetUnionRequest;
  static deserializeBinaryFromReader(message: _SetUnionRequest, reader: jspb.BinaryReader): _SetUnionRequest;
}

export namespace _SetUnionRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    elementsList: Array<Uint8Array | string>,
    ttlMilliseconds: number,
    refreshTtl: boolean,
  }
}

export class _SetUnionResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetUnionResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetUnionResponse): _SetUnionResponse.AsObject;
  static serializeBinaryToWriter(message: _SetUnionResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetUnionResponse;
  static deserializeBinaryFromReader(message: _SetUnionResponse, reader: jspb.BinaryReader): _SetUnionResponse;
}

export namespace _SetUnionResponse {
  export type AsObject = {
  }
}

export class _SetDifferenceRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetDifferenceRequest;

  getMinuend(): _SetDifferenceRequest._Minuend | undefined;
  setMinuend(value?: _SetDifferenceRequest._Minuend): _SetDifferenceRequest;
  hasMinuend(): boolean;
  clearMinuend(): _SetDifferenceRequest;

  getSubtrahend(): _SetDifferenceRequest._Subtrahend | undefined;
  setSubtrahend(value?: _SetDifferenceRequest._Subtrahend): _SetDifferenceRequest;
  hasSubtrahend(): boolean;
  clearSubtrahend(): _SetDifferenceRequest;

  getDifferenceCase(): _SetDifferenceRequest.DifferenceCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetDifferenceRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetDifferenceRequest): _SetDifferenceRequest.AsObject;
  static serializeBinaryToWriter(message: _SetDifferenceRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetDifferenceRequest;
  static deserializeBinaryFromReader(message: _SetDifferenceRequest, reader: jspb.BinaryReader): _SetDifferenceRequest;
}

export namespace _SetDifferenceRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    minuend?: _SetDifferenceRequest._Minuend.AsObject,
    subtrahend?: _SetDifferenceRequest._Subtrahend.AsObject,
  }

  export class _Minuend extends jspb.Message {
    getElementsList(): Array<Uint8Array | string>;
    setElementsList(value: Array<Uint8Array | string>): _Minuend;
    clearElementsList(): _Minuend;
    addElements(value: Uint8Array | string, index?: number): _Minuend;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Minuend.AsObject;
    static toObject(includeInstance: boolean, msg: _Minuend): _Minuend.AsObject;
    static serializeBinaryToWriter(message: _Minuend, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Minuend;
    static deserializeBinaryFromReader(message: _Minuend, reader: jspb.BinaryReader): _Minuend;
  }

  export namespace _Minuend {
    export type AsObject = {
      elementsList: Array<Uint8Array | string>,
    }
  }


  export class _Subtrahend extends jspb.Message {
    getSet(): _SetDifferenceRequest._Subtrahend._Set | undefined;
    setSet(value?: _SetDifferenceRequest._Subtrahend._Set): _Subtrahend;
    hasSet(): boolean;
    clearSet(): _Subtrahend;

    getIdentity(): _SetDifferenceRequest._Subtrahend._Identity | undefined;
    setIdentity(value?: _SetDifferenceRequest._Subtrahend._Identity): _Subtrahend;
    hasIdentity(): boolean;
    clearIdentity(): _Subtrahend;

    getSubtrahendSetCase(): _Subtrahend.SubtrahendSetCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Subtrahend.AsObject;
    static toObject(includeInstance: boolean, msg: _Subtrahend): _Subtrahend.AsObject;
    static serializeBinaryToWriter(message: _Subtrahend, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Subtrahend;
    static deserializeBinaryFromReader(message: _Subtrahend, reader: jspb.BinaryReader): _Subtrahend;
  }

  export namespace _Subtrahend {
    export type AsObject = {
      set?: _SetDifferenceRequest._Subtrahend._Set.AsObject,
      identity?: _SetDifferenceRequest._Subtrahend._Identity.AsObject,
    }

    export class _Set extends jspb.Message {
      getElementsList(): Array<Uint8Array | string>;
      setElementsList(value: Array<Uint8Array | string>): _Set;
      clearElementsList(): _Set;
      addElements(value: Uint8Array | string, index?: number): _Set;

      serializeBinary(): Uint8Array;
      toObject(includeInstance?: boolean): _Set.AsObject;
      static toObject(includeInstance: boolean, msg: _Set): _Set.AsObject;
      static serializeBinaryToWriter(message: _Set, writer: jspb.BinaryWriter): void;
      static deserializeBinary(bytes: Uint8Array): _Set;
      static deserializeBinaryFromReader(message: _Set, reader: jspb.BinaryReader): _Set;
    }

    export namespace _Set {
      export type AsObject = {
        elementsList: Array<Uint8Array | string>,
      }
    }


    export class _Identity extends jspb.Message {
      serializeBinary(): Uint8Array;
      toObject(includeInstance?: boolean): _Identity.AsObject;
      static toObject(includeInstance: boolean, msg: _Identity): _Identity.AsObject;
      static serializeBinaryToWriter(message: _Identity, writer: jspb.BinaryWriter): void;
      static deserializeBinary(bytes: Uint8Array): _Identity;
      static deserializeBinaryFromReader(message: _Identity, reader: jspb.BinaryReader): _Identity;
    }

    export namespace _Identity {
      export type AsObject = {
      }
    }


    export enum SubtrahendSetCase { 
      SUBTRAHEND_SET_NOT_SET = 0,
      SET = 1,
      IDENTITY = 2,
    }
  }


  export enum DifferenceCase { 
    DIFFERENCE_NOT_SET = 0,
    MINUEND = 2,
    SUBTRAHEND = 3,
  }
}

export class _SetDifferenceResponse extends jspb.Message {
  getFound(): _SetDifferenceResponse._Found | undefined;
  setFound(value?: _SetDifferenceResponse._Found): _SetDifferenceResponse;
  hasFound(): boolean;
  clearFound(): _SetDifferenceResponse;

  getMissing(): _SetDifferenceResponse._Missing | undefined;
  setMissing(value?: _SetDifferenceResponse._Missing): _SetDifferenceResponse;
  hasMissing(): boolean;
  clearMissing(): _SetDifferenceResponse;

  getSetCase(): _SetDifferenceResponse.SetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetDifferenceResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetDifferenceResponse): _SetDifferenceResponse.AsObject;
  static serializeBinaryToWriter(message: _SetDifferenceResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetDifferenceResponse;
  static deserializeBinaryFromReader(message: _SetDifferenceResponse, reader: jspb.BinaryReader): _SetDifferenceResponse;
}

export namespace _SetDifferenceResponse {
  export type AsObject = {
    found?: _SetDifferenceResponse._Found.AsObject,
    missing?: _SetDifferenceResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SetCase { 
    SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SetContainsRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetContainsRequest;

  getElementsList(): Array<Uint8Array | string>;
  setElementsList(value: Array<Uint8Array | string>): _SetContainsRequest;
  clearElementsList(): _SetContainsRequest;
  addElements(value: Uint8Array | string, index?: number): _SetContainsRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetContainsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetContainsRequest): _SetContainsRequest.AsObject;
  static serializeBinaryToWriter(message: _SetContainsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetContainsRequest;
  static deserializeBinaryFromReader(message: _SetContainsRequest, reader: jspb.BinaryReader): _SetContainsRequest;
}

export namespace _SetContainsRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    elementsList: Array<Uint8Array | string>,
  }
}

export class _SetContainsResponse extends jspb.Message {
  getFound(): _SetContainsResponse._Found | undefined;
  setFound(value?: _SetContainsResponse._Found): _SetContainsResponse;
  hasFound(): boolean;
  clearFound(): _SetContainsResponse;

  getMissing(): _SetContainsResponse._Missing | undefined;
  setMissing(value?: _SetContainsResponse._Missing): _SetContainsResponse;
  hasMissing(): boolean;
  clearMissing(): _SetContainsResponse;

  getSetCase(): _SetContainsResponse.SetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetContainsResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetContainsResponse): _SetContainsResponse.AsObject;
  static serializeBinaryToWriter(message: _SetContainsResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetContainsResponse;
  static deserializeBinaryFromReader(message: _SetContainsResponse, reader: jspb.BinaryReader): _SetContainsResponse;
}

export namespace _SetContainsResponse {
  export type AsObject = {
    found?: _SetContainsResponse._Found.AsObject,
    missing?: _SetContainsResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getContainsList(): Array<boolean>;
    setContainsList(value: Array<boolean>): _Found;
    clearContainsList(): _Found;
    addContains(value: boolean, index?: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      containsList: Array<boolean>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SetCase { 
    SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SetLengthRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetLengthRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetLengthRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetLengthRequest): _SetLengthRequest.AsObject;
  static serializeBinaryToWriter(message: _SetLengthRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetLengthRequest;
  static deserializeBinaryFromReader(message: _SetLengthRequest, reader: jspb.BinaryReader): _SetLengthRequest;
}

export namespace _SetLengthRequest {
  export type AsObject = {
    setName: Uint8Array | string,
  }
}

export class _SetLengthResponse extends jspb.Message {
  getFound(): _SetLengthResponse._Found | undefined;
  setFound(value?: _SetLengthResponse._Found): _SetLengthResponse;
  hasFound(): boolean;
  clearFound(): _SetLengthResponse;

  getMissing(): _SetLengthResponse._Missing | undefined;
  setMissing(value?: _SetLengthResponse._Missing): _SetLengthResponse;
  hasMissing(): boolean;
  clearMissing(): _SetLengthResponse;

  getSetCase(): _SetLengthResponse.SetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetLengthResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetLengthResponse): _SetLengthResponse.AsObject;
  static serializeBinaryToWriter(message: _SetLengthResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetLengthResponse;
  static deserializeBinaryFromReader(message: _SetLengthResponse, reader: jspb.BinaryReader): _SetLengthResponse;
}

export namespace _SetLengthResponse {
  export type AsObject = {
    found?: _SetLengthResponse._Found.AsObject,
    missing?: _SetLengthResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getLength(): number;
    setLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      length: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SetCase { 
    SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SetPopRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SetPopRequest;

  getCount(): number;
  setCount(value: number): _SetPopRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetPopRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SetPopRequest): _SetPopRequest.AsObject;
  static serializeBinaryToWriter(message: _SetPopRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetPopRequest;
  static deserializeBinaryFromReader(message: _SetPopRequest, reader: jspb.BinaryReader): _SetPopRequest;
}

export namespace _SetPopRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    count: number,
  }
}

export class _SetPopResponse extends jspb.Message {
  getFound(): _SetPopResponse._Found | undefined;
  setFound(value?: _SetPopResponse._Found): _SetPopResponse;
  hasFound(): boolean;
  clearFound(): _SetPopResponse;

  getMissing(): _SetPopResponse._Missing | undefined;
  setMissing(value?: _SetPopResponse._Missing): _SetPopResponse;
  hasMissing(): boolean;
  clearMissing(): _SetPopResponse;

  getSetCase(): _SetPopResponse.SetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SetPopResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SetPopResponse): _SetPopResponse.AsObject;
  static serializeBinaryToWriter(message: _SetPopResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SetPopResponse;
  static deserializeBinaryFromReader(message: _SetPopResponse, reader: jspb.BinaryReader): _SetPopResponse;
}

export namespace _SetPopResponse {
  export type AsObject = {
    found?: _SetPopResponse._Found.AsObject,
    missing?: _SetPopResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getElementsList(): Array<Uint8Array | string>;
    setElementsList(value: Array<Uint8Array | string>): _Found;
    clearElementsList(): _Found;
    addElements(value: Uint8Array | string, index?: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      elementsList: Array<Uint8Array | string>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SetCase { 
    SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListConcatenateFrontRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListConcatenateFrontRequest;

  getValuesList(): Array<Uint8Array | string>;
  setValuesList(value: Array<Uint8Array | string>): _ListConcatenateFrontRequest;
  clearValuesList(): _ListConcatenateFrontRequest;
  addValues(value: Uint8Array | string, index?: number): _ListConcatenateFrontRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _ListConcatenateFrontRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _ListConcatenateFrontRequest;

  getTruncateBackToSize(): number;
  setTruncateBackToSize(value: number): _ListConcatenateFrontRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListConcatenateFrontRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListConcatenateFrontRequest): _ListConcatenateFrontRequest.AsObject;
  static serializeBinaryToWriter(message: _ListConcatenateFrontRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListConcatenateFrontRequest;
  static deserializeBinaryFromReader(message: _ListConcatenateFrontRequest, reader: jspb.BinaryReader): _ListConcatenateFrontRequest;
}

export namespace _ListConcatenateFrontRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    valuesList: Array<Uint8Array | string>,
    ttlMilliseconds: number,
    refreshTtl: boolean,
    truncateBackToSize: number,
  }
}

export class _ListConcatenateFrontResponse extends jspb.Message {
  getListLength(): number;
  setListLength(value: number): _ListConcatenateFrontResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListConcatenateFrontResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListConcatenateFrontResponse): _ListConcatenateFrontResponse.AsObject;
  static serializeBinaryToWriter(message: _ListConcatenateFrontResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListConcatenateFrontResponse;
  static deserializeBinaryFromReader(message: _ListConcatenateFrontResponse, reader: jspb.BinaryReader): _ListConcatenateFrontResponse;
}

export namespace _ListConcatenateFrontResponse {
  export type AsObject = {
    listLength: number,
  }
}

export class _ListConcatenateBackRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListConcatenateBackRequest;

  getValuesList(): Array<Uint8Array | string>;
  setValuesList(value: Array<Uint8Array | string>): _ListConcatenateBackRequest;
  clearValuesList(): _ListConcatenateBackRequest;
  addValues(value: Uint8Array | string, index?: number): _ListConcatenateBackRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _ListConcatenateBackRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _ListConcatenateBackRequest;

  getTruncateFrontToSize(): number;
  setTruncateFrontToSize(value: number): _ListConcatenateBackRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListConcatenateBackRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListConcatenateBackRequest): _ListConcatenateBackRequest.AsObject;
  static serializeBinaryToWriter(message: _ListConcatenateBackRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListConcatenateBackRequest;
  static deserializeBinaryFromReader(message: _ListConcatenateBackRequest, reader: jspb.BinaryReader): _ListConcatenateBackRequest;
}

export namespace _ListConcatenateBackRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    valuesList: Array<Uint8Array | string>,
    ttlMilliseconds: number,
    refreshTtl: boolean,
    truncateFrontToSize: number,
  }
}

export class _ListConcatenateBackResponse extends jspb.Message {
  getListLength(): number;
  setListLength(value: number): _ListConcatenateBackResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListConcatenateBackResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListConcatenateBackResponse): _ListConcatenateBackResponse.AsObject;
  static serializeBinaryToWriter(message: _ListConcatenateBackResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListConcatenateBackResponse;
  static deserializeBinaryFromReader(message: _ListConcatenateBackResponse, reader: jspb.BinaryReader): _ListConcatenateBackResponse;
}

export namespace _ListConcatenateBackResponse {
  export type AsObject = {
    listLength: number,
  }
}

export class _ListPushFrontRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListPushFrontRequest;

  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): _ListPushFrontRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _ListPushFrontRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _ListPushFrontRequest;

  getTruncateBackToSize(): number;
  setTruncateBackToSize(value: number): _ListPushFrontRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPushFrontRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPushFrontRequest): _ListPushFrontRequest.AsObject;
  static serializeBinaryToWriter(message: _ListPushFrontRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPushFrontRequest;
  static deserializeBinaryFromReader(message: _ListPushFrontRequest, reader: jspb.BinaryReader): _ListPushFrontRequest;
}

export namespace _ListPushFrontRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    value: Uint8Array | string,
    ttlMilliseconds: number,
    refreshTtl: boolean,
    truncateBackToSize: number,
  }
}

export class _ListPushFrontResponse extends jspb.Message {
  getListLength(): number;
  setListLength(value: number): _ListPushFrontResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPushFrontResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPushFrontResponse): _ListPushFrontResponse.AsObject;
  static serializeBinaryToWriter(message: _ListPushFrontResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPushFrontResponse;
  static deserializeBinaryFromReader(message: _ListPushFrontResponse, reader: jspb.BinaryReader): _ListPushFrontResponse;
}

export namespace _ListPushFrontResponse {
  export type AsObject = {
    listLength: number,
  }
}

export class _ListPushBackRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListPushBackRequest;

  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): _ListPushBackRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _ListPushBackRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _ListPushBackRequest;

  getTruncateFrontToSize(): number;
  setTruncateFrontToSize(value: number): _ListPushBackRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPushBackRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPushBackRequest): _ListPushBackRequest.AsObject;
  static serializeBinaryToWriter(message: _ListPushBackRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPushBackRequest;
  static deserializeBinaryFromReader(message: _ListPushBackRequest, reader: jspb.BinaryReader): _ListPushBackRequest;
}

export namespace _ListPushBackRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    value: Uint8Array | string,
    ttlMilliseconds: number,
    refreshTtl: boolean,
    truncateFrontToSize: number,
  }
}

export class _ListPushBackResponse extends jspb.Message {
  getListLength(): number;
  setListLength(value: number): _ListPushBackResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPushBackResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPushBackResponse): _ListPushBackResponse.AsObject;
  static serializeBinaryToWriter(message: _ListPushBackResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPushBackResponse;
  static deserializeBinaryFromReader(message: _ListPushBackResponse, reader: jspb.BinaryReader): _ListPushBackResponse;
}

export namespace _ListPushBackResponse {
  export type AsObject = {
    listLength: number,
  }
}

export class _ListPopFrontRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListPopFrontRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPopFrontRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPopFrontRequest): _ListPopFrontRequest.AsObject;
  static serializeBinaryToWriter(message: _ListPopFrontRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPopFrontRequest;
  static deserializeBinaryFromReader(message: _ListPopFrontRequest, reader: jspb.BinaryReader): _ListPopFrontRequest;
}

export namespace _ListPopFrontRequest {
  export type AsObject = {
    listName: Uint8Array | string,
  }
}

export class _ListPopFrontResponse extends jspb.Message {
  getFound(): _ListPopFrontResponse._Found | undefined;
  setFound(value?: _ListPopFrontResponse._Found): _ListPopFrontResponse;
  hasFound(): boolean;
  clearFound(): _ListPopFrontResponse;

  getMissing(): _ListPopFrontResponse._Missing | undefined;
  setMissing(value?: _ListPopFrontResponse._Missing): _ListPopFrontResponse;
  hasMissing(): boolean;
  clearMissing(): _ListPopFrontResponse;

  getListCase(): _ListPopFrontResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPopFrontResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPopFrontResponse): _ListPopFrontResponse.AsObject;
  static serializeBinaryToWriter(message: _ListPopFrontResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPopFrontResponse;
  static deserializeBinaryFromReader(message: _ListPopFrontResponse, reader: jspb.BinaryReader): _ListPopFrontResponse;
}

export namespace _ListPopFrontResponse {
  export type AsObject = {
    found?: _ListPopFrontResponse._Found.AsObject,
    missing?: _ListPopFrontResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getFront(): Uint8Array | string;
    getFront_asU8(): Uint8Array;
    getFront_asB64(): string;
    setFront(value: Uint8Array | string): _Found;

    getListLength(): number;
    setListLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      front: Uint8Array | string,
      listLength: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListPopBackRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListPopBackRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPopBackRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPopBackRequest): _ListPopBackRequest.AsObject;
  static serializeBinaryToWriter(message: _ListPopBackRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPopBackRequest;
  static deserializeBinaryFromReader(message: _ListPopBackRequest, reader: jspb.BinaryReader): _ListPopBackRequest;
}

export namespace _ListPopBackRequest {
  export type AsObject = {
    listName: Uint8Array | string,
  }
}

export class _ListPopBackResponse extends jspb.Message {
  getFound(): _ListPopBackResponse._Found | undefined;
  setFound(value?: _ListPopBackResponse._Found): _ListPopBackResponse;
  hasFound(): boolean;
  clearFound(): _ListPopBackResponse;

  getMissing(): _ListPopBackResponse._Missing | undefined;
  setMissing(value?: _ListPopBackResponse._Missing): _ListPopBackResponse;
  hasMissing(): boolean;
  clearMissing(): _ListPopBackResponse;

  getListCase(): _ListPopBackResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListPopBackResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListPopBackResponse): _ListPopBackResponse.AsObject;
  static serializeBinaryToWriter(message: _ListPopBackResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListPopBackResponse;
  static deserializeBinaryFromReader(message: _ListPopBackResponse, reader: jspb.BinaryReader): _ListPopBackResponse;
}

export namespace _ListPopBackResponse {
  export type AsObject = {
    found?: _ListPopBackResponse._Found.AsObject,
    missing?: _ListPopBackResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getBack(): Uint8Array | string;
    getBack_asU8(): Uint8Array;
    getBack_asB64(): string;
    setBack(value: Uint8Array | string): _Found;

    getListLength(): number;
    setListLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      back: Uint8Array | string,
      listLength: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListRange extends jspb.Message {
  getBeginIndex(): number;
  setBeginIndex(value: number): _ListRange;

  getCount(): number;
  setCount(value: number): _ListRange;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListRange.AsObject;
  static toObject(includeInstance: boolean, msg: _ListRange): _ListRange.AsObject;
  static serializeBinaryToWriter(message: _ListRange, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListRange;
  static deserializeBinaryFromReader(message: _ListRange, reader: jspb.BinaryReader): _ListRange;
}

export namespace _ListRange {
  export type AsObject = {
    beginIndex: number,
    count: number,
  }
}

export class _ListEraseRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListEraseRequest;

  getSome(): _ListEraseRequest._ListRanges | undefined;
  setSome(value?: _ListEraseRequest._ListRanges): _ListEraseRequest;
  hasSome(): boolean;
  clearSome(): _ListEraseRequest;

  getAll(): _ListEraseRequest._All | undefined;
  setAll(value?: _ListEraseRequest._All): _ListEraseRequest;
  hasAll(): boolean;
  clearAll(): _ListEraseRequest;

  getEraseCase(): _ListEraseRequest.EraseCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListEraseRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListEraseRequest): _ListEraseRequest.AsObject;
  static serializeBinaryToWriter(message: _ListEraseRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListEraseRequest;
  static deserializeBinaryFromReader(message: _ListEraseRequest, reader: jspb.BinaryReader): _ListEraseRequest;
}

export namespace _ListEraseRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    some?: _ListEraseRequest._ListRanges.AsObject,
    all?: _ListEraseRequest._All.AsObject,
  }

  export class _All extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _All.AsObject;
    static toObject(includeInstance: boolean, msg: _All): _All.AsObject;
    static serializeBinaryToWriter(message: _All, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _All;
    static deserializeBinaryFromReader(message: _All, reader: jspb.BinaryReader): _All;
  }

  export namespace _All {
    export type AsObject = {
    }
  }


  export class _ListRanges extends jspb.Message {
    getRangesList(): Array<_ListRange>;
    setRangesList(value: Array<_ListRange>): _ListRanges;
    clearRangesList(): _ListRanges;
    addRanges(value?: _ListRange, index?: number): _ListRange;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _ListRanges.AsObject;
    static toObject(includeInstance: boolean, msg: _ListRanges): _ListRanges.AsObject;
    static serializeBinaryToWriter(message: _ListRanges, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _ListRanges;
    static deserializeBinaryFromReader(message: _ListRanges, reader: jspb.BinaryReader): _ListRanges;
  }

  export namespace _ListRanges {
    export type AsObject = {
      rangesList: Array<_ListRange.AsObject>,
    }
  }


  export enum EraseCase { 
    ERASE_NOT_SET = 0,
    SOME = 2,
    ALL = 3,
  }
}

export class _ListEraseResponse extends jspb.Message {
  getFound(): _ListEraseResponse._Found | undefined;
  setFound(value?: _ListEraseResponse._Found): _ListEraseResponse;
  hasFound(): boolean;
  clearFound(): _ListEraseResponse;

  getMissing(): _ListEraseResponse._Missing | undefined;
  setMissing(value?: _ListEraseResponse._Missing): _ListEraseResponse;
  hasMissing(): boolean;
  clearMissing(): _ListEraseResponse;

  getListCase(): _ListEraseResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListEraseResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListEraseResponse): _ListEraseResponse.AsObject;
  static serializeBinaryToWriter(message: _ListEraseResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListEraseResponse;
  static deserializeBinaryFromReader(message: _ListEraseResponse, reader: jspb.BinaryReader): _ListEraseResponse;
}

export namespace _ListEraseResponse {
  export type AsObject = {
    found?: _ListEraseResponse._Found.AsObject,
    missing?: _ListEraseResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getListLength(): number;
    setListLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      listLength: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListRemoveRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListRemoveRequest;

  getAllElementsWithValue(): Uint8Array | string;
  getAllElementsWithValue_asU8(): Uint8Array;
  getAllElementsWithValue_asB64(): string;
  setAllElementsWithValue(value: Uint8Array | string): _ListRemoveRequest;

  getRemoveCase(): _ListRemoveRequest.RemoveCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListRemoveRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListRemoveRequest): _ListRemoveRequest.AsObject;
  static serializeBinaryToWriter(message: _ListRemoveRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListRemoveRequest;
  static deserializeBinaryFromReader(message: _ListRemoveRequest, reader: jspb.BinaryReader): _ListRemoveRequest;
}

export namespace _ListRemoveRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    allElementsWithValue: Uint8Array | string,
  }

  export enum RemoveCase { 
    REMOVE_NOT_SET = 0,
    ALL_ELEMENTS_WITH_VALUE = 2,
  }
}

export class _ListRemoveResponse extends jspb.Message {
  getFound(): _ListRemoveResponse._Found | undefined;
  setFound(value?: _ListRemoveResponse._Found): _ListRemoveResponse;
  hasFound(): boolean;
  clearFound(): _ListRemoveResponse;

  getMissing(): _ListRemoveResponse._Missing | undefined;
  setMissing(value?: _ListRemoveResponse._Missing): _ListRemoveResponse;
  hasMissing(): boolean;
  clearMissing(): _ListRemoveResponse;

  getListCase(): _ListRemoveResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListRemoveResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListRemoveResponse): _ListRemoveResponse.AsObject;
  static serializeBinaryToWriter(message: _ListRemoveResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListRemoveResponse;
  static deserializeBinaryFromReader(message: _ListRemoveResponse, reader: jspb.BinaryReader): _ListRemoveResponse;
}

export namespace _ListRemoveResponse {
  export type AsObject = {
    found?: _ListRemoveResponse._Found.AsObject,
    missing?: _ListRemoveResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getListLength(): number;
    setListLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      listLength: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListFetchRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListFetchRequest;

  getUnboundedStart(): common_pb._Unbounded | undefined;
  setUnboundedStart(value?: common_pb._Unbounded): _ListFetchRequest;
  hasUnboundedStart(): boolean;
  clearUnboundedStart(): _ListFetchRequest;

  getInclusiveStart(): number;
  setInclusiveStart(value: number): _ListFetchRequest;

  getUnboundedEnd(): common_pb._Unbounded | undefined;
  setUnboundedEnd(value?: common_pb._Unbounded): _ListFetchRequest;
  hasUnboundedEnd(): boolean;
  clearUnboundedEnd(): _ListFetchRequest;

  getExclusiveEnd(): number;
  setExclusiveEnd(value: number): _ListFetchRequest;

  getStartIndexCase(): _ListFetchRequest.StartIndexCase;

  getEndIndexCase(): _ListFetchRequest.EndIndexCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListFetchRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListFetchRequest): _ListFetchRequest.AsObject;
  static serializeBinaryToWriter(message: _ListFetchRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListFetchRequest;
  static deserializeBinaryFromReader(message: _ListFetchRequest, reader: jspb.BinaryReader): _ListFetchRequest;
}

export namespace _ListFetchRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    unboundedStart?: common_pb._Unbounded.AsObject,
    inclusiveStart: number,
    unboundedEnd?: common_pb._Unbounded.AsObject,
    exclusiveEnd: number,
  }

  export enum StartIndexCase { 
    START_INDEX_NOT_SET = 0,
    UNBOUNDED_START = 2,
    INCLUSIVE_START = 3,
  }

  export enum EndIndexCase { 
    END_INDEX_NOT_SET = 0,
    UNBOUNDED_END = 4,
    EXCLUSIVE_END = 5,
  }
}

export class _ListRetainRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListRetainRequest;

  getUnboundedStart(): common_pb._Unbounded | undefined;
  setUnboundedStart(value?: common_pb._Unbounded): _ListRetainRequest;
  hasUnboundedStart(): boolean;
  clearUnboundedStart(): _ListRetainRequest;

  getInclusiveStart(): number;
  setInclusiveStart(value: number): _ListRetainRequest;

  getUnboundedEnd(): common_pb._Unbounded | undefined;
  setUnboundedEnd(value?: common_pb._Unbounded): _ListRetainRequest;
  hasUnboundedEnd(): boolean;
  clearUnboundedEnd(): _ListRetainRequest;

  getExclusiveEnd(): number;
  setExclusiveEnd(value: number): _ListRetainRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _ListRetainRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _ListRetainRequest;

  getStartIndexCase(): _ListRetainRequest.StartIndexCase;

  getEndIndexCase(): _ListRetainRequest.EndIndexCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListRetainRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListRetainRequest): _ListRetainRequest.AsObject;
  static serializeBinaryToWriter(message: _ListRetainRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListRetainRequest;
  static deserializeBinaryFromReader(message: _ListRetainRequest, reader: jspb.BinaryReader): _ListRetainRequest;
}

export namespace _ListRetainRequest {
  export type AsObject = {
    listName: Uint8Array | string,
    unboundedStart?: common_pb._Unbounded.AsObject,
    inclusiveStart: number,
    unboundedEnd?: common_pb._Unbounded.AsObject,
    exclusiveEnd: number,
    ttlMilliseconds: number,
    refreshTtl: boolean,
  }

  export enum StartIndexCase { 
    START_INDEX_NOT_SET = 0,
    UNBOUNDED_START = 2,
    INCLUSIVE_START = 3,
  }

  export enum EndIndexCase { 
    END_INDEX_NOT_SET = 0,
    UNBOUNDED_END = 4,
    EXCLUSIVE_END = 5,
  }
}

export class _ListRetainResponse extends jspb.Message {
  getFound(): _ListRetainResponse._Found | undefined;
  setFound(value?: _ListRetainResponse._Found): _ListRetainResponse;
  hasFound(): boolean;
  clearFound(): _ListRetainResponse;

  getMissing(): _ListRetainResponse._Missing | undefined;
  setMissing(value?: _ListRetainResponse._Missing): _ListRetainResponse;
  hasMissing(): boolean;
  clearMissing(): _ListRetainResponse;

  getListCase(): _ListRetainResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListRetainResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListRetainResponse): _ListRetainResponse.AsObject;
  static serializeBinaryToWriter(message: _ListRetainResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListRetainResponse;
  static deserializeBinaryFromReader(message: _ListRetainResponse, reader: jspb.BinaryReader): _ListRetainResponse;
}

export namespace _ListRetainResponse {
  export type AsObject = {
    found?: _ListRetainResponse._Found.AsObject,
    missing?: _ListRetainResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getListLength(): number;
    setListLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      listLength: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListFetchResponse extends jspb.Message {
  getFound(): _ListFetchResponse._Found | undefined;
  setFound(value?: _ListFetchResponse._Found): _ListFetchResponse;
  hasFound(): boolean;
  clearFound(): _ListFetchResponse;

  getMissing(): _ListFetchResponse._Missing | undefined;
  setMissing(value?: _ListFetchResponse._Missing): _ListFetchResponse;
  hasMissing(): boolean;
  clearMissing(): _ListFetchResponse;

  getListCase(): _ListFetchResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListFetchResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListFetchResponse): _ListFetchResponse.AsObject;
  static serializeBinaryToWriter(message: _ListFetchResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListFetchResponse;
  static deserializeBinaryFromReader(message: _ListFetchResponse, reader: jspb.BinaryReader): _ListFetchResponse;
}

export namespace _ListFetchResponse {
  export type AsObject = {
    found?: _ListFetchResponse._Found.AsObject,
    missing?: _ListFetchResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getValuesList(): Array<Uint8Array | string>;
    setValuesList(value: Array<Uint8Array | string>): _Found;
    clearValuesList(): _Found;
    addValues(value: Uint8Array | string, index?: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      valuesList: Array<Uint8Array | string>,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _ListLengthRequest extends jspb.Message {
  getListName(): Uint8Array | string;
  getListName_asU8(): Uint8Array;
  getListName_asB64(): string;
  setListName(value: Uint8Array | string): _ListLengthRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListLengthRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListLengthRequest): _ListLengthRequest.AsObject;
  static serializeBinaryToWriter(message: _ListLengthRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListLengthRequest;
  static deserializeBinaryFromReader(message: _ListLengthRequest, reader: jspb.BinaryReader): _ListLengthRequest;
}

export namespace _ListLengthRequest {
  export type AsObject = {
    listName: Uint8Array | string,
  }
}

export class _ListLengthResponse extends jspb.Message {
  getFound(): _ListLengthResponse._Found | undefined;
  setFound(value?: _ListLengthResponse._Found): _ListLengthResponse;
  hasFound(): boolean;
  clearFound(): _ListLengthResponse;

  getMissing(): _ListLengthResponse._Missing | undefined;
  setMissing(value?: _ListLengthResponse._Missing): _ListLengthResponse;
  hasMissing(): boolean;
  clearMissing(): _ListLengthResponse;

  getListCase(): _ListLengthResponse.ListCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListLengthResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListLengthResponse): _ListLengthResponse.AsObject;
  static serializeBinaryToWriter(message: _ListLengthResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListLengthResponse;
  static deserializeBinaryFromReader(message: _ListLengthResponse, reader: jspb.BinaryReader): _ListLengthResponse;
}

export namespace _ListLengthResponse {
  export type AsObject = {
    found?: _ListLengthResponse._Found.AsObject,
    missing?: _ListLengthResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getLength(): number;
    setLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      length: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum ListCase { 
    LIST_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SortedSetElement extends jspb.Message {
  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): _SortedSetElement;

  getScore(): number;
  setScore(value: number): _SortedSetElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetElement.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetElement): _SortedSetElement.AsObject;
  static serializeBinaryToWriter(message: _SortedSetElement, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetElement;
  static deserializeBinaryFromReader(message: _SortedSetElement, reader: jspb.BinaryReader): _SortedSetElement;
}

export namespace _SortedSetElement {
  export type AsObject = {
    value: Uint8Array | string,
    score: number,
  }
}

export class _SortedSetPutRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetPutRequest;

  getElementsList(): Array<_SortedSetElement>;
  setElementsList(value: Array<_SortedSetElement>): _SortedSetPutRequest;
  clearElementsList(): _SortedSetPutRequest;
  addElements(value?: _SortedSetElement, index?: number): _SortedSetElement;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SortedSetPutRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _SortedSetPutRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetPutRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetPutRequest): _SortedSetPutRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetPutRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetPutRequest;
  static deserializeBinaryFromReader(message: _SortedSetPutRequest, reader: jspb.BinaryReader): _SortedSetPutRequest;
}

export namespace _SortedSetPutRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    elementsList: Array<_SortedSetElement.AsObject>,
    ttlMilliseconds: number,
    refreshTtl: boolean,
  }
}

export class _SortedSetPutResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetPutResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetPutResponse): _SortedSetPutResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetPutResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetPutResponse;
  static deserializeBinaryFromReader(message: _SortedSetPutResponse, reader: jspb.BinaryReader): _SortedSetPutResponse;
}

export namespace _SortedSetPutResponse {
  export type AsObject = {
  }
}

export class _SortedSetFetchRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetFetchRequest;

  getOrder(): _SortedSetFetchRequest.Order;
  setOrder(value: _SortedSetFetchRequest.Order): _SortedSetFetchRequest;

  getWithScores(): boolean;
  setWithScores(value: boolean): _SortedSetFetchRequest;

  getByIndex(): _SortedSetFetchRequest._ByIndex | undefined;
  setByIndex(value?: _SortedSetFetchRequest._ByIndex): _SortedSetFetchRequest;
  hasByIndex(): boolean;
  clearByIndex(): _SortedSetFetchRequest;

  getByScore(): _SortedSetFetchRequest._ByScore | undefined;
  setByScore(value?: _SortedSetFetchRequest._ByScore): _SortedSetFetchRequest;
  hasByScore(): boolean;
  clearByScore(): _SortedSetFetchRequest;

  getRangeCase(): _SortedSetFetchRequest.RangeCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetFetchRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetFetchRequest): _SortedSetFetchRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetFetchRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetFetchRequest;
  static deserializeBinaryFromReader(message: _SortedSetFetchRequest, reader: jspb.BinaryReader): _SortedSetFetchRequest;
}

export namespace _SortedSetFetchRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    order: _SortedSetFetchRequest.Order,
    withScores: boolean,
    byIndex?: _SortedSetFetchRequest._ByIndex.AsObject,
    byScore?: _SortedSetFetchRequest._ByScore.AsObject,
  }

  export class _ByIndex extends jspb.Message {
    getUnboundedStart(): common_pb._Unbounded | undefined;
    setUnboundedStart(value?: common_pb._Unbounded): _ByIndex;
    hasUnboundedStart(): boolean;
    clearUnboundedStart(): _ByIndex;

    getInclusiveStartIndex(): number;
    setInclusiveStartIndex(value: number): _ByIndex;

    getUnboundedEnd(): common_pb._Unbounded | undefined;
    setUnboundedEnd(value?: common_pb._Unbounded): _ByIndex;
    hasUnboundedEnd(): boolean;
    clearUnboundedEnd(): _ByIndex;

    getExclusiveEndIndex(): number;
    setExclusiveEndIndex(value: number): _ByIndex;

    getStartCase(): _ByIndex.StartCase;

    getEndCase(): _ByIndex.EndCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _ByIndex.AsObject;
    static toObject(includeInstance: boolean, msg: _ByIndex): _ByIndex.AsObject;
    static serializeBinaryToWriter(message: _ByIndex, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _ByIndex;
    static deserializeBinaryFromReader(message: _ByIndex, reader: jspb.BinaryReader): _ByIndex;
  }

  export namespace _ByIndex {
    export type AsObject = {
      unboundedStart?: common_pb._Unbounded.AsObject,
      inclusiveStartIndex: number,
      unboundedEnd?: common_pb._Unbounded.AsObject,
      exclusiveEndIndex: number,
    }

    export enum StartCase { 
      START_NOT_SET = 0,
      UNBOUNDED_START = 1,
      INCLUSIVE_START_INDEX = 2,
    }

    export enum EndCase { 
      END_NOT_SET = 0,
      UNBOUNDED_END = 3,
      EXCLUSIVE_END_INDEX = 4,
    }
  }


  export class _ByScore extends jspb.Message {
    getUnboundedMin(): common_pb._Unbounded | undefined;
    setUnboundedMin(value?: common_pb._Unbounded): _ByScore;
    hasUnboundedMin(): boolean;
    clearUnboundedMin(): _ByScore;

    getMinScore(): _SortedSetFetchRequest._ByScore._Score | undefined;
    setMinScore(value?: _SortedSetFetchRequest._ByScore._Score): _ByScore;
    hasMinScore(): boolean;
    clearMinScore(): _ByScore;

    getUnboundedMax(): common_pb._Unbounded | undefined;
    setUnboundedMax(value?: common_pb._Unbounded): _ByScore;
    hasUnboundedMax(): boolean;
    clearUnboundedMax(): _ByScore;

    getMaxScore(): _SortedSetFetchRequest._ByScore._Score | undefined;
    setMaxScore(value?: _SortedSetFetchRequest._ByScore._Score): _ByScore;
    hasMaxScore(): boolean;
    clearMaxScore(): _ByScore;

    getOffset(): number;
    setOffset(value: number): _ByScore;

    getCount(): number;
    setCount(value: number): _ByScore;

    getMinCase(): _ByScore.MinCase;

    getMaxCase(): _ByScore.MaxCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _ByScore.AsObject;
    static toObject(includeInstance: boolean, msg: _ByScore): _ByScore.AsObject;
    static serializeBinaryToWriter(message: _ByScore, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _ByScore;
    static deserializeBinaryFromReader(message: _ByScore, reader: jspb.BinaryReader): _ByScore;
  }

  export namespace _ByScore {
    export type AsObject = {
      unboundedMin?: common_pb._Unbounded.AsObject,
      minScore?: _SortedSetFetchRequest._ByScore._Score.AsObject,
      unboundedMax?: common_pb._Unbounded.AsObject,
      maxScore?: _SortedSetFetchRequest._ByScore._Score.AsObject,
      offset: number,
      count: number,
    }

    export class _Score extends jspb.Message {
      getScore(): number;
      setScore(value: number): _Score;

      getExclusive(): boolean;
      setExclusive(value: boolean): _Score;

      serializeBinary(): Uint8Array;
      toObject(includeInstance?: boolean): _Score.AsObject;
      static toObject(includeInstance: boolean, msg: _Score): _Score.AsObject;
      static serializeBinaryToWriter(message: _Score, writer: jspb.BinaryWriter): void;
      static deserializeBinary(bytes: Uint8Array): _Score;
      static deserializeBinaryFromReader(message: _Score, reader: jspb.BinaryReader): _Score;
    }

    export namespace _Score {
      export type AsObject = {
        score: number,
        exclusive: boolean,
      }
    }


    export enum MinCase { 
      MIN_NOT_SET = 0,
      UNBOUNDED_MIN = 1,
      MIN_SCORE = 2,
    }

    export enum MaxCase { 
      MAX_NOT_SET = 0,
      UNBOUNDED_MAX = 3,
      MAX_SCORE = 4,
    }
  }


  export enum Order { 
    ASCENDING = 0,
    DESCENDING = 1,
  }

  export enum RangeCase { 
    RANGE_NOT_SET = 0,
    BY_INDEX = 4,
    BY_SCORE = 5,
  }
}

export class _SortedSetFetchResponse extends jspb.Message {
  getFound(): _SortedSetFetchResponse._Found | undefined;
  setFound(value?: _SortedSetFetchResponse._Found): _SortedSetFetchResponse;
  hasFound(): boolean;
  clearFound(): _SortedSetFetchResponse;

  getMissing(): _SortedSetFetchResponse._Missing | undefined;
  setMissing(value?: _SortedSetFetchResponse._Missing): _SortedSetFetchResponse;
  hasMissing(): boolean;
  clearMissing(): _SortedSetFetchResponse;

  getSortedSetCase(): _SortedSetFetchResponse.SortedSetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetFetchResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetFetchResponse): _SortedSetFetchResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetFetchResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetFetchResponse;
  static deserializeBinaryFromReader(message: _SortedSetFetchResponse, reader: jspb.BinaryReader): _SortedSetFetchResponse;
}

export namespace _SortedSetFetchResponse {
  export type AsObject = {
    found?: _SortedSetFetchResponse._Found.AsObject,
    missing?: _SortedSetFetchResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getValuesWithScores(): _SortedSetFetchResponse._Found._ValuesWithScores | undefined;
    setValuesWithScores(value?: _SortedSetFetchResponse._Found._ValuesWithScores): _Found;
    hasValuesWithScores(): boolean;
    clearValuesWithScores(): _Found;

    getValues(): _SortedSetFetchResponse._Found._Values | undefined;
    setValues(value?: _SortedSetFetchResponse._Found._Values): _Found;
    hasValues(): boolean;
    clearValues(): _Found;

    getElementsCase(): _Found.ElementsCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      valuesWithScores?: _SortedSetFetchResponse._Found._ValuesWithScores.AsObject,
      values?: _SortedSetFetchResponse._Found._Values.AsObject,
    }

    export class _ValuesWithScores extends jspb.Message {
      getElementsList(): Array<_SortedSetElement>;
      setElementsList(value: Array<_SortedSetElement>): _ValuesWithScores;
      clearElementsList(): _ValuesWithScores;
      addElements(value?: _SortedSetElement, index?: number): _SortedSetElement;

      serializeBinary(): Uint8Array;
      toObject(includeInstance?: boolean): _ValuesWithScores.AsObject;
      static toObject(includeInstance: boolean, msg: _ValuesWithScores): _ValuesWithScores.AsObject;
      static serializeBinaryToWriter(message: _ValuesWithScores, writer: jspb.BinaryWriter): void;
      static deserializeBinary(bytes: Uint8Array): _ValuesWithScores;
      static deserializeBinaryFromReader(message: _ValuesWithScores, reader: jspb.BinaryReader): _ValuesWithScores;
    }

    export namespace _ValuesWithScores {
      export type AsObject = {
        elementsList: Array<_SortedSetElement.AsObject>,
      }
    }


    export class _Values extends jspb.Message {
      getValuesList(): Array<Uint8Array | string>;
      setValuesList(value: Array<Uint8Array | string>): _Values;
      clearValuesList(): _Values;
      addValues(value: Uint8Array | string, index?: number): _Values;

      serializeBinary(): Uint8Array;
      toObject(includeInstance?: boolean): _Values.AsObject;
      static toObject(includeInstance: boolean, msg: _Values): _Values.AsObject;
      static serializeBinaryToWriter(message: _Values, writer: jspb.BinaryWriter): void;
      static deserializeBinary(bytes: Uint8Array): _Values;
      static deserializeBinaryFromReader(message: _Values, reader: jspb.BinaryReader): _Values;
    }

    export namespace _Values {
      export type AsObject = {
        valuesList: Array<Uint8Array | string>,
      }
    }


    export enum ElementsCase { 
      ELEMENTS_NOT_SET = 0,
      VALUES_WITH_SCORES = 1,
      VALUES = 2,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SortedSetCase { 
    SORTED_SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SortedSetGetScoreRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetGetScoreRequest;

  getValuesList(): Array<Uint8Array | string>;
  setValuesList(value: Array<Uint8Array | string>): _SortedSetGetScoreRequest;
  clearValuesList(): _SortedSetGetScoreRequest;
  addValues(value: Uint8Array | string, index?: number): _SortedSetGetScoreRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetGetScoreRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetGetScoreRequest): _SortedSetGetScoreRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetGetScoreRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetGetScoreRequest;
  static deserializeBinaryFromReader(message: _SortedSetGetScoreRequest, reader: jspb.BinaryReader): _SortedSetGetScoreRequest;
}

export namespace _SortedSetGetScoreRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    valuesList: Array<Uint8Array | string>,
  }
}

export class _SortedSetGetScoreResponse extends jspb.Message {
  getFound(): _SortedSetGetScoreResponse._SortedSetFound | undefined;
  setFound(value?: _SortedSetGetScoreResponse._SortedSetFound): _SortedSetGetScoreResponse;
  hasFound(): boolean;
  clearFound(): _SortedSetGetScoreResponse;

  getMissing(): _SortedSetGetScoreResponse._SortedSetMissing | undefined;
  setMissing(value?: _SortedSetGetScoreResponse._SortedSetMissing): _SortedSetGetScoreResponse;
  hasMissing(): boolean;
  clearMissing(): _SortedSetGetScoreResponse;

  getSortedSetCase(): _SortedSetGetScoreResponse.SortedSetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetGetScoreResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetGetScoreResponse): _SortedSetGetScoreResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetGetScoreResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetGetScoreResponse;
  static deserializeBinaryFromReader(message: _SortedSetGetScoreResponse, reader: jspb.BinaryReader): _SortedSetGetScoreResponse;
}

export namespace _SortedSetGetScoreResponse {
  export type AsObject = {
    found?: _SortedSetGetScoreResponse._SortedSetFound.AsObject,
    missing?: _SortedSetGetScoreResponse._SortedSetMissing.AsObject,
  }

  export class _SortedSetGetScoreResponsePart extends jspb.Message {
    getResult(): ECacheResult;
    setResult(value: ECacheResult): _SortedSetGetScoreResponsePart;

    getScore(): number;
    setScore(value: number): _SortedSetGetScoreResponsePart;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _SortedSetGetScoreResponsePart.AsObject;
    static toObject(includeInstance: boolean, msg: _SortedSetGetScoreResponsePart): _SortedSetGetScoreResponsePart.AsObject;
    static serializeBinaryToWriter(message: _SortedSetGetScoreResponsePart, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _SortedSetGetScoreResponsePart;
    static deserializeBinaryFromReader(message: _SortedSetGetScoreResponsePart, reader: jspb.BinaryReader): _SortedSetGetScoreResponsePart;
  }

  export namespace _SortedSetGetScoreResponsePart {
    export type AsObject = {
      result: ECacheResult,
      score: number,
    }
  }


  export class _SortedSetFound extends jspb.Message {
    getElementsList(): Array<_SortedSetGetScoreResponse._SortedSetGetScoreResponsePart>;
    setElementsList(value: Array<_SortedSetGetScoreResponse._SortedSetGetScoreResponsePart>): _SortedSetFound;
    clearElementsList(): _SortedSetFound;
    addElements(value?: _SortedSetGetScoreResponse._SortedSetGetScoreResponsePart, index?: number): _SortedSetGetScoreResponse._SortedSetGetScoreResponsePart;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _SortedSetFound.AsObject;
    static toObject(includeInstance: boolean, msg: _SortedSetFound): _SortedSetFound.AsObject;
    static serializeBinaryToWriter(message: _SortedSetFound, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _SortedSetFound;
    static deserializeBinaryFromReader(message: _SortedSetFound, reader: jspb.BinaryReader): _SortedSetFound;
  }

  export namespace _SortedSetFound {
    export type AsObject = {
      elementsList: Array<_SortedSetGetScoreResponse._SortedSetGetScoreResponsePart.AsObject>,
    }
  }


  export class _SortedSetMissing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _SortedSetMissing.AsObject;
    static toObject(includeInstance: boolean, msg: _SortedSetMissing): _SortedSetMissing.AsObject;
    static serializeBinaryToWriter(message: _SortedSetMissing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _SortedSetMissing;
    static deserializeBinaryFromReader(message: _SortedSetMissing, reader: jspb.BinaryReader): _SortedSetMissing;
  }

  export namespace _SortedSetMissing {
    export type AsObject = {
    }
  }


  export enum SortedSetCase { 
    SORTED_SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SortedSetRemoveRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetRemoveRequest;

  getAll(): _SortedSetRemoveRequest._All | undefined;
  setAll(value?: _SortedSetRemoveRequest._All): _SortedSetRemoveRequest;
  hasAll(): boolean;
  clearAll(): _SortedSetRemoveRequest;

  getSome(): _SortedSetRemoveRequest._Some | undefined;
  setSome(value?: _SortedSetRemoveRequest._Some): _SortedSetRemoveRequest;
  hasSome(): boolean;
  clearSome(): _SortedSetRemoveRequest;

  getRemoveElementsCase(): _SortedSetRemoveRequest.RemoveElementsCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetRemoveRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetRemoveRequest): _SortedSetRemoveRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetRemoveRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetRemoveRequest;
  static deserializeBinaryFromReader(message: _SortedSetRemoveRequest, reader: jspb.BinaryReader): _SortedSetRemoveRequest;
}

export namespace _SortedSetRemoveRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    all?: _SortedSetRemoveRequest._All.AsObject,
    some?: _SortedSetRemoveRequest._Some.AsObject,
  }

  export class _All extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _All.AsObject;
    static toObject(includeInstance: boolean, msg: _All): _All.AsObject;
    static serializeBinaryToWriter(message: _All, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _All;
    static deserializeBinaryFromReader(message: _All, reader: jspb.BinaryReader): _All;
  }

  export namespace _All {
    export type AsObject = {
    }
  }


  export class _Some extends jspb.Message {
    getValuesList(): Array<Uint8Array | string>;
    setValuesList(value: Array<Uint8Array | string>): _Some;
    clearValuesList(): _Some;
    addValues(value: Uint8Array | string, index?: number): _Some;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Some.AsObject;
    static toObject(includeInstance: boolean, msg: _Some): _Some.AsObject;
    static serializeBinaryToWriter(message: _Some, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Some;
    static deserializeBinaryFromReader(message: _Some, reader: jspb.BinaryReader): _Some;
  }

  export namespace _Some {
    export type AsObject = {
      valuesList: Array<Uint8Array | string>,
    }
  }


  export enum RemoveElementsCase { 
    REMOVE_ELEMENTS_NOT_SET = 0,
    ALL = 2,
    SOME = 3,
  }
}

export class _SortedSetRemoveResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetRemoveResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetRemoveResponse): _SortedSetRemoveResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetRemoveResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetRemoveResponse;
  static deserializeBinaryFromReader(message: _SortedSetRemoveResponse, reader: jspb.BinaryReader): _SortedSetRemoveResponse;
}

export namespace _SortedSetRemoveResponse {
  export type AsObject = {
  }
}

export class _SortedSetIncrementRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetIncrementRequest;

  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): _SortedSetIncrementRequest;

  getAmount(): number;
  setAmount(value: number): _SortedSetIncrementRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SortedSetIncrementRequest;

  getRefreshTtl(): boolean;
  setRefreshTtl(value: boolean): _SortedSetIncrementRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetIncrementRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetIncrementRequest): _SortedSetIncrementRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetIncrementRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetIncrementRequest;
  static deserializeBinaryFromReader(message: _SortedSetIncrementRequest, reader: jspb.BinaryReader): _SortedSetIncrementRequest;
}

export namespace _SortedSetIncrementRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    value: Uint8Array | string,
    amount: number,
    ttlMilliseconds: number,
    refreshTtl: boolean,
  }
}

export class _SortedSetIncrementResponse extends jspb.Message {
  getScore(): number;
  setScore(value: number): _SortedSetIncrementResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetIncrementResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetIncrementResponse): _SortedSetIncrementResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetIncrementResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetIncrementResponse;
  static deserializeBinaryFromReader(message: _SortedSetIncrementResponse, reader: jspb.BinaryReader): _SortedSetIncrementResponse;
}

export namespace _SortedSetIncrementResponse {
  export type AsObject = {
    score: number,
  }
}

export class _SortedSetGetRankRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetGetRankRequest;

  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): _SortedSetGetRankRequest;

  getOrder(): _SortedSetGetRankRequest.Order;
  setOrder(value: _SortedSetGetRankRequest.Order): _SortedSetGetRankRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetGetRankRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetGetRankRequest): _SortedSetGetRankRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetGetRankRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetGetRankRequest;
  static deserializeBinaryFromReader(message: _SortedSetGetRankRequest, reader: jspb.BinaryReader): _SortedSetGetRankRequest;
}

export namespace _SortedSetGetRankRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    value: Uint8Array | string,
    order: _SortedSetGetRankRequest.Order,
  }

  export enum Order { 
    ASCENDING = 0,
    DESCENDING = 1,
  }
}

export class _SortedSetGetRankResponse extends jspb.Message {
  getElementRank(): _SortedSetGetRankResponse._RankResponsePart | undefined;
  setElementRank(value?: _SortedSetGetRankResponse._RankResponsePart): _SortedSetGetRankResponse;
  hasElementRank(): boolean;
  clearElementRank(): _SortedSetGetRankResponse;

  getMissing(): _SortedSetGetRankResponse._SortedSetMissing | undefined;
  setMissing(value?: _SortedSetGetRankResponse._SortedSetMissing): _SortedSetGetRankResponse;
  hasMissing(): boolean;
  clearMissing(): _SortedSetGetRankResponse;

  getRankCase(): _SortedSetGetRankResponse.RankCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetGetRankResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetGetRankResponse): _SortedSetGetRankResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetGetRankResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetGetRankResponse;
  static deserializeBinaryFromReader(message: _SortedSetGetRankResponse, reader: jspb.BinaryReader): _SortedSetGetRankResponse;
}

export namespace _SortedSetGetRankResponse {
  export type AsObject = {
    elementRank?: _SortedSetGetRankResponse._RankResponsePart.AsObject,
    missing?: _SortedSetGetRankResponse._SortedSetMissing.AsObject,
  }

  export class _RankResponsePart extends jspb.Message {
    getResult(): ECacheResult;
    setResult(value: ECacheResult): _RankResponsePart;

    getRank(): number;
    setRank(value: number): _RankResponsePart;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _RankResponsePart.AsObject;
    static toObject(includeInstance: boolean, msg: _RankResponsePart): _RankResponsePart.AsObject;
    static serializeBinaryToWriter(message: _RankResponsePart, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _RankResponsePart;
    static deserializeBinaryFromReader(message: _RankResponsePart, reader: jspb.BinaryReader): _RankResponsePart;
  }

  export namespace _RankResponsePart {
    export type AsObject = {
      result: ECacheResult,
      rank: number,
    }
  }


  export class _SortedSetMissing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _SortedSetMissing.AsObject;
    static toObject(includeInstance: boolean, msg: _SortedSetMissing): _SortedSetMissing.AsObject;
    static serializeBinaryToWriter(message: _SortedSetMissing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _SortedSetMissing;
    static deserializeBinaryFromReader(message: _SortedSetMissing, reader: jspb.BinaryReader): _SortedSetMissing;
  }

  export namespace _SortedSetMissing {
    export type AsObject = {
    }
  }


  export enum RankCase { 
    RANK_NOT_SET = 0,
    ELEMENT_RANK = 1,
    MISSING = 2,
  }
}

export class _SortedSetLengthRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetLengthRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetLengthRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetLengthRequest): _SortedSetLengthRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetLengthRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetLengthRequest;
  static deserializeBinaryFromReader(message: _SortedSetLengthRequest, reader: jspb.BinaryReader): _SortedSetLengthRequest;
}

export namespace _SortedSetLengthRequest {
  export type AsObject = {
    setName: Uint8Array | string,
  }
}

export class _SortedSetLengthResponse extends jspb.Message {
  getFound(): _SortedSetLengthResponse._Found | undefined;
  setFound(value?: _SortedSetLengthResponse._Found): _SortedSetLengthResponse;
  hasFound(): boolean;
  clearFound(): _SortedSetLengthResponse;

  getMissing(): _SortedSetLengthResponse._Missing | undefined;
  setMissing(value?: _SortedSetLengthResponse._Missing): _SortedSetLengthResponse;
  hasMissing(): boolean;
  clearMissing(): _SortedSetLengthResponse;

  getSortedSetCase(): _SortedSetLengthResponse.SortedSetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetLengthResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetLengthResponse): _SortedSetLengthResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetLengthResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetLengthResponse;
  static deserializeBinaryFromReader(message: _SortedSetLengthResponse, reader: jspb.BinaryReader): _SortedSetLengthResponse;
}

export namespace _SortedSetLengthResponse {
  export type AsObject = {
    found?: _SortedSetLengthResponse._Found.AsObject,
    missing?: _SortedSetLengthResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getLength(): number;
    setLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      length: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SortedSetCase { 
    SORTED_SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SortedSetLengthByScoreRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetLengthByScoreRequest;

  getInclusiveMin(): number;
  setInclusiveMin(value: number): _SortedSetLengthByScoreRequest;

  getExclusiveMin(): number;
  setExclusiveMin(value: number): _SortedSetLengthByScoreRequest;

  getUnboundedMin(): common_pb._Unbounded | undefined;
  setUnboundedMin(value?: common_pb._Unbounded): _SortedSetLengthByScoreRequest;
  hasUnboundedMin(): boolean;
  clearUnboundedMin(): _SortedSetLengthByScoreRequest;

  getInclusiveMax(): number;
  setInclusiveMax(value: number): _SortedSetLengthByScoreRequest;

  getExclusiveMax(): number;
  setExclusiveMax(value: number): _SortedSetLengthByScoreRequest;

  getUnboundedMax(): common_pb._Unbounded | undefined;
  setUnboundedMax(value?: common_pb._Unbounded): _SortedSetLengthByScoreRequest;
  hasUnboundedMax(): boolean;
  clearUnboundedMax(): _SortedSetLengthByScoreRequest;

  getMinCase(): _SortedSetLengthByScoreRequest.MinCase;

  getMaxCase(): _SortedSetLengthByScoreRequest.MaxCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetLengthByScoreRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetLengthByScoreRequest): _SortedSetLengthByScoreRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetLengthByScoreRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetLengthByScoreRequest;
  static deserializeBinaryFromReader(message: _SortedSetLengthByScoreRequest, reader: jspb.BinaryReader): _SortedSetLengthByScoreRequest;
}

export namespace _SortedSetLengthByScoreRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    inclusiveMin: number,
    exclusiveMin: number,
    unboundedMin?: common_pb._Unbounded.AsObject,
    inclusiveMax: number,
    exclusiveMax: number,
    unboundedMax?: common_pb._Unbounded.AsObject,
  }

  export enum MinCase { 
    MIN_NOT_SET = 0,
    INCLUSIVE_MIN = 2,
    EXCLUSIVE_MIN = 3,
    UNBOUNDED_MIN = 4,
  }

  export enum MaxCase { 
    MAX_NOT_SET = 0,
    INCLUSIVE_MAX = 5,
    EXCLUSIVE_MAX = 6,
    UNBOUNDED_MAX = 7,
  }
}

export class _SortedSetLengthByScoreResponse extends jspb.Message {
  getFound(): _SortedSetLengthByScoreResponse._Found | undefined;
  setFound(value?: _SortedSetLengthByScoreResponse._Found): _SortedSetLengthByScoreResponse;
  hasFound(): boolean;
  clearFound(): _SortedSetLengthByScoreResponse;

  getMissing(): _SortedSetLengthByScoreResponse._Missing | undefined;
  setMissing(value?: _SortedSetLengthByScoreResponse._Missing): _SortedSetLengthByScoreResponse;
  hasMissing(): boolean;
  clearMissing(): _SortedSetLengthByScoreResponse;

  getSortedSetCase(): _SortedSetLengthByScoreResponse.SortedSetCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetLengthByScoreResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetLengthByScoreResponse): _SortedSetLengthByScoreResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetLengthByScoreResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetLengthByScoreResponse;
  static deserializeBinaryFromReader(message: _SortedSetLengthByScoreResponse, reader: jspb.BinaryReader): _SortedSetLengthByScoreResponse;
}

export namespace _SortedSetLengthByScoreResponse {
  export type AsObject = {
    found?: _SortedSetLengthByScoreResponse._Found.AsObject,
    missing?: _SortedSetLengthByScoreResponse._Missing.AsObject,
  }

  export class _Found extends jspb.Message {
    getLength(): number;
    setLength(value: number): _Found;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Found.AsObject;
    static toObject(includeInstance: boolean, msg: _Found): _Found.AsObject;
    static serializeBinaryToWriter(message: _Found, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Found;
    static deserializeBinaryFromReader(message: _Found, reader: jspb.BinaryReader): _Found;
  }

  export namespace _Found {
    export type AsObject = {
      length: number,
    }
  }


  export class _Missing extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Missing.AsObject;
    static toObject(includeInstance: boolean, msg: _Missing): _Missing.AsObject;
    static serializeBinaryToWriter(message: _Missing, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Missing;
    static deserializeBinaryFromReader(message: _Missing, reader: jspb.BinaryReader): _Missing;
  }

  export namespace _Missing {
    export type AsObject = {
    }
  }


  export enum SortedSetCase { 
    SORTED_SET_NOT_SET = 0,
    FOUND = 1,
    MISSING = 2,
  }
}

export class _SortedSetUnionStoreRequest extends jspb.Message {
  getSetName(): Uint8Array | string;
  getSetName_asU8(): Uint8Array;
  getSetName_asB64(): string;
  setSetName(value: Uint8Array | string): _SortedSetUnionStoreRequest;

  getSourcesList(): Array<_SortedSetUnionStoreRequest._Source>;
  setSourcesList(value: Array<_SortedSetUnionStoreRequest._Source>): _SortedSetUnionStoreRequest;
  clearSourcesList(): _SortedSetUnionStoreRequest;
  addSources(value?: _SortedSetUnionStoreRequest._Source, index?: number): _SortedSetUnionStoreRequest._Source;

  getAggregate(): _SortedSetUnionStoreRequest.AggregateFunction;
  setAggregate(value: _SortedSetUnionStoreRequest.AggregateFunction): _SortedSetUnionStoreRequest;

  getTtlMilliseconds(): number;
  setTtlMilliseconds(value: number): _SortedSetUnionStoreRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetUnionStoreRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetUnionStoreRequest): _SortedSetUnionStoreRequest.AsObject;
  static serializeBinaryToWriter(message: _SortedSetUnionStoreRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetUnionStoreRequest;
  static deserializeBinaryFromReader(message: _SortedSetUnionStoreRequest, reader: jspb.BinaryReader): _SortedSetUnionStoreRequest;
}

export namespace _SortedSetUnionStoreRequest {
  export type AsObject = {
    setName: Uint8Array | string,
    sourcesList: Array<_SortedSetUnionStoreRequest._Source.AsObject>,
    aggregate: _SortedSetUnionStoreRequest.AggregateFunction,
    ttlMilliseconds: number,
  }

  export class _Source extends jspb.Message {
    getSetName(): Uint8Array | string;
    getSetName_asU8(): Uint8Array;
    getSetName_asB64(): string;
    setSetName(value: Uint8Array | string): _Source;

    getWeight(): number;
    setWeight(value: number): _Source;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): _Source.AsObject;
    static toObject(includeInstance: boolean, msg: _Source): _Source.AsObject;
    static serializeBinaryToWriter(message: _Source, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): _Source;
    static deserializeBinaryFromReader(message: _Source, reader: jspb.BinaryReader): _Source;
  }

  export namespace _Source {
    export type AsObject = {
      setName: Uint8Array | string,
      weight: number,
    }
  }


  export enum AggregateFunction { 
    SUM = 0,
    MIN = 1,
    MAX = 2,
  }
}

export class _SortedSetUnionStoreResponse extends jspb.Message {
  getLength(): number;
  setLength(value: number): _SortedSetUnionStoreResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SortedSetUnionStoreResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _SortedSetUnionStoreResponse): _SortedSetUnionStoreResponse.AsObject;
  static serializeBinaryToWriter(message: _SortedSetUnionStoreResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SortedSetUnionStoreResponse;
  static deserializeBinaryFromReader(message: _SortedSetUnionStoreResponse, reader: jspb.BinaryReader): _SortedSetUnionStoreResponse;
}

export namespace _SortedSetUnionStoreResponse {
  export type AsObject = {
    length: number,
  }
}

export enum ECacheResult { 
  INVALID = 0,
  OK = 1,
  HIT = 2,
  MISS = 3,
}
