import * as jspb from 'google-protobuf'

import * as common_pb from './common_pb';
import * as extensions_pb from './extensions_pb';


export class _PublishRequest extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): _PublishRequest;

  getTopic(): string;
  setTopic(value: string): _PublishRequest;

  getValue(): _TopicValue | undefined;
  setValue(value?: _TopicValue): _PublishRequest;
  hasValue(): boolean;
  clearValue(): _PublishRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _PublishRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _PublishRequest): _PublishRequest.AsObject;
  static serializeBinaryToWriter(message: _PublishRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _PublishRequest;
  static deserializeBinaryFromReader(message: _PublishRequest, reader: jspb.BinaryReader): _PublishRequest;
}

export namespace _PublishRequest {
  export type AsObject = {
    cacheName: string,
    topic: string,
    value?: _TopicValue.AsObject,
  }
}

export class _SubscriptionRequest extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): _SubscriptionRequest;

  getTopic(): string;
  setTopic(value: string): _SubscriptionRequest;

  getResumeAtTopicSequenceNumber(): number;
  setResumeAtTopicSequenceNumber(value: number): _SubscriptionRequest;

  getSequencePage(): number;
  setSequencePage(value: number): _SubscriptionRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SubscriptionRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _SubscriptionRequest): _SubscriptionRequest.AsObject;
  static serializeBinaryToWriter(message: _SubscriptionRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SubscriptionRequest;
  static deserializeBinaryFromReader(message: _SubscriptionRequest, reader: jspb.BinaryReader): _SubscriptionRequest;
}

export namespace _SubscriptionRequest {
  export type AsObject = {
    cacheName: string,
    topic: string,
    resumeAtTopicSequenceNumber: number,
    sequencePage: number,
  }
}

export class _SubscriptionItem extends jspb.Message {
  getItem(): _TopicItem | undefined;
  setItem(value?: _TopicItem): _SubscriptionItem;
  hasItem(): boolean;
  clearItem(): _SubscriptionItem;

  getDiscontinuity(): _Discontinuity | undefined;
  setDiscontinuity(value?: _Discontinuity): _SubscriptionItem;
  hasDiscontinuity(): boolean;
  clearDiscontinuity(): _SubscriptionItem;

  getHeartbeat(): _Heartbeat | undefined;
  setHeartbeat(value?: _Heartbeat): _SubscriptionItem;
  hasHeartbeat(): boolean;
  clearHeartbeat(): _SubscriptionItem;

  getKindCase(): _SubscriptionItem.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _SubscriptionItem.AsObject;
  static toObject(includeInstance: boolean, msg: _SubscriptionItem): _SubscriptionItem.AsObject;
  static serializeBinaryToWriter(message: _SubscriptionItem, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _SubscriptionItem;
  static deserializeBinaryFromReader(message: _SubscriptionItem, reader: jspb.BinaryReader): _SubscriptionItem;
}

export namespace _SubscriptionItem {
  export type AsObject = {
    item?: _TopicItem.AsObject,
    discontinuity?: _Discontinuity.AsObject,
    heartbeat?: _Heartbeat.AsObject,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    ITEM = 1,
    DISCONTINUITY = 2,
    HEARTBEAT = 3,
  }
}

export class _TopicItem extends jspb.Message {
  getTopicSequenceNumber(): number;
  setTopicSequenceNumber(value: number): _TopicItem;

  getValue(): _TopicValue | undefined;
  setValue(value?: _TopicValue): _TopicItem;
  hasValue(): boolean;
  clearValue(): _TopicItem;

  getPublisherId(): string;
  setPublisherId(value: string): _TopicItem;

  getSequencePage(): number;
  setSequencePage(value: number): _TopicItem;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _TopicItem.AsObject;
  static toObject(includeInstance: boolean, msg: _TopicItem): _TopicItem.AsObject;
  static serializeBinaryToWriter(message: _TopicItem, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _TopicItem;
  static deserializeBinaryFromReader(message: _TopicItem, reader: jspb.BinaryReader): _TopicItem;
}

export namespace _TopicItem {
  export type AsObject = {
    topicSequenceNumber: number,
    value?: _TopicValue.AsObject,
    publisherId: string,
    sequencePage: number,
  }
}

export class _TopicValue extends jspb.Message {
  getText(): string;
  setText(value: string): _TopicValue;

  getBinary(): Uint8Array | string;
  getBinary_asU8(): Uint8Array;
  getBinary_asB64(): string;
  setBinary(value: Uint8Array | string): _TopicValue;

  getKindCase(): _TopicValue.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _TopicValue.AsObject;
  static toObject(includeInstance: boolean, msg: _TopicValue): _TopicValue.AsObject;
  static serializeBinaryToWriter(message: _TopicValue, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _TopicValue;
  static deserializeBinaryFromReader(message: _TopicValue, reader: jspb.BinaryReader): _TopicValue;
}

export namespace _TopicValue {
  export type AsObject = {
    text: string,
    binary: Uint8Array | string,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    TEXT = 1,
    BINARY = 2,
  }
}

export class _Discontinuity extends jspb.Message {
  getLastTopicSequence(): number;
  setLastTopicSequence(value: number): _Discontinuity;

  getNewTopicSequence(): number;
  setNewTopicSequence(value: number): _Discontinuity;

  getNewSequencePage(): number;
  setNewSequencePage(value: number): _Discontinuity;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _Discontinuity.AsObject;
  static toObject(includeInstance: boolean, msg: _Discontinuity): _Discontinuity.AsObject;
  static serializeBinaryToWriter(message: _Discontinuity, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _Discontinuity;
  static deserializeBinaryFromReader(message: _Discontinuity, reader: jspb.BinaryReader): _Discontinuity;
}

export namespace _Discontinuity {
  export type AsObject = {
    lastTopicSequence: number,
    newTopicSequence: number,
    newSequencePage: number,
  }
}

export class _Heartbeat extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _Heartbeat.AsObject;
  static toObject(includeInstance: boolean, msg: _Heartbeat): _Heartbeat.AsObject;
  static serializeBinaryToWriter(message: _Heartbeat, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _Heartbeat;
  static deserializeBinaryFromReader(message: _Heartbeat, reader: jspb.BinaryReader): _Heartbeat;
}

export namespace _Heartbeat {
  export type AsObject = {
  }
}

