import * as jspb from 'google-protobuf'

import * as common_pb from './common_pb';


export class _Element extends jspb.Message {
  getId(): number;
  setId(value: number): _Element;

  getScore(): number;
  setScore(value: number): _Element;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _Element.AsObject;
  static toObject(includeInstance: boolean, msg: _Element): _Element.AsObject;
  static serializeBinaryToWriter(message: _Element, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _Element;
  static deserializeBinaryFromReader(message: _Element, reader: jspb.BinaryReader): _Element;
}

export namespace _Element {
  export type AsObject = {
    id: number,
    score: number,
  }
}

export class _RankedElement extends jspb.Message {
  getId(): number;
  setId(value: number): _RankedElement;

  getRank(): number;
  setRank(value: number): _RankedElement;

  getScore(): number;
  setScore(value: number): _RankedElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RankedElement.AsObject;
  static toObject(includeInstance: boolean, msg: _RankedElement): _RankedElement.AsObject;
  static serializeBinaryToWriter(message: _RankedElement, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RankedElement;
  static deserializeBinaryFromReader(message: _RankedElement, reader: jspb.BinaryReader): _RankedElement;
}

export namespace _RankedElement {
  export type AsObject = {
    id: number,
    rank: number,
    score: number,
  }
}

export class _RankRange extends jspb.Message {
  getStartInclusive(): number;
  setStartInclusive(value: number): _RankRange;

  getEndExclusive(): number;
  setEndExclusive(value: number): _RankRange;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RankRange.AsObject;
  static toObject(includeInstance: boolean, msg: _RankRange): _RankRange.AsObject;
  static serializeBinaryToWriter(message: _RankRange, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RankRange;
  static deserializeBinaryFromReader(message: _RankRange, reader: jspb.BinaryReader): _RankRange;
}

export namespace _RankRange {
  export type AsObject = {
    startInclusive: number,
    endExclusive: number,
  }
}

export class _ScoreRange extends jspb.Message {
  getUnboundedMin(): common_pb._Unbounded | undefined;
  setUnboundedMin(value?: common_pb._Unbounded): _ScoreRange;
  hasUnboundedMin(): boolean;
  clearUnboundedMin(): _ScoreRange;

  getMinInclusive(): number;
  setMinInclusive(value: number): _ScoreRange;

  getUnboundedMax(): common_pb._Unbounded | undefined;
  setUnboundedMax(value?: common_pb._Unbounded): _ScoreRange;
  hasUnboundedMax(): boolean;
  clearUnboundedMax(): _ScoreRange;

  getMaxExclusive(): number;
  setMaxExclusive(value: number): _ScoreRange;

  getMinCase(): _ScoreRange.MinCase;

  getMaxCase(): _ScoreRange.MaxCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ScoreRange.AsObject;
  static toObject(includeInstance: boolean, msg: _ScoreRange): _ScoreRange.AsObject;
  static serializeBinaryToWriter(message: _ScoreRange, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ScoreRange;
  static deserializeBinaryFromReader(message: _ScoreRange, reader: jspb.BinaryReader): _ScoreRange;
}

export namespace _ScoreRange {
  export type AsObject = {
    unboundedMin?: common_pb._Unbounded.AsObject,
    minInclusive: number,
    unboundedMax?: common_pb._Unbounded.AsObject,
    maxExclusive: number,
  }

  export enum MinCase { 
    MIN_NOT_SET = 0,
    UNBOUNDED_MIN = 1,
    MIN_INCLUSIVE = 5,
  }

  export enum MaxCase { 
    MAX_NOT_SET = 0,
    UNBOUNDED_MAX = 3,
    MAX_EXCLUSIVE = 6,
  }
}

export class _DeleteLeaderboardRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _DeleteLeaderboardRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DeleteLeaderboardRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DeleteLeaderboardRequest): _DeleteLeaderboardRequest.AsObject;
  static serializeBinaryToWriter(message: _DeleteLeaderboardRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DeleteLeaderboardRequest;
  static deserializeBinaryFromReader(message: _DeleteLeaderboardRequest, reader: jspb.BinaryReader): _DeleteLeaderboardRequest;
}

export namespace _DeleteLeaderboardRequest {
  export type AsObject = {
    leaderboard: string,
  }
}

export class _GetLeaderboardLengthRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _GetLeaderboardLengthRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetLeaderboardLengthRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetLeaderboardLengthRequest): _GetLeaderboardLengthRequest.AsObject;
  static serializeBinaryToWriter(message: _GetLeaderboardLengthRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetLeaderboardLengthRequest;
  static deserializeBinaryFromReader(message: _GetLeaderboardLengthRequest, reader: jspb.BinaryReader): _GetLeaderboardLengthRequest;
}

export namespace _GetLeaderboardLengthRequest {
  export type AsObject = {
    leaderboard: string,
  }
}

export class _GetLeaderboardLengthResponse extends jspb.Message {
  getCount(): number;
  setCount(value: number): _GetLeaderboardLengthResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetLeaderboardLengthResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetLeaderboardLengthResponse): _GetLeaderboardLengthResponse.AsObject;
  static serializeBinaryToWriter(message: _GetLeaderboardLengthResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetLeaderboardLengthResponse;
  static deserializeBinaryFromReader(message: _GetLeaderboardLengthResponse, reader: jspb.BinaryReader): _GetLeaderboardLengthResponse;
}

export namespace _GetLeaderboardLengthResponse {
  export type AsObject = {
    count: number,
  }
}

export class _UpsertElementsRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _UpsertElementsRequest;

  getElementsList(): Array<_Element>;
  setElementsList(value: Array<_Element>): _UpsertElementsRequest;
  clearElementsList(): _UpsertElementsRequest;
  addElements(value?: _Element, index?: number): _Element;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _UpsertElementsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _UpsertElementsRequest): _UpsertElementsRequest.AsObject;
  static serializeBinaryToWriter(message: _UpsertElementsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _UpsertElementsRequest;
  static deserializeBinaryFromReader(message: _UpsertElementsRequest, reader: jspb.BinaryReader): _UpsertElementsRequest;
}

export namespace _UpsertElementsRequest {
  export type AsObject = {
    leaderboard: string,
    elementsList: Array<_Element.AsObject>,
  }
}

export class _GetByRankRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _GetByRankRequest;

  getRankRange(): _RankRange | undefined;
  setRankRange(value?: _RankRange): _GetByRankRequest;
  hasRankRange(): boolean;
  clearRankRange(): _GetByRankRequest;

  getOrder(): _Order;
  setOrder(value: _Order): _GetByRankRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetByRankRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetByRankRequest): _GetByRankRequest.AsObject;
  static serializeBinaryToWriter(message: _GetByRankRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetByRankRequest;
  static deserializeBinaryFromReader(message: _GetByRankRequest, reader: jspb.BinaryReader): _GetByRankRequest;
}

export namespace _GetByRankRequest {
  export type AsObject = {
    leaderboard: string,
    rankRange?: _RankRange.AsObject,
    order: _Order,
  }
}

export class _GetByRankResponse extends jspb.Message {
  getElementsList(): Array<_RankedElement>;
  setElementsList(value: Array<_RankedElement>): _GetByRankResponse;
  clearElementsList(): _GetByRankResponse;
  addElements(value?: _RankedElement, index?: number): _RankedElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetByRankResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetByRankResponse): _GetByRankResponse.AsObject;
  static serializeBinaryToWriter(message: _GetByRankResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetByRankResponse;
  static deserializeBinaryFromReader(message: _GetByRankResponse, reader: jspb.BinaryReader): _GetByRankResponse;
}

export namespace _GetByRankResponse {
  export type AsObject = {
    elementsList: Array<_RankedElement.AsObject>,
  }
}

export class _GetRankRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _GetRankRequest;

  getIdsList(): Array<number>;
  setIdsList(value: Array<number>): _GetRankRequest;
  clearIdsList(): _GetRankRequest;
  addIds(value: number, index?: number): _GetRankRequest;

  getOrder(): _Order;
  setOrder(value: _Order): _GetRankRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetRankRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetRankRequest): _GetRankRequest.AsObject;
  static serializeBinaryToWriter(message: _GetRankRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetRankRequest;
  static deserializeBinaryFromReader(message: _GetRankRequest, reader: jspb.BinaryReader): _GetRankRequest;
}

export namespace _GetRankRequest {
  export type AsObject = {
    leaderboard: string,
    idsList: Array<number>,
    order: _Order,
  }
}

export class _GetRankResponse extends jspb.Message {
  getElementsList(): Array<_RankedElement>;
  setElementsList(value: Array<_RankedElement>): _GetRankResponse;
  clearElementsList(): _GetRankResponse;
  addElements(value?: _RankedElement, index?: number): _RankedElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetRankResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetRankResponse): _GetRankResponse.AsObject;
  static serializeBinaryToWriter(message: _GetRankResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetRankResponse;
  static deserializeBinaryFromReader(message: _GetRankResponse, reader: jspb.BinaryReader): _GetRankResponse;
}

export namespace _GetRankResponse {
  export type AsObject = {
    elementsList: Array<_RankedElement.AsObject>,
  }
}

export class _RemoveElementsRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _RemoveElementsRequest;

  getIdsList(): Array<number>;
  setIdsList(value: Array<number>): _RemoveElementsRequest;
  clearIdsList(): _RemoveElementsRequest;
  addIds(value: number, index?: number): _RemoveElementsRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RemoveElementsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _RemoveElementsRequest): _RemoveElementsRequest.AsObject;
  static serializeBinaryToWriter(message: _RemoveElementsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RemoveElementsRequest;
  static deserializeBinaryFromReader(message: _RemoveElementsRequest, reader: jspb.BinaryReader): _RemoveElementsRequest;
}

export namespace _RemoveElementsRequest {
  export type AsObject = {
    leaderboard: string,
    idsList: Array<number>,
  }
}

export class _GetByScoreRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _GetByScoreRequest;

  getScoreRange(): _ScoreRange | undefined;
  setScoreRange(value?: _ScoreRange): _GetByScoreRequest;
  hasScoreRange(): boolean;
  clearScoreRange(): _GetByScoreRequest;

  getOffset(): number;
  setOffset(value: number): _GetByScoreRequest;

  getLimitElements(): number;
  setLimitElements(value: number): _GetByScoreRequest;

  getOrder(): _Order;
  setOrder(value: _Order): _GetByScoreRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetByScoreRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetByScoreRequest): _GetByScoreRequest.AsObject;
  static serializeBinaryToWriter(message: _GetByScoreRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetByScoreRequest;
  static deserializeBinaryFromReader(message: _GetByScoreRequest, reader: jspb.BinaryReader): _GetByScoreRequest;
}

export namespace _GetByScoreRequest {
  export type AsObject = {
    leaderboard: string,
    scoreRange?: _ScoreRange.AsObject,
    offset: number,
    limitElements: number,
    order: _Order,
  }
}

export class _GetByScoreResponse extends jspb.Message {
  getElementsList(): Array<_RankedElement>;
  setElementsList(value: Array<_RankedElement>): _GetByScoreResponse;
  clearElementsList(): _GetByScoreResponse;
  addElements(value?: _RankedElement, index?: number): _RankedElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetByScoreResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetByScoreResponse): _GetByScoreResponse.AsObject;
  static serializeBinaryToWriter(message: _GetByScoreResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetByScoreResponse;
  static deserializeBinaryFromReader(message: _GetByScoreResponse, reader: jspb.BinaryReader): _GetByScoreResponse;
}

export namespace _GetByScoreResponse {
  export type AsObject = {
    elementsList: Array<_RankedElement.AsObject>,
  }
}

export class _GetCompetitionRankRequest extends jspb.Message {
  getLeaderboard(): string;
  setLeaderboard(value: string): _GetCompetitionRankRequest;

  getIdsList(): Array<number>;
  setIdsList(value: Array<number>): _GetCompetitionRankRequest;
  clearIdsList(): _GetCompetitionRankRequest;
  addIds(value: number, index?: number): _GetCompetitionRankRequest;

  getOrder(): _Order;
  setOrder(value: _Order): _GetCompetitionRankRequest;
  hasOrder(): boolean;
  clearOrder(): _GetCompetitionRankRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetCompetitionRankRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetCompetitionRankRequest): _GetCompetitionRankRequest.AsObject;
  static serializeBinaryToWriter(message: _GetCompetitionRankRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetCompetitionRankRequest;
  static deserializeBinaryFromReader(message: _GetCompetitionRankRequest, reader: jspb.BinaryReader): _GetCompetitionRankRequest;
}

export namespace _GetCompetitionRankRequest {
  export type AsObject = {
    leaderboard: string,
    idsList: Array<number>,
    order?: _Order,
  }

  export enum OrderCase { 
    _ORDER_NOT_SET = 0,
    ORDER = 3,
  }
}

export class _GetCompetitionRankResponse extends jspb.Message {
  getElementsList(): Array<_RankedElement>;
  setElementsList(value: Array<_RankedElement>): _GetCompetitionRankResponse;
  clearElementsList(): _GetCompetitionRankResponse;
  addElements(value?: _RankedElement, index?: number): _RankedElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetCompetitionRankResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetCompetitionRankResponse): _GetCompetitionRankResponse.AsObject;
  static serializeBinaryToWriter(message: _GetCompetitionRankResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetCompetitionRankResponse;
  static deserializeBinaryFromReader(message: _GetCompetitionRankResponse, reader: jspb.BinaryReader): _GetCompetitionRankResponse;
}

export namespace _GetCompetitionRankResponse {
  export type AsObject = {
    elementsList: Array<_RankedElement.AsObject>,
  }
}

export enum _Order { 
  ASCENDING = 0,
  DESCENDING = 1,
}
