import * as jspb from 'google-protobuf'



export class Permissions extends jspb.Message {
  getSuperUser(): SuperUserPermissions;
  setSuperUser(value: SuperUserPermissions): Permissions;

  getExplicit(): ExplicitPermissions | undefined;
  setExplicit(value?: ExplicitPermissions): Permissions;
  hasExplicit(): boolean;
  clearExplicit(): Permissions;

  getKindCase(): Permissions.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Permissions.AsObject;
  static toObject(includeInstance: boolean, msg: Permissions): Permissions.AsObject;
  static serializeBinaryToWriter(message: Permissions, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Permissions;
  static deserializeBinaryFromReader(message: Permissions, reader: jspb.BinaryReader): Permissions;
}

export namespace Permissions {
  export type AsObject = {
    superUser: SuperUserPermissions,
    explicit?: ExplicitPermissions.AsObject,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    SUPER_USER = 1,
    EXPLICIT = 2,
  }
}

export class ExplicitPermissions extends jspb.Message {
  getPermissionsList(): Array<PermissionsType>;
  setPermissionsList(value: Array<PermissionsType>): ExplicitPermissions;
  clearPermissionsList(): ExplicitPermissions;
  addPermissions(value?: PermissionsType, index?: number): PermissionsType;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ExplicitPermissions.AsObject;
  static toObject(includeInstance: boolean, msg: ExplicitPermissions): ExplicitPermissions.AsObject;
  static serializeBinaryToWriter(message: ExplicitPermissions, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ExplicitPermissions;
  static deserializeBinaryFromReader(message: ExplicitPermissions, reader: jspb.BinaryReader): ExplicitPermissions;
}

export namespace ExplicitPermissions {
  export type AsObject = {
    permissionsList: Array<PermissionsType.AsObject>,
  }
}

export class PermissionsType extends jspb.Message {
  getCachePermissions(): PermissionsType.CachePermissions | undefined;
  setCachePermissions(value?: PermissionsType.CachePermissions): PermissionsType;
  hasCachePermissions(): boolean;
  clearCachePermissions(): PermissionsType;

  getTopicPermissions(): PermissionsType.TopicPermissions | undefined;
  setTopicPermissions(value?: PermissionsType.TopicPermissions): PermissionsType;
  hasTopicPermissions(): boolean;
  clearTopicPermissions(): PermissionsType;

  getKindCase(): PermissionsType.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PermissionsType.AsObject;
  static toObject(includeInstance: boolean, msg: PermissionsType): PermissionsType.AsObject;
  static serializeBinaryToWriter(message: PermissionsType, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PermissionsType;
  static deserializeBinaryFromReader(message: PermissionsType, reader: jspb.BinaryReader): PermissionsType;
}

export namespace PermissionsType {
  export type AsObject = {
    cachePermissions?: PermissionsType.CachePermissions.AsObject,
    topicPermissions?: PermissionsType.TopicPermissions.AsObject,
  }

  export class All extends jspb.Message {
    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): All.AsObject;
    static toObject(includeInstance: boolean, msg: All): All.AsObject;
    static serializeBinaryToWriter(message: All, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): All;
    static deserializeBinaryFromReader(message: All, reader: jspb.BinaryReader): All;
  }

  export namespace All {
    export type AsObject = {
    }
  }


  export class CacheSelector extends jspb.Message {
    getCacheName(): string;
    setCacheName(value: string): CacheSelector;

    getKindCase(): CacheSelector.KindCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): CacheSelector.AsObject;
    static toObject(includeInstance: boolean, msg: CacheSelector): CacheSelector.AsObject;
    static serializeBinaryToWriter(message: CacheSelector, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): CacheSelector;
    static deserializeBinaryFromReader(message: CacheSelector, reader: jspb.BinaryReader): CacheSelector;
  }

  export namespace CacheSelector {
    export type AsObject = {
      cacheName: string,
    }

    export enum KindCase { 
      KIND_NOT_SET = 0,
      CACHE_NAME = 1,
    }
  }


  export class CacheItemSelector extends jspb.Message {
    getKey(): Uint8Array | string;
    getKey_asU8(): Uint8Array;
    getKey_asB64(): string;
    setKey(value: Uint8Array | string): CacheItemSelector;

    getKeyPrefix(): Uint8Array | string;
    getKeyPrefix_asU8(): Uint8Array;
    getKeyPrefix_asB64(): string;
    setKeyPrefix(value: Uint8Array | string): CacheItemSelector;

    getKindCase(): CacheItemSelector.KindCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): CacheItemSelector.AsObject;
    static toObject(includeInstance: boolean, msg: CacheItemSelector): CacheItemSelector.AsObject;
    static serializeBinaryToWriter(message: CacheItemSelector, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): CacheItemSelector;
    static deserializeBinaryFromReader(message: CacheItemSelector, reader: jspb.BinaryReader): CacheItemSelector;
  }

  export namespace CacheItemSelector {
    export type AsObject = {
      key: Uint8Array | string,
      keyPrefix: Uint8Array | string,
    }

    export enum KindCase { 
      KIND_NOT_SET = 0,
      KEY = 1,
      KEY_PREFIX = 2,
    }
  }


  export class CachePermissions extends jspb.Message {
    getRole(): CacheRole;
    setRole(value: CacheRole): CachePermissions;

    getAllCaches(): PermissionsType.All | undefined;
    setAllCaches(value?: PermissionsType.All): CachePermissions;
    hasAllCaches(): boolean;
    clearAllCaches(): CachePermissions;

    getCacheSelector(): PermissionsType.CacheSelector | undefined;
    setCacheSelector(value?: PermissionsType.CacheSelector): CachePermissions;
    hasCacheSelector(): boolean;
    clearCacheSelector(): CachePermissions;

    getAllItems(): PermissionsType.All | undefined;
    setAllItems(value?: PermissionsType.All): CachePermissions;
    hasAllItems(): boolean;
    clearAllItems(): CachePermissions;

    getItemSelector(): PermissionsType.CacheItemSelector | undefined;
    setItemSelector(value?: PermissionsType.CacheItemSelector): CachePermissions;
    hasItemSelector(): boolean;
    clearItemSelector(): CachePermissions;

    getCacheCase(): CachePermissions.CacheCase;

    getCacheItemCase(): CachePermissions.CacheItemCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): CachePermissions.AsObject;
    static toObject(includeInstance: boolean, msg: CachePermissions): CachePermissions.AsObject;
    static serializeBinaryToWriter(message: CachePermissions, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): CachePermissions;
    static deserializeBinaryFromReader(message: CachePermissions, reader: jspb.BinaryReader): CachePermissions;
  }

  export namespace CachePermissions {
    export type AsObject = {
      role: CacheRole,
      allCaches?: PermissionsType.All.AsObject,
      cacheSelector?: PermissionsType.CacheSelector.AsObject,
      allItems?: PermissionsType.All.AsObject,
      itemSelector?: PermissionsType.CacheItemSelector.AsObject,
    }

    export enum CacheCase { 
      CACHE_NOT_SET = 0,
      ALL_CACHES = 2,
      CACHE_SELECTOR = 3,
    }

    export enum CacheItemCase { 
      CACHE_ITEM_NOT_SET = 0,
      ALL_ITEMS = 4,
      ITEM_SELECTOR = 5,
    }
  }


  export class TopicSelector extends jspb.Message {
    getTopicName(): string;
    setTopicName(value: string): TopicSelector;

    getTopicNamePrefix(): string;
    setTopicNamePrefix(value: string): TopicSelector;

    getKindCase(): TopicSelector.KindCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): TopicSelector.AsObject;
    static toObject(includeInstance: boolean, msg: TopicSelector): TopicSelector.AsObject;
    static serializeBinaryToWriter(message: TopicSelector, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): TopicSelector;
    static deserializeBinaryFromReader(message: TopicSelector, reader: jspb.BinaryReader): TopicSelector;
  }

  export namespace TopicSelector {
    export type AsObject = {
      topicName: string,
      topicNamePrefix: string,
    }

    export enum KindCase { 
      KIND_NOT_SET = 0,
      TOPIC_NAME = 1,
      TOPIC_NAME_PREFIX = 2,
    }
  }


  export class TopicPermissions extends jspb.Message {
    getRole(): TopicRole;
    setRole(value: TopicRole): TopicPermissions;

    getAllCaches(): PermissionsType.All | undefined;
    setAllCaches(value?: PermissionsType.All): TopicPermissions;
    hasAllCaches(): boolean;
    clearAllCaches(): TopicPermissions;

    getCacheSelector(): PermissionsType.CacheSelector | undefined;
    setCacheSelector(value?: PermissionsType.CacheSelector): TopicPermissions;
    hasCacheSelector(): boolean;
    clearCacheSelector(): TopicPermissions;

    getAllTopics(): PermissionsType.All | undefined;
    setAllTopics(value?: PermissionsType.All): TopicPermissions;
    hasAllTopics(): boolean;
    clearAllTopics(): TopicPermissions;

    getTopicSelector(): PermissionsType.TopicSelector | undefined;
    setTopicSelector(value?: PermissionsType.TopicSelector): TopicPermissions;
    hasTopicSelector(): boolean;
    clearTopicSelector(): TopicPermissions;

    getCacheCase(): TopicPermissions.CacheCase;

    getTopicCase(): TopicPermissions.TopicCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): TopicPermissions.AsObject;
    static toObject(includeInstance: boolean, msg: TopicPermissions): TopicPermissions.AsObject;
    static serializeBinaryToWriter(message: TopicPermissions, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): TopicPermissions;
    static deserializeBinaryFromReader(message: TopicPermissions, reader: jspb.BinaryReader): TopicPermissions;
  }

  export namespace TopicPermissions {
    export type AsObject = {
      role: TopicRole,
      allCaches?: PermissionsType.All.AsObject,
      cacheSelector?: PermissionsType.CacheSelector.AsObject,
      allTopics?: PermissionsType.All.AsObject,
      topicSelector?: PermissionsType.TopicSelector.AsObject,
    }

    export enum CacheCase { 
      CACHE_NOT_SET = 0,
      ALL_CACHES = 2,
      CACHE_SELECTOR = 3,
    }

    export enum TopicCase { 
      TOPIC_NOT_SET = 0,
      ALL_TOPICS = 4,
      TOPIC_SELECTOR = 5,
    }
  }


  export enum KindCase { 
    KIND_NOT_SET = 0,
    CACHE_PERMISSIONS = 1,
    TOPIC_PERMISSIONS = 2,
  }
}

export enum CacheRole { 
  CACHEPERMITNONE = 0,
  CACHEREADWRITE = 1,
  CACHEREADONLY = 2,
  CACHEWRITEONLY = 3,
}
export enum TopicRole { 
  TOPICPERMITNONE = 0,
  TOPICREADWRITE = 1,
  TOPICREADONLY = 2,
  TOPICWRITEONLY = 3,
}
export enum SuperUserPermissions { 
  SUPERUSER = 0,
}
