import * as jspb from 'google-protobuf'



export class All extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): All.AsObject;
  static toObject(includeInstance: boolean, msg: All): All.AsObject;
  static serializeBinaryToWriter(message: All, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): All;
  static deserializeBinaryFromReader(message: All, reader: jspb.BinaryReader): All;
}

export namespace All {
  export type AsObject = {
  }
}

export class CacheSelector extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): CacheSelector;

  getKindCase(): CacheSelector.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CacheSelector.AsObject;
  static toObject(includeInstance: boolean, msg: CacheSelector): CacheSelector.AsObject;
  static serializeBinaryToWriter(message: CacheSelector, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CacheSelector;
  static deserializeBinaryFromReader(message: CacheSelector, reader: jspb.BinaryReader): CacheSelector;
}

export namespace CacheSelector {
  export type AsObject = {
    cacheName: string,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    CACHE_NAME = 1,
  }
}

export class CacheItemSelector extends jspb.Message {
  getKey(): Uint8Array | string;
  getKey_asU8(): Uint8Array;
  getKey_asB64(): string;
  setKey(value: Uint8Array | string): CacheItemSelector;

  getKeyPrefix(): Uint8Array | string;
  getKeyPrefix_asU8(): Uint8Array;
  getKeyPrefix_asB64(): string;
  setKeyPrefix(value: Uint8Array | string): CacheItemSelector;

  getKindCase(): CacheItemSelector.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CacheItemSelector.AsObject;
  static toObject(includeInstance: boolean, msg: CacheItemSelector): CacheItemSelector.AsObject;
  static serializeBinaryToWriter(message: CacheItemSelector, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CacheItemSelector;
  static deserializeBinaryFromReader(message: CacheItemSelector, reader: jspb.BinaryReader): CacheItemSelector;
}

export namespace CacheItemSelector {
  export type AsObject = {
    key: Uint8Array | string,
    keyPrefix: Uint8Array | string,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    KEY = 1,
    KEY_PREFIX = 2,
  }
}

export class TopicSelector extends jspb.Message {
  getTopicName(): string;
  setTopicName(value: string): TopicSelector;

  getTopicNamePrefix(): string;
  setTopicNamePrefix(value: string): TopicSelector;

  getKindCase(): TopicSelector.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TopicSelector.AsObject;
  static toObject(includeInstance: boolean, msg: TopicSelector): TopicSelector.AsObject;
  static serializeBinaryToWriter(message: TopicSelector, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TopicSelector;
  static deserializeBinaryFromReader(message: TopicSelector, reader: jspb.BinaryReader): TopicSelector;
}

export namespace TopicSelector {
  export type AsObject = {
    topicName: string,
    topicNamePrefix: string,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    TOPIC_NAME = 1,
    TOPIC_NAME_PREFIX = 2,
  }
}

export class PermissionSet extends jspb.Message {
  getSuperUser(): SuperUserPermissions;
  setSuperUser(value: SuperUserPermissions): PermissionSet;

  getExplicit(): ExplicitPermissions | undefined;
  setExplicit(value?: ExplicitPermissions): PermissionSet;
  hasExplicit(): boolean;
  clearExplicit(): PermissionSet;

  getKindCase(): PermissionSet.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PermissionSet.AsObject;
  static toObject(includeInstance: boolean, msg: PermissionSet): PermissionSet.AsObject;
  static serializeBinaryToWriter(message: PermissionSet, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PermissionSet;
  static deserializeBinaryFromReader(message: PermissionSet, reader: jspb.BinaryReader): PermissionSet;
}

export namespace PermissionSet {
  export type AsObject = {
    superUser: SuperUserPermissions,
    explicit?: ExplicitPermissions.AsObject,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    SUPER_USER = 1,
    EXPLICIT = 2,
  }
}

export class ExplicitPermissions extends jspb.Message {
  getRulesList(): Array<Rule>;
  setRulesList(value: Array<Rule>): ExplicitPermissions;
  clearRulesList(): ExplicitPermissions;
  addRules(value?: Rule, index?: number): Rule;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ExplicitPermissions.AsObject;
  static toObject(includeInstance: boolean, msg: ExplicitPermissions): ExplicitPermissions.AsObject;
  static serializeBinaryToWriter(message: ExplicitPermissions, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ExplicitPermissions;
  static deserializeBinaryFromReader(message: ExplicitPermissions, reader: jspb.BinaryReader): ExplicitPermissions;
}

export namespace ExplicitPermissions {
  export type AsObject = {
    rulesList: Array<Rule.AsObject>,
  }
}

export class Rule extends jspb.Message {
  getAccountManagementRule(): Rule.AccountManagementRule | undefined;
  setAccountManagementRule(value?: Rule.AccountManagementRule): Rule;
  hasAccountManagementRule(): boolean;
  clearAccountManagementRule(): Rule;

  getAuthManagementRule(): Rule.AuthManagementRule | undefined;
  setAuthManagementRule(value?: Rule.AuthManagementRule): Rule;
  hasAuthManagementRule(): boolean;
  clearAuthManagementRule(): Rule;

  getResourceManagementRule(): Rule.ResourceManagementRule | undefined;
  setResourceManagementRule(value?: Rule.ResourceManagementRule): Rule;
  hasResourceManagementRule(): boolean;
  clearResourceManagementRule(): Rule;

  getCacheRule(): Rule.CacheRule | undefined;
  setCacheRule(value?: Rule.CacheRule): Rule;
  hasCacheRule(): boolean;
  clearCacheRule(): Rule;

  getTopicRule(): Rule.TopicRule | undefined;
  setTopicRule(value?: Rule.TopicRule): Rule;
  hasTopicRule(): boolean;
  clearTopicRule(): Rule;

  getKindCase(): Rule.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Rule.AsObject;
  static toObject(includeInstance: boolean, msg: Rule): Rule.AsObject;
  static serializeBinaryToWriter(message: Rule, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Rule;
  static deserializeBinaryFromReader(message: Rule, reader: jspb.BinaryReader): Rule;
}

export namespace Rule {
  export type AsObject = {
    accountManagementRule?: Rule.AccountManagementRule.AsObject,
    authManagementRule?: Rule.AuthManagementRule.AsObject,
    resourceManagementRule?: Rule.ResourceManagementRule.AsObject,
    cacheRule?: Rule.CacheRule.AsObject,
    topicRule?: Rule.TopicRule.AsObject,
  }

  export class AccountManagementRule extends jspb.Message {
    getPermissionsList(): Array<AccountManagementPermissions>;
    setPermissionsList(value: Array<AccountManagementPermissions>): AccountManagementRule;
    clearPermissionsList(): AccountManagementRule;
    addPermissions(value: AccountManagementPermissions, index?: number): AccountManagementRule;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): AccountManagementRule.AsObject;
    static toObject(includeInstance: boolean, msg: AccountManagementRule): AccountManagementRule.AsObject;
    static serializeBinaryToWriter(message: AccountManagementRule, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): AccountManagementRule;
    static deserializeBinaryFromReader(message: AccountManagementRule, reader: jspb.BinaryReader): AccountManagementRule;
  }

  export namespace AccountManagementRule {
    export type AsObject = {
      permissionsList: Array<AccountManagementPermissions>,
    }
  }


  export class AuthManagementRule extends jspb.Message {
    getPermissionsList(): Array<AuthManagementPermissions>;
    setPermissionsList(value: Array<AuthManagementPermissions>): AuthManagementRule;
    clearPermissionsList(): AuthManagementRule;
    addPermissions(value: AuthManagementPermissions, index?: number): AuthManagementRule;

    getAllItems(): All | undefined;
    setAllItems(value?: All): AuthManagementRule;
    hasAllItems(): boolean;
    clearAllItems(): AuthManagementRule;

    getAuthItemsCase(): AuthManagementRule.AuthItemsCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): AuthManagementRule.AsObject;
    static toObject(includeInstance: boolean, msg: AuthManagementRule): AuthManagementRule.AsObject;
    static serializeBinaryToWriter(message: AuthManagementRule, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): AuthManagementRule;
    static deserializeBinaryFromReader(message: AuthManagementRule, reader: jspb.BinaryReader): AuthManagementRule;
  }

  export namespace AuthManagementRule {
    export type AsObject = {
      permissionsList: Array<AuthManagementPermissions>,
      allItems?: All.AsObject,
    }

    export enum AuthItemsCase { 
      AUTH_ITEMS_NOT_SET = 0,
      ALL_ITEMS = 2,
    }
  }


  export class ResourceManagementRule extends jspb.Message {
    getPermissionsList(): Array<ResourceManagementPermissions>;
    setPermissionsList(value: Array<ResourceManagementPermissions>): ResourceManagementRule;
    clearPermissionsList(): ResourceManagementRule;
    addPermissions(value: ResourceManagementPermissions, index?: number): ResourceManagementRule;

    getAllResources(): All | undefined;
    setAllResources(value?: All): ResourceManagementRule;
    hasAllResources(): boolean;
    clearAllResources(): ResourceManagementRule;

    getResourcesCase(): ResourceManagementRule.ResourcesCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): ResourceManagementRule.AsObject;
    static toObject(includeInstance: boolean, msg: ResourceManagementRule): ResourceManagementRule.AsObject;
    static serializeBinaryToWriter(message: ResourceManagementRule, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): ResourceManagementRule;
    static deserializeBinaryFromReader(message: ResourceManagementRule, reader: jspb.BinaryReader): ResourceManagementRule;
  }

  export namespace ResourceManagementRule {
    export type AsObject = {
      permissionsList: Array<ResourceManagementPermissions>,
      allResources?: All.AsObject,
    }

    export enum ResourcesCase { 
      RESOURCES_NOT_SET = 0,
      ALL_RESOURCES = 2,
    }
  }


  export class CacheRule extends jspb.Message {
    getPermissionsList(): Array<CacheAPIPermissions>;
    setPermissionsList(value: Array<CacheAPIPermissions>): CacheRule;
    clearPermissionsList(): CacheRule;
    addPermissions(value: CacheAPIPermissions, index?: number): CacheRule;

    getAllCaches(): All | undefined;
    setAllCaches(value?: All): CacheRule;
    hasAllCaches(): boolean;
    clearAllCaches(): CacheRule;

    getCacheSelector(): CacheSelector | undefined;
    setCacheSelector(value?: CacheSelector): CacheRule;
    hasCacheSelector(): boolean;
    clearCacheSelector(): CacheRule;

    getAllItems(): All | undefined;
    setAllItems(value?: All): CacheRule;
    hasAllItems(): boolean;
    clearAllItems(): CacheRule;

    getItemSelector(): CacheItemSelector | undefined;
    setItemSelector(value?: CacheItemSelector): CacheRule;
    hasItemSelector(): boolean;
    clearItemSelector(): CacheRule;

    getCacheCase(): CacheRule.CacheCase;

    getCacheItemCase(): CacheRule.CacheItemCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): CacheRule.AsObject;
    static toObject(includeInstance: boolean, msg: CacheRule): CacheRule.AsObject;
    static serializeBinaryToWriter(message: CacheRule, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): CacheRule;
    static deserializeBinaryFromReader(message: CacheRule, reader: jspb.BinaryReader): CacheRule;
  }

  export namespace CacheRule {
    export type AsObject = {
      permissionsList: Array<CacheAPIPermissions>,
      allCaches?: All.AsObject,
      cacheSelector?: CacheSelector.AsObject,
      allItems?: All.AsObject,
      itemSelector?: CacheItemSelector.AsObject,
    }

    export enum CacheCase { 
      CACHE_NOT_SET = 0,
      ALL_CACHES = 2,
      CACHE_SELECTOR = 3,
    }

    export enum CacheItemCase { 
      CACHE_ITEM_NOT_SET = 0,
      ALL_ITEMS = 4,
      ITEM_SELECTOR = 5,
    }
  }


  export class TopicRule extends jspb.Message {
    getPermissionsList(): Array<TopicAPIPermissions>;
    setPermissionsList(value: Array<TopicAPIPermissions>): TopicRule;
    clearPermissionsList(): TopicRule;
    addPermissions(value: TopicAPIPermissions, index?: number): TopicRule;

    getAllCaches(): All | undefined;
    setAllCaches(value?: All): TopicRule;
    hasAllCaches(): boolean;
    clearAllCaches(): TopicRule;

    getCacheSelector(): CacheSelector | undefined;
    setCacheSelector(value?: CacheSelector): TopicRule;
    hasCacheSelector(): boolean;
    clearCacheSelector(): TopicRule;

    getAllTopics(): All | undefined;
    setAllTopics(value?: All): TopicRule;
    hasAllTopics(): boolean;
    clearAllTopics(): TopicRule;

    getTopicSelector(): TopicSelector | undefined;
    setTopicSelector(value?: TopicSelector): TopicRule;
    hasTopicSelector(): boolean;
    clearTopicSelector(): TopicRule;

    getCacheCase(): TopicRule.CacheCase;

    getTopicCase(): TopicRule.TopicCase;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): TopicRule.AsObject;
    static toObject(includeInstance: boolean, msg: TopicRule): TopicRule.AsObject;
    static serializeBinaryToWriter(message: TopicRule, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): TopicRule;
    static deserializeBinaryFromReader(message: TopicRule, reader: jspb.BinaryReader): TopicRule;
  }

  export namespace TopicRule {
    export type AsObject = {
      permissionsList: Array<TopicAPIPermissions>,
      allCaches?: All.AsObject,
      cacheSelector?: CacheSelector.AsObject,
      allTopics?: All.AsObject,
      topicSelector?: TopicSelector.AsObject,
    }

    export enum CacheCase { 
      CACHE_NOT_SET = 0,
      ALL_CACHES = 2,
      CACHE_SELECTOR = 3,
    }

    export enum TopicCase { 
      TOPIC_NOT_SET = 0,
      ALL_TOPICS = 4,
      TOPIC_SELECTOR = 5,
    }
  }


  export enum KindCase { 
    KIND_NOT_SET = 0,
    ACCOUNT_MANAGEMENT_RULE = 1,
    AUTH_MANAGEMENT_RULE = 2,
    RESOURCE_MANAGEMENT_RULE = 3,
    CACHE_RULE = 4,
    TOPIC_RULE = 5,
  }
}

export enum AccountManagementPermissions { 
  ACCOUNTREAD = 0,
  ACCOUNTWRITE = 1,
  ACCOUNTLIST = 2,
}
export enum AuthManagementPermissions { 
  AUTHREAD = 0,
  AUTHWRITE = 1,
  AUTHLIST = 2,
}
export enum ResourceManagementPermissions { 
  RESOURCEREAD = 0,
  RESOURCEWRITE = 1,
  RESOURCELIST = 2,
}
export enum CacheAPIPermissions { 
  CACHELIST = 0,
  CACHEREAD = 1,
  CACHEWRITE = 2,
}
export enum TopicAPIPermissions { 
  TOPICLIST = 0,
  TOPICREAD = 1,
  TOPICWRITE = 2,
}
export enum SuperUserPermissions { 
  SUPERUSER = 0,
}
