import * as jspb from 'google-protobuf'



export class _WebhookId extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): _WebhookId;

  getWebhookName(): string;
  setWebhookName(value: string): _WebhookId;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _WebhookId.AsObject;
  static toObject(includeInstance: boolean, msg: _WebhookId): _WebhookId.AsObject;
  static serializeBinaryToWriter(message: _WebhookId, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _WebhookId;
  static deserializeBinaryFromReader(message: _WebhookId, reader: jspb.BinaryReader): _WebhookId;
}

export namespace _WebhookId {
  export type AsObject = {
    cacheName: string,
    webhookName: string,
  }
}

export class _Webhook extends jspb.Message {
  getWebhookId(): _WebhookId | undefined;
  setWebhookId(value?: _WebhookId): _Webhook;
  hasWebhookId(): boolean;
  clearWebhookId(): _Webhook;

  getTopicName(): string;
  setTopicName(value: string): _Webhook;

  getDestination(): _WebhookDestination | undefined;
  setDestination(value?: _WebhookDestination): _Webhook;
  hasDestination(): boolean;
  clearDestination(): _Webhook;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _Webhook.AsObject;
  static toObject(includeInstance: boolean, msg: _Webhook): _Webhook.AsObject;
  static serializeBinaryToWriter(message: _Webhook, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _Webhook;
  static deserializeBinaryFromReader(message: _Webhook, reader: jspb.BinaryReader): _Webhook;
}

export namespace _Webhook {
  export type AsObject = {
    webhookId?: _WebhookId.AsObject,
    topicName: string,
    destination?: _WebhookDestination.AsObject,
  }
}

export class _PutWebhookRequest extends jspb.Message {
  getWebhook(): _Webhook | undefined;
  setWebhook(value?: _Webhook): _PutWebhookRequest;
  hasWebhook(): boolean;
  clearWebhook(): _PutWebhookRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _PutWebhookRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _PutWebhookRequest): _PutWebhookRequest.AsObject;
  static serializeBinaryToWriter(message: _PutWebhookRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _PutWebhookRequest;
  static deserializeBinaryFromReader(message: _PutWebhookRequest, reader: jspb.BinaryReader): _PutWebhookRequest;
}

export namespace _PutWebhookRequest {
  export type AsObject = {
    webhook?: _Webhook.AsObject,
  }
}

export class _PutWebhookResponse extends jspb.Message {
  getSecretString(): string;
  setSecretString(value: string): _PutWebhookResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _PutWebhookResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _PutWebhookResponse): _PutWebhookResponse.AsObject;
  static serializeBinaryToWriter(message: _PutWebhookResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _PutWebhookResponse;
  static deserializeBinaryFromReader(message: _PutWebhookResponse, reader: jspb.BinaryReader): _PutWebhookResponse;
}

export namespace _PutWebhookResponse {
  export type AsObject = {
    secretString: string,
  }
}

export class _DeleteWebhookRequest extends jspb.Message {
  getWebhookId(): _WebhookId | undefined;
  setWebhookId(value?: _WebhookId): _DeleteWebhookRequest;
  hasWebhookId(): boolean;
  clearWebhookId(): _DeleteWebhookRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DeleteWebhookRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _DeleteWebhookRequest): _DeleteWebhookRequest.AsObject;
  static serializeBinaryToWriter(message: _DeleteWebhookRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DeleteWebhookRequest;
  static deserializeBinaryFromReader(message: _DeleteWebhookRequest, reader: jspb.BinaryReader): _DeleteWebhookRequest;
}

export namespace _DeleteWebhookRequest {
  export type AsObject = {
    webhookId?: _WebhookId.AsObject,
  }
}

export class _DeleteWebhookResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _DeleteWebhookResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _DeleteWebhookResponse): _DeleteWebhookResponse.AsObject;
  static serializeBinaryToWriter(message: _DeleteWebhookResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _DeleteWebhookResponse;
  static deserializeBinaryFromReader(message: _DeleteWebhookResponse, reader: jspb.BinaryReader): _DeleteWebhookResponse;
}

export namespace _DeleteWebhookResponse {
  export type AsObject = {
  }
}

export class _ListWebhookRequest extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): _ListWebhookRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListWebhookRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _ListWebhookRequest): _ListWebhookRequest.AsObject;
  static serializeBinaryToWriter(message: _ListWebhookRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListWebhookRequest;
  static deserializeBinaryFromReader(message: _ListWebhookRequest, reader: jspb.BinaryReader): _ListWebhookRequest;
}

export namespace _ListWebhookRequest {
  export type AsObject = {
    cacheName: string,
  }
}

export class _ListWebhooksResponse extends jspb.Message {
  getWebhookList(): Array<_Webhook>;
  setWebhookList(value: Array<_Webhook>): _ListWebhooksResponse;
  clearWebhookList(): _ListWebhooksResponse;
  addWebhook(value?: _Webhook, index?: number): _Webhook;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _ListWebhooksResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _ListWebhooksResponse): _ListWebhooksResponse.AsObject;
  static serializeBinaryToWriter(message: _ListWebhooksResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _ListWebhooksResponse;
  static deserializeBinaryFromReader(message: _ListWebhooksResponse, reader: jspb.BinaryReader): _ListWebhooksResponse;
}

export namespace _ListWebhooksResponse {
  export type AsObject = {
    webhookList: Array<_Webhook.AsObject>,
  }
}

export class _GetWebhookSecretRequest extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): _GetWebhookSecretRequest;

  getWebhookName(): string;
  setWebhookName(value: string): _GetWebhookSecretRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetWebhookSecretRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _GetWebhookSecretRequest): _GetWebhookSecretRequest.AsObject;
  static serializeBinaryToWriter(message: _GetWebhookSecretRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetWebhookSecretRequest;
  static deserializeBinaryFromReader(message: _GetWebhookSecretRequest, reader: jspb.BinaryReader): _GetWebhookSecretRequest;
}

export namespace _GetWebhookSecretRequest {
  export type AsObject = {
    cacheName: string,
    webhookName: string,
  }
}

export class _GetWebhookSecretResponse extends jspb.Message {
  getCacheName(): string;
  setCacheName(value: string): _GetWebhookSecretResponse;

  getWebhookName(): string;
  setWebhookName(value: string): _GetWebhookSecretResponse;

  getSecretString(): string;
  setSecretString(value: string): _GetWebhookSecretResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _GetWebhookSecretResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _GetWebhookSecretResponse): _GetWebhookSecretResponse.AsObject;
  static serializeBinaryToWriter(message: _GetWebhookSecretResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _GetWebhookSecretResponse;
  static deserializeBinaryFromReader(message: _GetWebhookSecretResponse, reader: jspb.BinaryReader): _GetWebhookSecretResponse;
}

export namespace _GetWebhookSecretResponse {
  export type AsObject = {
    cacheName: string,
    webhookName: string,
    secretString: string,
  }
}

export class _WebhookDestination extends jspb.Message {
  getPostUrl(): string;
  setPostUrl(value: string): _WebhookDestination;

  getKindCase(): _WebhookDestination.KindCase;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _WebhookDestination.AsObject;
  static toObject(includeInstance: boolean, msg: _WebhookDestination): _WebhookDestination.AsObject;
  static serializeBinaryToWriter(message: _WebhookDestination, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _WebhookDestination;
  static deserializeBinaryFromReader(message: _WebhookDestination, reader: jspb.BinaryReader): _WebhookDestination;
}

export namespace _WebhookDestination {
  export type AsObject = {
    postUrl: string,
  }

  export enum KindCase { 
    KIND_NOT_SET = 0,
    POST_URL = 1,
  }
}

export class _RotateWebhookSecretRequest extends jspb.Message {
  getWebhookId(): _WebhookId | undefined;
  setWebhookId(value?: _WebhookId): _RotateWebhookSecretRequest;
  hasWebhookId(): boolean;
  clearWebhookId(): _RotateWebhookSecretRequest;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RotateWebhookSecretRequest.AsObject;
  static toObject(includeInstance: boolean, msg: _RotateWebhookSecretRequest): _RotateWebhookSecretRequest.AsObject;
  static serializeBinaryToWriter(message: _RotateWebhookSecretRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RotateWebhookSecretRequest;
  static deserializeBinaryFromReader(message: _RotateWebhookSecretRequest, reader: jspb.BinaryReader): _RotateWebhookSecretRequest;
}

export namespace _RotateWebhookSecretRequest {
  export type AsObject = {
    webhookId?: _WebhookId.AsObject,
  }
}

export class _RotateWebhookSecretResponse extends jspb.Message {
  getSecretString(): string;
  setSecretString(value: string): _RotateWebhookSecretResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): _RotateWebhookSecretResponse.AsObject;
  static toObject(includeInstance: boolean, msg: _RotateWebhookSecretResponse): _RotateWebhookSecretResponse.AsObject;
  static serializeBinaryToWriter(message: _RotateWebhookSecretResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): _RotateWebhookSecretResponse;
  static deserializeBinaryFromReader(message: _RotateWebhookSecretResponse, reader: jspb.BinaryReader): _RotateWebhookSecretResponse;
}

export namespace _RotateWebhookSecretResponse {
  export type AsObject = {
    secretString: string,
  }
}

